/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         smiparse
#define yylex           smilex
#define yyerror         smierror
#define yydebug         smidebug
#define yynerrs         sminerrs

/* First part of user prologue.  */
#line 17 "parser-smi.y"


#include <config.h>
    
#ifdef BACKEND_SMI

#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <limits.h>

#if defined(_MSC_VER)
#include <malloc.h>
#endif

#include "smi.h"
#include "error.h"
#include "parser-smi.h"
#include "scanner-smi.h"
#include "data.h"
#include "check.h"
#include "util.h"
    
#ifdef HAVE_DMALLOC_H
#include <dmalloc.h>
#endif



#define thisParserPtr      ((Parser *)parserPtr)
#define thisModulePtr     (((Parser *)parserPtr)->modulePtr)


    
/*
 * NOTE: The argument lvalp is not really a void pointer. Unfortunately,
 * we don't know it better at this point. bison generated C code declares
 * YYSTYPE just a few lines below based on the `%union' declaration.
 */
extern int yylex(void *lvalp, Parser *parserPtr);



static int	   impliedFlag;
static SmiNodekind variationkind;
static SmiBasetype defaultBasetype;
static int	   indexFlag;

/*
 * Values for the indexFlag variable
 */
#define INDEXFLAG_NONE     0
#define INDEXFLAG_PIBINDEX 1
#define INDEXFLAG_AUGMENTS 2
#define INDEXFLAG_EXTENDS  3
 

#define SMI_EPOCH	631152000	/* 01 Jan 1990 00:00:00 */ 

 

static char *convertImportv2[] = {
    "RFC1155-SMI", "internet",	    "SNMPv2-SMI", "internet",
    "RFC1155-SMI", "directory",	    "SNMPv2-SMI", "directory",
    "RFC1155-SMI", "mgmt",	    "SNMPv2-SMI", "mgmt",
    "RFC1155-SMI", "experimental",  "SNMPv2-SMI", "experimental",
    "RFC1155-SMI", "private",	    "SNMPv2-SMI", "private",
    "RFC1155-SMI", "enterprises",   "SNMPv2-SMI", "enterprises",
    "RFC1155-SMI", "IpAddress",     "SNMPv2-SMI", "IpAddress",
    "RFC1155-SMI", "Counter",       "SNMPv2-SMI", "Counter32",
    "RFC1155-SMI", "Gauge",         "SNMPv2-SMI", "Gauge32",
    "RFC1155-SMI", "TimeTicks",     "SNMPv2-SMI", "TimeTicks",
    "RFC1155-SMI", "Opaque",        "SNMPv2-SMI", "Opaque",
    "RFC1065-SMI", "internet",	    "SNMPv2-SMI", "internet",
    "RFC1065-SMI", "directory",	    "SNMPv2-SMI", "directory",
    "RFC1065-SMI", "mgmt",	    "SNMPv2-SMI", "mgmt",
    "RFC1065-SMI", "experimental",  "SNMPv2-SMI", "experimental",
    "RFC1065-SMI", "private",	    "SNMPv2-SMI", "private",
    "RFC1065-SMI", "enterprises",   "SNMPv2-SMI", "enterprises",
    "RFC1065-SMI", "IpAddress",     "SNMPv2-SMI", "IpAddress",
    "RFC1065-SMI", "Counter",       "SNMPv2-SMI", "Counter32",
    "RFC1065-SMI", "Gauge",         "SNMPv2-SMI", "Gauge32",
    "RFC1065-SMI", "TimeTicks",     "SNMPv2-SMI", "TimeTicks",
    "RFC1065-SMI", "Opaque",        "SNMPv2-SMI", "Opaque",
    "RFC1213-MIB", "mib-2",         "SNMPv2-SMI", "mib-2",    
    "RFC1213-MIB", "DisplayString", "SNMPv2-TC",  "DisplayString",    
    NULL, NULL, NULL, NULL
};



static void
checkDescr(Parser *parser, char *descr)
{
    if (descr) {
	if (descr[0] == 0) {
	    smiPrintError(parser, ERR_EMPTY_DESCRIPTION);
	}
	/* we might want to add more checks since I have recently
	   seen things like DESCRIPTION "." to cirumvent warnings */
    }
}
 

 
static void
checkNameLen(Parser *parser, char *name, int error_32, int error_64)
{
    int len = strlen(name);
    
    if (len > 64) {
	smiPrintError(parser, error_64, name);
    } else if (len > 32) {
	smiPrintError(parser, error_32, name);
    }
}


 
static void
checkModuleName(Parser *parserPtr, Module *modulePtr)
{
     static char *mib_ignore[] = {
	 "SNMPv2-SMI", "SNMPv2-TC", "SNMPv2-CONF", NULL
     };
     
     static char *pib_ignore[] = {
	 "COPS-PR-SPPI", "COPS-PR-SPPI-TC",
	 "SNMPv2-SMI", "SNMPv2-TC", "SNMPv2-CONF", NULL
     };

     const char *name = thisModulePtr->export.name;
     const int len = strlen(name);
     int i;

     switch (modulePtr->export.language) {
     case SMI_LANGUAGE_SMIV1:
     case SMI_LANGUAGE_SMIV2:
     case SMI_LANGUAGE_SMING:
	 for (i = 0; mib_ignore[i]; i++) {
	     if (strcmp(mib_ignore[i], name) == 0) {
		 return;
	     }
	 }
	 if (len > 3 && (strcmp(name + len - 4, "-MIB") != 0)) {
	     smiPrintError(parserPtr, ERR_MIB_MODULENAME_SUFFIX, name);
	     return;
	 }
	 break;
     case SMI_LANGUAGE_SPPI:
	 for (i = 0; pib_ignore[i]; i++) {
	     if (strcmp(pib_ignore[i], name) == 0) {
		 return;
	     }
	 }
	 if (len > 3 && (strcmp(name + len - 4, "-PIB") != 0)) {
	     smiPrintError(parserPtr, ERR_PIB_MODULENAME_SUFFIX, name);
	 }
	 break;
     case SMI_LANGUAGE_UNKNOWN:
	 break;
     }
}



static void
checkModuleIdentity(Parser *parserPtr, Module *modulePtr)
{
    if ((modulePtr->export.language == SMI_LANGUAGE_SMIV2)
	&& (modulePtr->numModuleIdentities < 1)
	&& strcmp(modulePtr->export.name, "SNMPv2-SMI")
	&& strcmp(modulePtr->export.name, "SNMPv2-CONF")
	&& strcmp(modulePtr->export.name, "SNMPv2-TC")
        && strcmp(modulePtr->export.name, "COPS-PR-SPPI")) {
	smiPrintError(parserPtr, ERR_NO_MODULE_IDENTITY);
    }
}



static void
checkObjects(Parser *parserPtr, Module *modulePtr)
{
    Object *objectPtr;
    Node *nodePtr;
    int i;
    Type *counterTypePtr, *counter32TypePtr, *counter64TypePtr;
    
    counterTypePtr = findTypeByName("Counter");
    counter32TypePtr = findTypeByModulenameAndName("SNMPv2-SMI", "Counter32");
    counter64TypePtr = findTypeByModulenameAndName("SNMPv2-SMI", "Counter64");
    
    for (objectPtr = modulePtr->firstObjectPtr;
	 objectPtr; objectPtr = objectPtr->nextPtr) {

	Object *parentPtr;
	
	if ((objectPtr->export.decl != SMI_DECL_UNKNOWN) &&
	    objectPtr->nodePtr->parentPtr &&
	    objectPtr->nodePtr->parentPtr->lastObjectPtr) {
	    parentPtr = objectPtr->nodePtr->parentPtr->lastObjectPtr;
	} else {
	    parentPtr = NULL;
	}

	/*
	 * Set nodekinds of all newly defined objects.
	 */
	
	if (objectPtr->export.decl == SMI_DECL_MODULEIDENTITY) {
	    objectPtr->export.nodekind = SMI_NODEKIND_NODE;
	} else if ((objectPtr->export.decl == SMI_DECL_VALUEASSIGNMENT) ||
		   (objectPtr->export.decl == SMI_DECL_OBJECTIDENTITY)) {
	    objectPtr->export.nodekind = SMI_NODEKIND_NODE;
	} else if ((objectPtr->export.decl == SMI_DECL_OBJECTTYPE) &&
		   (objectPtr->typePtr) &&
		   (objectPtr->typePtr->export.decl == SMI_DECL_IMPL_SEQUENCEOF)) {
	    objectPtr->export.nodekind = SMI_NODEKIND_TABLE;
	} else if ((objectPtr->export.decl == SMI_DECL_OBJECTTYPE) &&
		   (objectPtr->export.indexkind != SMI_INDEX_UNKNOWN)) {
	    objectPtr->export.nodekind = SMI_NODEKIND_ROW;
	} else if ((objectPtr->export.decl == SMI_DECL_NOTIFICATIONTYPE) ||
		   (objectPtr->export.decl == SMI_DECL_TRAPTYPE)) {
	    objectPtr->export.nodekind = SMI_NODEKIND_NOTIFICATION;
	} else if ((objectPtr->export.decl == SMI_DECL_OBJECTGROUP) ||
		   (objectPtr->export.decl == SMI_DECL_NOTIFICATIONGROUP)) {
	    objectPtr->export.nodekind = SMI_NODEKIND_GROUP;
	} else if (objectPtr->export.decl == SMI_DECL_MODULECOMPLIANCE) {
	    objectPtr->export.nodekind = SMI_NODEKIND_COMPLIANCE;
	} else if (objectPtr->export.decl == SMI_DECL_AGENTCAPABILITIES) {
	    objectPtr->export.nodekind = SMI_NODEKIND_CAPABILITIES;
	} else if ((objectPtr->export.decl == SMI_DECL_OBJECTTYPE) &&
		   (parentPtr) &&
		   (parentPtr->export.indexkind != SMI_INDEX_UNKNOWN)) {
	    objectPtr->export.nodekind = SMI_NODEKIND_COLUMN;
	} else if ((objectPtr->export.decl == SMI_DECL_OBJECTTYPE) &&
		   (parentPtr) &&
		   (parentPtr->export.indexkind == SMI_INDEX_UNKNOWN)) {
	    objectPtr->export.nodekind = SMI_NODEKIND_SCALAR;
	}
    }

    for (objectPtr = modulePtr->firstObjectPtr;
	 objectPtr; objectPtr = objectPtr->nextPtr) {

	Object *parentPtr;
	
	if (objectPtr->nodePtr->parentPtr &&
	    objectPtr->nodePtr->parentPtr->lastObjectPtr) {
	    parentPtr = objectPtr->nodePtr->parentPtr->lastObjectPtr;
	} else {
	    parentPtr = NULL;
	}

	/*
	 * Check whether the associated type resolves to a known base type.
	 */
	
	if (objectPtr->typePtr
	    && (objectPtr->export.nodekind == SMI_NODEKIND_COLUMN
		|| objectPtr->export.nodekind == SMI_NODEKIND_SCALAR)
	    && objectPtr->typePtr->export.basetype == SMI_BASETYPE_UNKNOWN) {
	    smiPrintErrorAtLine(parserPtr, ERR_BASETYPE_UNKNOWN,
				objectPtr->line,
				objectPtr->typePtr->export.name ?
				objectPtr->typePtr->export.name : "[unknown]",
				objectPtr->export.name);
	    if (objectPtr->nodePtr->parentPtr->firstObjectPtr->export.nodekind
		== SMI_NODEKIND_TABLE) {
		/* the parent node is a table node, so assume this is
		 *  a row node. this adjusts missing INDEXs in RFC 1158.
		 */
		objectPtr->export.nodekind = SMI_NODEKIND_ROW;
	    }
	}

	/*
	 * Mark types that are referenced in this module.
	 */

	if (objectPtr->typePtr
	    && (objectPtr->export.nodekind == SMI_NODEKIND_COLUMN
		|| objectPtr->export.nodekind == SMI_NODEKIND_SCALAR)
	    && (objectPtr->typePtr->export.decl == SMI_DECL_TYPEDEF
		|| objectPtr->typePtr->export.decl == SMI_DECL_TEXTUALCONVENTION
		|| objectPtr->typePtr->export.decl == SMI_DECL_IMPLICIT_TYPE)) {
	    addTypeFlags(objectPtr->typePtr, FLAG_INSYNTAX);
	    if (objectPtr->typePtr->export.decl == SMI_DECL_IMPLICIT_TYPE) {
		addTypeFlags(objectPtr->typePtr->parentPtr, FLAG_INSYNTAX);
	    }
	}
	
	/*
	 * Check whether the status of the associated type matches the
	 * status of the object.
	 */

	if (objectPtr->typePtr
	    && (objectPtr->export.nodekind == SMI_NODEKIND_COLUMN
		|| objectPtr->export.nodekind == SMI_NODEKIND_SCALAR)
	    && (objectPtr->export.status < objectPtr->typePtr->export.status)) {
	    if (objectPtr->typePtr->export.status == SMI_STATUS_DEPRECATED) {
		smiPrintErrorAtLine(parserPtr, ERR_TYPE_STATUS_DEPRECATED,
				    objectPtr->line,
				    objectPtr->typePtr->export.name,
				    objectPtr->export.name);
	    }
	    if (objectPtr->typePtr->export.status == SMI_STATUS_OBSOLETE) {
		smiPrintErrorAtLine(parserPtr, ERR_TYPE_STATUS_OBSOLETE,
				    objectPtr->line,
				    objectPtr->typePtr->export.name,
				    objectPtr->export.name);
	    }
	}

	/*
	 * Check the nodekind of the parent node.
	 */

	if (parentPtr) {
	    switch (objectPtr->export.nodekind) {
	    case SMI_NODEKIND_COLUMN:
		if (parentPtr->export.nodekind != SMI_NODEKIND_ROW) {
		    smiPrintErrorAtLine(parserPtr, ERR_COLUMN_PARENT_TYPE,
					objectPtr->line, objectPtr->export.name);
		}
		break;
	    case SMI_NODEKIND_ROW:
		if (parentPtr->export.nodekind != SMI_NODEKIND_TABLE) {
		    smiPrintErrorAtLine(parserPtr, ERR_ROW_PARENT_TYPE,
					objectPtr->line, objectPtr->export.name);
		}
		if (parentPtr->typePtr && parentPtr->typePtr->parentPtr &&
		    strcmp(parentPtr->typePtr->parentPtr->export.name,
			   objectPtr->typePtr->export.name)) {
		    smiPrintErrorAtLine(parserPtr, ERR_TABLE_ROW_TYPE_MISMATCH,
					objectPtr->line,
					objectPtr->export.name);
		}
		break;
	    case SMI_NODEKIND_TABLE:
		if ((parentPtr->export.nodekind != SMI_NODEKIND_UNKNOWN) &&
		    (parentPtr->export.nodekind != SMI_NODEKIND_NODE)) {
		    smiPrintErrorAtLine(parserPtr, ERR_TABLE_PARENT_TYPE,
					objectPtr->line, objectPtr->export.name);
		}
		break;
	    case SMI_NODEKIND_SCALAR:
		if ((parentPtr->export.nodekind != SMI_NODEKIND_UNKNOWN) &&
		    (parentPtr->export.nodekind != SMI_NODEKIND_NODE)) {
		    smiPrintErrorAtLine(parserPtr, ERR_SCALAR_PARENT_TYPE,
					objectPtr->line, objectPtr->export.name);
		}
		break;
	    case SMI_NODEKIND_NOTIFICATION:
		if ((parentPtr->export.nodekind != SMI_NODEKIND_NODE) &&
		    (parentPtr->export.nodekind != SMI_NODEKIND_UNKNOWN)) {
		    smiPrintErrorAtLine(parserPtr, ERR_NOTIFICATION_PARENT_TYPE,
					objectPtr->line, objectPtr->export.name);
		}
		if (parserPtr && parentPtr->nodePtr->parentPtr &&
		    parentPtr->nodePtr->parentPtr->lastObjectPtr) {
		    Object *parent2Ptr = parentPtr->nodePtr->parentPtr->lastObjectPtr;
		    if ((parent2Ptr->export.nodekind != SMI_NODEKIND_NODE) &&
			(parent2Ptr->export.nodekind != SMI_NODEKIND_UNKNOWN)) {
			smiPrintErrorAtLine(parserPtr,
					    ERR_NOTIFICATION_PARENT_TYPE,
					    objectPtr->line,
					    objectPtr->export.name);
		    }
		}
		break;
	    case SMI_NODEKIND_NODE:
		/* Node defined by OBJECT IDENTIFIER assignments can have
		   arbitrary parent node. */
		if ((parentPtr->export.nodekind != SMI_NODEKIND_UNKNOWN) &&
		    (parentPtr->export.nodekind != SMI_NODEKIND_NODE) &&
		    (objectPtr->export.decl != SMI_DECL_VALUEASSIGNMENT)) {
		    smiPrintErrorAtLine(parserPtr, ERR_NODE_PARENT_TYPE,
					objectPtr->line, objectPtr->export.name);
		}
		break;
	    case SMI_NODEKIND_GROUP:
		if ((parentPtr->export.nodekind != SMI_NODEKIND_UNKNOWN) &&
		    (parentPtr->export.nodekind != SMI_NODEKIND_NODE)) {
		    smiPrintErrorAtLine(parserPtr, ERR_GROUP_PARENT_TYPE,
					objectPtr->line, objectPtr->export.name);
		}
		break;
	    case SMI_NODEKIND_COMPLIANCE:
		if ((parentPtr->export.nodekind != SMI_NODEKIND_UNKNOWN) &&
		    (parentPtr->export.nodekind != SMI_NODEKIND_NODE)) {
		    smiPrintErrorAtLine(parserPtr, ERR_COMPLIANCE_PARENT_TYPE,
					objectPtr->line, objectPtr->export.name);
		}
		break;
	    case SMI_NODEKIND_CAPABILITIES:
		if ((parentPtr->export.nodekind != SMI_NODEKIND_UNKNOWN) &&
		    (parentPtr->export.nodekind != SMI_NODEKIND_NODE)) {
		    smiPrintErrorAtLine(parserPtr, ERR_CAPABILITIES_PARENT_TYPE,
					objectPtr->line, objectPtr->export.name);
		}
		break;
	    }
	}
	
	/*
	 * Check whether groups only contain scalars, columns and
	 * notifications.
	 */

	if (objectPtr->export.nodekind == SMI_NODEKIND_GROUP) {
	    smiCheckGroupMembers(parserPtr, objectPtr);
	}

	/*
	 * Check whether compliance statements contain out of date
	 * groups or objects.
	 */

	if (objectPtr->export.nodekind == SMI_NODEKIND_COMPLIANCE) {
	    smiCheckComplianceStatus(parserPtr, objectPtr);
	}

	/*
	 * Check whether notification statements contain useful
	 * objects.
	 */

	if (objectPtr->export.nodekind == SMI_NODEKIND_NOTIFICATION) {
	    smiCheckNotificationOid(parserPtr, modulePtr, objectPtr);
	    smiCheckNotificationMembers(parserPtr, objectPtr);
	}

        if (modulePtr->export.language != SMI_LANGUAGE_SPPI) {
	    /*
	     * Check whether tables and rows are not accessible
	     * (RFC 2578 7.1.12).
	     */

	    if (objectPtr->export.nodekind == SMI_NODEKIND_TABLE
	        && objectPtr->export.access != SMI_ACCESS_NOT_ACCESSIBLE) {
	        smiPrintErrorAtLine(parserPtr, ERR_TABLE_ACCESS,
				    objectPtr->line, objectPtr->export.name);
	    }

	    if (objectPtr->export.nodekind == SMI_NODEKIND_ROW
	        && objectPtr->export.access != SMI_ACCESS_NOT_ACCESSIBLE) {
	        smiPrintErrorAtLine(parserPtr, ERR_ROW_ACCESS,
				    objectPtr->line, objectPtr->export.name);
	    }

	    /*
	     * Check whether counter objects are read-only or
	     * accessible-for-notify (RFC 2578, 7.1.6).
	     */
	    if (((objectPtr->export.nodekind == SMI_NODEKIND_SCALAR) ||
		 (objectPtr->export.nodekind == SMI_NODEKIND_COLUMN)) &&
	        (objectPtr->export.access != SMI_ACCESS_NOTIFY) &&
		(objectPtr->export.access != SMI_ACCESS_READ_ONLY) &&
		(smiTypeDerivedFrom(objectPtr->typePtr, counterTypePtr) ||
		 smiTypeDerivedFrom(objectPtr->typePtr, counter32TypePtr) ||
		 smiTypeDerivedFrom(objectPtr->typePtr, counter64TypePtr))) {
	        smiPrintErrorAtLine(parserPtr, ERR_COUNTER_ACCESS,
				    objectPtr->line, objectPtr->export.name);
	    }
        }
	
	/*
	 * Check whether a row's subid is 1, see RFC 2578 7.10 (1).
	 */
	
	if (objectPtr->export.nodekind == SMI_NODEKIND_ROW) {
	    int len;
	    
	    if (objectPtr->nodePtr->subid != 1) {
		smiPrintErrorAtLine(parserPtr, ERR_ROW_SUBID_ONE,
				    objectPtr->line, objectPtr->export.name);
	    }

	    len = strlen(objectPtr->export.name);
	    if (len < 6 || strcmp(objectPtr->export.name+len-5, "Entry")) {
		smiPrintErrorAtLine(parserPtr, ERR_ROWNAME_ENTRY,
				    objectPtr->line, objectPtr->export.name);
	    } else {

		/*
		 * This misreports some cases where the table name
		 * does not have the "*Table" suffix.  This is trying
		 * to allow Entry names of either fooTableEntry or
		 * fooEntry.
		 */
		if (parentPtr &&
		    !(((int)strlen(parentPtr->export.name) == len ||
		       (int)strlen(parentPtr->export.name) == len - 5) &&
		      !strncmp(objectPtr->export.name, parentPtr->export.name,
			len - 5))) {
		    smiPrintErrorAtLine(parserPtr, ERR_ROWNAME_TABLENAME,
					objectPtr->line,
					objectPtr->export.name,
					parentPtr->export.name);
		}
	    }
	}

	/*
	 * Check whether a row's SEQUENCE contains exactly the list
	 * of child nodes (columns).  An unknown SEQUENCE type
	 * is handled later.
	 */

	if (objectPtr->export.nodekind == SMI_NODEKIND_ROW &&
	    ((objectPtr->typePtr->flags & FLAG_INCOMPLETE) == 0)) {
	    List *p;
	    Node *seqNodePtr, *childNodePtr;
	    Object *colPtr;
	    int i;
	    
	    /*
	     * Walk through the SEQUENCE elements and find those
	     * that are misordered or have no matching columnar object.
	     */
	    for (p = objectPtr->typePtr->listPtr, i = 1,
		     childNodePtr = objectPtr->nodePtr->firstChildPtr;
		 p && childNodePtr;
		 p = p->nextPtr, childNodePtr = childNodePtr->nextPtr, i++) {
		seqNodePtr = ((Object *)p->ptr)->nodePtr;

		if (seqNodePtr->parentPtr != childNodePtr->parentPtr) {
		    smiPrintErrorAtLine(parserPtr, ERR_SEQUENCE_NO_COLUMN,
					objectPtr->typePtr->line,
					i,
					((Object *)p->ptr)->export.name,
					objectPtr->export.name);
		    continue;
		}

		if (seqNodePtr != childNodePtr) {
		    smiPrintErrorAtLine(parserPtr, ERR_SEQUENCE_ORDER,
					objectPtr->typePtr->line,
					i,
					((Object *)p->ptr)->export.name,
					objectPtr->export.name);
		    break;
		}
	    }
	    if ((p != NULL) && (childNodePtr == NULL)) {
		smiPrintErrorAtLine(parserPtr, ERR_SEQUENCE_NO_COLUMN,
				    objectPtr->typePtr->line,
				    i, 
				    ((Object *)p->ptr)->export.name,
				    objectPtr->export.name);
	    }

	    /*
	     * Walk through all child objects and find those
	     * that were missing in the SEQUENCE.
	     */
	    for (childNodePtr = objectPtr->nodePtr->firstChildPtr;
		 childNodePtr; childNodePtr = childNodePtr->nextPtr) {
		colPtr = findObjectByModuleAndNode(modulePtr, childNodePtr);
		if (!colPtr) continue;
		for (p = objectPtr->typePtr->listPtr; p; p = p->nextPtr) {
		    if (((Object *)p->ptr)->nodePtr == colPtr->nodePtr)
			break;
		}
		if (!p) {
		    if (colPtr->export.name) {
			/*
			 * Don't complain, if it's an implcitly defined
			 * unnamed node (could happen for parent node of
			 * TRAP-TYPE definitions).
			 */
			smiPrintErrorAtLine(parserPtr,
					    ERR_SEQUENCE_MISSING_COLUMN,
					    objectPtr->typePtr->line,
					    objectPtr->typePtr->export.name,
					    colPtr->export.name);
		    }
		}
	    }
	    
	}
	
	if (objectPtr->export.nodekind == SMI_NODEKIND_TABLE) {
	    int len;

	    len = strlen(objectPtr->export.name);
	    if (len < 6 || strcmp(objectPtr->export.name+len-5, "Table")) {
		smiPrintErrorAtLine(parserPtr, ERR_TABLENAME_TABLE,
				    objectPtr->line, objectPtr->export.name);
	    }
	}

	/*
	 * TODO: check whether the row is the only node below the
         * table node
	 */

	/*
	 * Check references to unknown identifiers.
	 */

	if ((objectPtr->flags & FLAG_INCOMPLETE) &&
	    (objectPtr->export.decl != SMI_DECL_IMPL_OBJECT)) {
	    if (objectPtr->export.name) {
		smiPrintErrorAtLine(parserPtr, ERR_UNKNOWN_OIDLABEL,
				    objectPtr->line, objectPtr->export.name);
	    } else {
		smiPrintErrorAtLine(parserPtr, ERR_IMPLICIT_NODE,
				    objectPtr->line);
	    }
	}

	/*
	 * Adjust the status of implicit type definitions.
	 */
	
	if (objectPtr->typePtr
	    && (objectPtr->typePtr->export.decl == SMI_DECL_IMPLICIT_TYPE)
	    && (objectPtr->typePtr->export.status == SMI_STATUS_UNKNOWN)) {
	    objectPtr->typePtr->export.status = objectPtr->export.status;
	}

	/*
	 * Link implicit type definition from refinements into
	 * the type derivation tree. Adjust the status of implicit
	 * type definitions in refinements. 
	 */

	if (objectPtr->export.nodekind == SMI_NODEKIND_COMPLIANCE) {

	    List *listPtr;

	    for (listPtr = objectPtr->refinementlistPtr;
		 listPtr;
		 listPtr = listPtr->nextPtr) {

		Refinement *refinementPtr;
		Type *typePtr;
		
		refinementPtr = ((Refinement *)(listPtr->ptr));
		typePtr = refinementPtr->typePtr;
		if (typePtr) {
		    if (typePtr->export.status == SMI_STATUS_UNKNOWN) {
			typePtr->export.status = objectPtr->export.status;
		    }
		}

		typePtr = refinementPtr->writetypePtr;
		if (typePtr) {
		    if (typePtr->export.status == SMI_STATUS_UNKNOWN) {
			typePtr->export.status = objectPtr->export.status;
		    }
		}
		
	    }
	    /* relocate the refinement type into the type tree */
	    /* relocate the write refinement type into the type tree */
	}

	/*
	 * Set the oidlen/oid values that are not yet correct.
	 */

	if (objectPtr->export.oidlen == 0) {
	    if (objectPtr->nodePtr->oidlen == 0) {
		for (nodePtr = objectPtr->nodePtr, i = 1;
		     nodePtr->parentPtr != thisParserPtr->pendingNodePtr &&
			 nodePtr->parentPtr != smiHandle->rootNodePtr &&
			 nodePtr != nodePtr->parentPtr &&
			 i <= 128;
		     nodePtr = nodePtr->parentPtr, i++);
		if ((objectPtr->export.name) &&
		    ((i > 128) || (nodePtr == nodePtr->parentPtr))) {
		    smiPrintErrorAtLine(parserPtr, ERR_OID_RECURSIVE,
					objectPtr->line,
					objectPtr->export.name);
		}
		objectPtr->nodePtr->oid = smiMalloc(i * sizeof(SmiSubid));
		objectPtr->nodePtr->oidlen = i;
		for (nodePtr = objectPtr->nodePtr; i > 0; i--) {
		    objectPtr->nodePtr->oid[i-1] = nodePtr->subid;
		    nodePtr = nodePtr->parentPtr;
		}
	    }
	    objectPtr->export.oidlen = objectPtr->nodePtr->oidlen;
	    objectPtr->export.oid = objectPtr->nodePtr->oid;
	}

	if ((objectPtr->export.decl != SMI_DECL_UNKNOWN)
	    && (objectPtr->export.nodekind != SMI_NODEKIND_NODE)
	    && objectPtr->export.name
	    && objectPtr->export.oid[objectPtr->export.oidlen-1] == 0
	    && objectPtr->export.oidlen != 2 && objectPtr->export.oid[0] != 0) {
	    smiPrintErrorAtLine(parserPtr, ERR_OID_ADMIN_ZERO,
				objectPtr->line,
				objectPtr->export.name);
	}

	/*
	 * Check whether the module identity is registered in a well
	 * known controlled location. 
	 */

	if (objectPtr->export.decl == SMI_DECL_MODULEIDENTITY) {
	    smiCheckModuleIdentityRegistration(parserPtr, objectPtr);
	}

	/*
	 * Check table linkage constraints for row objects.
	 */

	if (objectPtr->export.nodekind == SMI_NODEKIND_ROW) {
	    switch (objectPtr->export.indexkind) {
	    case SMI_INDEX_INDEX:
		smiCheckIndex(parserPtr, objectPtr);
		break;
	    case SMI_INDEX_AUGMENT:
            case SMI_INDEX_SPARSE:
		smiCheckAugment(parserPtr, objectPtr);
		break;
	    default:
		break;
	    }
	}
	
	/*
	 * Determine the longest common OID prefix of all nodes.
	 */

	if (!modulePtr->prefixNodePtr) {
	    modulePtr->prefixNodePtr = objectPtr->nodePtr;
	} else {
	    if (objectPtr->nodePtr->oidlen < modulePtr->prefixNodePtr->oidlen) {
		Node *nodePtr = findNodeByOid(objectPtr->nodePtr->oidlen,
					      modulePtr->prefixNodePtr->oid);
		if (nodePtr)
		    modulePtr->prefixNodePtr = nodePtr;
		else
		    smiPrintError(parserPtr, ERR_OTHER_ERROR,
				  "Failed to create complete object tree - "
				  "expect incorrect output");
	    }
	    for (i = 0; i < modulePtr->prefixNodePtr->oidlen; i++) {
		if (modulePtr->prefixNodePtr->oid[i] !=
		    objectPtr->nodePtr->oid[i]) {
		    modulePtr->prefixNodePtr =
			findNodeByOid(i, modulePtr->prefixNodePtr->oid);
		    break;
		}
	    }
	}
    }

    if (modulePtr->export.language == SMI_LANGUAGE_SMIV2) {
	for (objectPtr = modulePtr->firstObjectPtr;
	     objectPtr; objectPtr = objectPtr->nextPtr) {
	    
	    /*
	     * Check whether all objects and notifications are contained in at
	     * least one conformance group (RFC 2580 3.3 and 4.1).
	     */
	    
	    smiCheckGroupMembership(parserPtr, objectPtr);
	}
    }

    if (modulePtr->export.language == SMI_LANGUAGE_SPPI) {
        Object *parentPtr;
        
        for (objectPtr = modulePtr->firstObjectPtr;
             objectPtr; objectPtr = objectPtr->nextPtr) {
            /*
             * All checks for SPPI constructs
             */
            if (objectPtr->nodePtr->parentPtr)
                parentPtr = objectPtr->nodePtr->parentPtr->lastObjectPtr;
            else
                parentPtr = NULL;
            
            /*
             * Do all rows contain a PIB-INDEX/AUGMENTS/EXTENDS ?
             * See RFC 3159 7.5, 7.7, 7.8
             */
            if (parentPtr  &&
                (parentPtr->export.nodekind == SMI_NODEKIND_TABLE) &&
                (objectPtr->export.indexkind != SMI_INDEX_INDEX) &&
                (objectPtr->export.indexkind != SMI_INDEX_AUGMENT) &&
                (objectPtr->export.indexkind != SMI_INDEX_SPARSE))
                smiPrintErrorAtLine(parserPtr, ERR_ROW_LACKS_PIB_INDEX,
                                    objectPtr->line);

            /*
             * Does any non row contain a PIB-INDEX/AUGMENTS/EXTENDS ?
             * See RFC 3159 7.5, 7.7, 7.8
             */
            if ((objectPtr->export.nodekind != SMI_NODEKIND_ROW) &&
                (objectPtr->export.indexkind != SMI_INDEX_UNKNOWN))
                smiPrintErrorAtLine(parserPtr, ERR_PIB_INDEX_FOR_NON_ROW_TYPE,
                                    objectPtr->line);

            /*
             * Check the PIB-INDEX and other indices
             */
            if ((objectPtr->export.nodekind == SMI_NODEKIND_ROW) &&
                (objectPtr->export.indexkind == SMI_INDEX_INDEX)) {

                /*
                 * Only the first element (PIB-INDEX) has to be an InstanceId.
                 * See RFC 3159 7.5
                 */
                if (objectPtr->listPtr && objectPtr->listPtr->ptr) {
                    Object *pibindex = (Object *)objectPtr->listPtr->ptr;
                    if (pibindex->typePtr && pibindex->typePtr->export.name &&
                        strcmp(pibindex->typePtr->export.name, "InstanceId"))
                        smiPrintErrorAtLine(thisParserPtr, ERR_PIB_INDEX_NOT_INSTANCEID,
                                            pibindex->line, pibindex->export.name);
                }
            }
            
            /*
             * Do all tables contain a PIB-ACCESS clause?
             * See RFC 3159 7.3
             */
            if ((objectPtr->export.nodekind == SMI_NODEKIND_TABLE) &&
                (objectPtr->export.access == SMI_ACCESS_UNKNOWN))
                smiPrintErrorAtLine(parserPtr, ERR_TABLE_LACKS_PIB_ACCESS,
                                    objectPtr->line);

            /*
             * Does any non table types contain a PIB-ACCESS clause?
             * See RFC 3159 7.3
             */
            if (((objectPtr->export.nodekind == SMI_NODEKIND_NODE) ||
                 (objectPtr->export.nodekind == SMI_NODEKIND_ROW) ||
                 (objectPtr->export.nodekind == SMI_NODEKIND_SCALAR)) &&
                (objectPtr->export.access != SMI_ACCESS_UNKNOWN))
                smiPrintErrorAtLine(parserPtr, ERR_PIB_ACCESS_FOR_NON_TABLE,
                                    objectPtr->line);

            /*
             * Check the UNIQUENESS clause and its entries
             * See RFC 3159 7.9
             */
            if (objectPtr->uniquenessPtr) {
                if (objectPtr->export.nodekind != SMI_NODEKIND_ROW)
                    smiPrintErrorAtLine(parserPtr, ERR_UNIQUENESS_FOR_NON_ROW,
                                        objectPtr->line);
                else
                    smiCheckUniqueness(parserPtr, objectPtr);
            }
            
            /*
             * Does the PIB-REFERENCES object point to a PRC (table)?
             * See RFC 3159 7.10
             */
            if (objectPtr->typePtr && objectPtr->typePtr->export.name &&
                !strcmp(objectPtr->typePtr->export.name, "ReferenceId") &&
                objectPtr->relatedPtr &&
                (objectPtr->relatedPtr->export.nodekind != SMI_NODEKIND_ROW))
                smiPrintErrorAtLine(parserPtr, ERR_PIB_REFERENCES_NOT_ROW,
                                    objectPtr->line);

            /*
             * Do all PIB-TAGs point to objects with a SYNTAX of TagId?
             * See RFC 3159 7.12
             */
            if (objectPtr->typePtr && objectPtr->typePtr->export.name &&
                !strcmp(objectPtr->typePtr->export.name, "TagReferenceId") &&
                objectPtr->relatedPtr && objectPtr->relatedPtr->typePtr &&
                objectPtr->relatedPtr->typePtr->export.name &&
                strcmp(objectPtr->relatedPtr->typePtr->export.name, "TagId"))
                smiPrintErrorAtLine(parserPtr, ERR_PIB_TAG_TYPE, objectPtr->line);
            
            /*
             * Is the attribute member of at least one compliance group?
             * See RFC 3159 9.1
             */
            if (objectPtr->export.nodekind & SMI_NODEKIND_COLUMN) {
                Object *group;
                int found = 0;
                
                for (group = modulePtr->firstObjectPtr; group;
                     group = group->nextPtr) {
                    if ((group->export.nodekind == SMI_NODEKIND_GROUP) &&
                        group->listPtr) {
                        List *l;
                        
                        for (l = group->listPtr; l; l = l->nextPtr)
                            if (((Object *)l->ptr)->export.name &&
                                !strcmp(((Object *)l->ptr)->export.name,
                                        objectPtr->export.name)) {
                                found = 1;
                                break;
                            }
                    }
                    if (found)
                        break;
                }
                if (!found)
                    smiPrintErrorAtLine(parserPtr, ERR_ATTRIBUTE_NOT_IN_GROUP,
                                        objectPtr->line, objectPtr->export.name);
            }
        }
    }
}



static void
checkTypes(Parser *parserPtr, Module *modulePtr)
{
    Type *typePtr;
    
    for (typePtr = modulePtr->firstTypePtr;
	typePtr; typePtr = typePtr->nextPtr) {

	/*
	 * Check references to unknown types.
	 */
	
	if ((typePtr->flags & FLAG_INCOMPLETE)
	    && typePtr->export.name
	    && (typePtr->export.decl == SMI_DECL_UNKNOWN)) {
	    smiPrintErrorAtLine(parserPtr, ERR_UNKNOWN_TYPE,
				typePtr->line, typePtr->export.name);
	}

	/*
	 * Use TCs instead of type assignments in SMIv2.
	 */

	if (thisModulePtr->export.language == SMI_LANGUAGE_SMIV2
	    && typePtr->export.decl == SMI_DECL_TYPEASSIGNMENT
	    && typePtr->export.basetype != SMI_BASETYPE_UNKNOWN
	    && strcmp(thisModulePtr->export.name, "SNMPv2-SMI")) {
	    smiPrintErrorAtLine(parserPtr, ERR_SMIV2_TYPE_ASSIGNEMENT,
				typePtr->line, typePtr->export.name);
	}

	/*
	 * Check whether we have types that are not used in this
	 * module.
	 */

	if ((typePtr->export.decl == SMI_DECL_TYPEDEF
	     || typePtr->export.decl == SMI_DECL_TEXTUALCONVENTION)
	    && ! (typePtr->flags & FLAG_INSYNTAX)) {
	    static char *status[] = { "Unknown", "current", "deprecated",
				      "mandatory", "optional", "obsolete" };
	    smiPrintErrorAtLine(parserPtr, ERR_TYPE_UNREF,
				typePtr->line,
				status[typePtr->export.status],
				typePtr->export.name);
	}

	/*
	 * Complain about TCs derived from other TCs (RFC 2579 3.5).
	 */
	
	if (typePtr->parentPtr
	    && typePtr->export.decl == SMI_DECL_TEXTUALCONVENTION
	    && typePtr->export.decl == typePtr->parentPtr->export.decl) {
	    smiPrintErrorAtLine(parserPtr, ERR_SMIV2_NESTED_TEXTUAL_CONVENTION,
				typePtr->line,
				typePtr->export.name,
				typePtr->parentPtr->export.name);

	    if (typePtr->export.status < typePtr->parentPtr->export.status) {
		if (typePtr->parentPtr->export.status == SMI_STATUS_DEPRECATED) {
		    smiPrintErrorAtLine(parserPtr, ERR_TYPE_STATUS_DEPRECATED,
					typePtr->line,
					typePtr->parentPtr->export.name,
					typePtr->export.name);
		}
		if (typePtr->parentPtr->export.status == SMI_STATUS_OBSOLETE) {
		    smiPrintErrorAtLine(parserPtr, ERR_TYPE_STATUS_OBSOLETE,
					typePtr->line,
					typePtr->parentPtr->export.name,
					typePtr->export.name);
		}
	    }
	}

	smiCheckTypeFormat(parserPtr, typePtr);
	smiCheckNamedNumberRedefinition(parserPtr, typePtr);
	smiCheckNamedNumberSubtyping(parserPtr, typePtr);
    }
}


				
static void
adjustDefval(Parser *parserPtr, SmiValue *valuePtr, Type *typePtr, int line)
{
    Object *object2Ptr;
    List *bitsListPtr, *valueListPtr, *p, *pp, *nextPtr, *listPtr;
    Import *importPtr;
    int nBits, bit;
    
    if (valuePtr->basetype == SMI_BASETYPE_UNKNOWN)
	return;
	
    if (valuePtr->basetype == SMI_BASETYPE_OBJECTIDENTIFIER) {
	/* a len of -1 indicates an unresolved label in ptr */
	if (valuePtr->len == -1) {
	    object2Ptr = findObjectByModuleAndName(parserPtr->modulePtr,
						  (char *)valuePtr->value.ptr);
	    if (!object2Ptr) {
		importPtr = findImportByName(
		    (char *)valuePtr->value.ptr, parserPtr->modulePtr);
		if (importPtr) {		/* imported object */
		    importPtr->use++;
		    object2Ptr = findObjectByModulenameAndName(
			importPtr->export.module,
			importPtr->export.name);
		}
	    }
	    if (!object2Ptr) {
		smiPrintErrorAtLine(parserPtr, ERR_UNKNOWN_OIDLABEL,
				    line,
				    (char *)valuePtr->value.ptr);
		smiFree(valuePtr->value.ptr);
		valuePtr->value.ptr = NULL;
		valuePtr->basetype = SMI_BASETYPE_UNKNOWN;
	    } else {
		smiFree(valuePtr->value.ptr);
		valuePtr->len = object2Ptr->export.oidlen;
		valuePtr->value.ptr = smiMalloc(object2Ptr->export.oidlen *
						sizeof(SmiSubid));
		memcpy(valuePtr->value.ptr,
		       object2Ptr->export.oid,
		       object2Ptr->export.oidlen * sizeof(SmiSubid));
	    }
	}
    } else if (valuePtr->basetype == SMI_BASETYPE_BITS) {
	bitsListPtr = typePtr->listPtr;
	valueListPtr = (void *)valuePtr->value.ptr;
	for (nBits = 0, p = bitsListPtr; p; p = p->nextPtr) {
	    if (nBits < 1+((NamedNumber *)(p->ptr))->export.value.value.integer32) {
		nBits = 1+((NamedNumber *)(p->ptr))->export.value.value.integer32;
	    }
	}
	valuePtr->value.ptr = smiMalloc((nBits+7)/8);
	memset(valuePtr->value.ptr, 0, (nBits+7)/8);
	valuePtr->len = (nBits+7)/8;
	for (p = valueListPtr; p;) {
	    for (pp = bitsListPtr; pp; pp = pp->nextPtr) {
		if (!strcmp(p->ptr,
			    ((NamedNumber *)(pp->ptr))->export.name)) {
		    bit = ((NamedNumber *)(pp->ptr))->export.value.value.integer32;
		    valuePtr->value.ptr[bit/8] |=
			1 << (7-(bit%8));
		}
	    }
	    smiFree(p->ptr);
	    nextPtr = p->nextPtr;
	    smiFree(p);
	    p = nextPtr;
	}
    } else if (valuePtr->basetype == SMI_BASETYPE_ENUM) {
	/* a len of -1 indicates an unresolved enum label in ptr */
	if (valuePtr->len == -1) {
	    for (listPtr = typePtr->listPtr; listPtr;
		 listPtr = listPtr->nextPtr) {
		if (!strcmp(((NamedNumber *)(listPtr->ptr))->export.name,
			    (char *)valuePtr->value.ptr)) {
		    smiFree(valuePtr->value.ptr);
		    valuePtr->value.integer32 =
			((NamedNumber *)(listPtr->ptr))->
			export.value.value.integer32;
		    valuePtr->len = 1;
		    break;
		}
	    }
	}
    }
}



static void
checkDefvals(Parser *parserPtr, Module *modulePtr)
{
    Object *objectPtr;
    
    /*
     * Check unknown identifiers in OID DEFVALs.
     */

    for(objectPtr = modulePtr->firstObjectPtr;
	objectPtr; objectPtr = objectPtr->nextPtr) {

	adjustDefval(parserPtr, &objectPtr->export.value,
		     objectPtr->typePtr, objectPtr->line);
	
	if (objectPtr->export.value.len == -1) {
	    smiPrintErrorAtLine(parserPtr,
				ERR_DEFVAL_SYNTAX, objectPtr->line);
	}
	
	smiCheckDefault(parserPtr, objectPtr);
    }
}



static void
checkImportsUsage(Parser *parserPtr, Module *modulePtr)
{
    Import *importPtr;
    
    /*
     * Check usage of all imported identifiers.
     */

    if (strcmp(modulePtr->export.name, "SNMPv2-TC") &&
	strcmp(modulePtr->export.name, "SNMPv2-CONF") &&
	strcmp(modulePtr->export.name, "RFC-1212") &&
	strcmp(modulePtr->export.name, "RFC-1215")) {
	for(importPtr = modulePtr->firstImportPtr;
	    importPtr; importPtr = importPtr->nextPtr) {
	    if (! strcmp(importPtr->export.module, "SNMPv2-SMI")) {
		if (! strcmp(importPtr->export.name, "ExtUTCTime")
		    || !strcmp(importPtr->export.name, "ObjectName")
		    || !strcmp(importPtr->export.name, "NotificationName")) {
		    smiPrintErrorAtLine(parserPtr, ERR_ILLEGAL_IMPORT,
					importPtr->line,
					importPtr->export.name,
					importPtr->export.module);
		}
	    }
	    /* checkImports() handles KIND_NOTFOUND */
	    if (importPtr->use == 0 && importPtr->kind != KIND_NOTFOUND) {
		smiPrintErrorAtLine(parserPtr, ERR_UNUSED_IMPORT,
				    importPtr->line,
				    importPtr->export.name,
				    importPtr->export.module);
	    }

	    if (modulePtr->export.language == SMI_LANGUAGE_SMIV2) {
		int j;
		for (j = 0; convertImportv2[j]; j += 4) {
		    if ((strcmp(convertImportv2[j],
				importPtr->export.module) == 0)
			&& (strcmp(convertImportv2[j+1],
				   importPtr->export.name) == 0)) {
			smiPrintErrorAtLine(parserPtr,
					    ERR_OBSOLETE_IMPORT,
					    importPtr->line,
					    importPtr->export.name,
					    convertImportv2[j+2],
					    importPtr->export.module);
		    }
		}
	    }
	}
    }
}



static time_t
checkDate(Parser *parserPtr, char *date)
{
    struct tm	tm;
    time_t	anytime;
    int		i, len;
    char	*p;
    
    memset(&tm, 0, sizeof(tm));
    anytime = 0;
    
    len = strlen(date);
    if (len == 11 || len == 13) {
	for (i = 0; i < len; i++) {
	    if ( (i < len-1 && ! isdigit((int) date[i]))
		 || (i == len-1 && date[len-1] != 'Z')) {
		smiPrintError(parserPtr, ERR_DATE_CHARACTER, date);
		anytime = (time_t) -1;
		break;
	    }
	}
    } else {
	smiPrintError(parserPtr, ERR_DATE_LENGTH, date);
	anytime = (time_t) -1;
    }

    if (anytime == 0) {
	for (i = 0, p = date, tm.tm_year = 0;
	     i < ((len == 11) ? 2 : 4); i++, p++) {
	    tm.tm_year = tm.tm_year * 10 + (*p - '0');
	}
	if (len == 11) {
	    tm.tm_year += 1900;
	    if (tm.tm_year < 1990)
		smiPrintError(parserPtr, ERR_DATE_YEAR_2DIGITS,
			      date, tm.tm_year);
	}
	tm.tm_mon  = (p[0]-'0') * 10 + (p[1]-'0');
	p += 2;
	tm.tm_mday = (p[0]-'0') * 10 + (p[1]-'0');
	p += 2;
	tm.tm_hour = (p[0]-'0') * 10 + (p[1]-'0');
	p += 2;
	tm.tm_min  = (p[0]-'0') * 10 + (p[1]-'0');
	
	if (tm.tm_mon < 1 || tm.tm_mon > 12) {
	    smiPrintError(parserPtr, ERR_DATE_MONTH, date);
	}
	if (tm.tm_mday < 1 || tm.tm_mday > 31) {
	    smiPrintError(parserPtr, ERR_DATE_DAY, date);
	}
	if (tm.tm_hour < 0 || tm.tm_hour > 23) {
	    smiPrintError(parserPtr, ERR_DATE_HOUR, date);
	}
	if (tm.tm_min < 0 || tm.tm_min > 59) {
	    smiPrintError(parserPtr, ERR_DATE_MINUTES, date);
	}
	
	tm.tm_year -= 1900;
	tm.tm_mon -= 1;
	tm.tm_isdst = 0;

	anytime = timegm(&tm);
	
	if (anytime == (time_t) -1) {
	    smiPrintError(parserPtr, ERR_DATE_VALUE, date);
	} else {
	    if (anytime < SMI_EPOCH) {
		smiPrintError(parserPtr, ERR_DATE_IN_PAST, date);
	    }
	    if (anytime > time(NULL)) {
		smiPrintError(parserPtr, ERR_DATE_IN_FUTURE, date);
	    }
	}
    }

    return (anytime == (time_t) -1) ? 0 : anytime;
}


#line 1324 "parser-smi.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parser-smi.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_DOT_DOT = 3,                    /* DOT_DOT  */
  YYSYMBOL_COLON_COLON_EQUAL = 4,          /* COLON_COLON_EQUAL  */
  YYSYMBOL_UPPERCASE_IDENTIFIER = 5,       /* UPPERCASE_IDENTIFIER  */
  YYSYMBOL_LOWERCASE_IDENTIFIER = 6,       /* LOWERCASE_IDENTIFIER  */
  YYSYMBOL_NUMBER = 7,                     /* NUMBER  */
  YYSYMBOL_NEGATIVENUMBER = 8,             /* NEGATIVENUMBER  */
  YYSYMBOL_NUMBER64 = 9,                   /* NUMBER64  */
  YYSYMBOL_NEGATIVENUMBER64 = 10,          /* NEGATIVENUMBER64  */
  YYSYMBOL_BIN_STRING = 11,                /* BIN_STRING  */
  YYSYMBOL_HEX_STRING = 12,                /* HEX_STRING  */
  YYSYMBOL_QUOTED_STRING = 13,             /* QUOTED_STRING  */
  YYSYMBOL_ACCESS = 14,                    /* ACCESS  */
  YYSYMBOL_AGENT_CAPABILITIES = 15,        /* AGENT_CAPABILITIES  */
  YYSYMBOL_APPLICATION = 16,               /* APPLICATION  */
  YYSYMBOL_AUGMENTS = 17,                  /* AUGMENTS  */
  YYSYMBOL_BEGIN_ = 18,                    /* BEGIN_  */
  YYSYMBOL_BITS = 19,                      /* BITS  */
  YYSYMBOL_CHOICE = 20,                    /* CHOICE  */
  YYSYMBOL_CONTACT_INFO = 21,              /* CONTACT_INFO  */
  YYSYMBOL_CREATION_REQUIRES = 22,         /* CREATION_REQUIRES  */
  YYSYMBOL_COUNTER32 = 23,                 /* COUNTER32  */
  YYSYMBOL_COUNTER64 = 24,                 /* COUNTER64  */
  YYSYMBOL_DEFINITIONS = 25,               /* DEFINITIONS  */
  YYSYMBOL_DEFVAL = 26,                    /* DEFVAL  */
  YYSYMBOL_DESCRIPTION = 27,               /* DESCRIPTION  */
  YYSYMBOL_DISPLAY_HINT = 28,              /* DISPLAY_HINT  */
  YYSYMBOL_END = 29,                       /* END  */
  YYSYMBOL_ENTERPRISE = 30,                /* ENTERPRISE  */
  YYSYMBOL_EXPORTS = 31,                   /* EXPORTS  */
  YYSYMBOL_EXTENDS = 32,                   /* EXTENDS  */
  YYSYMBOL_FROM = 33,                      /* FROM  */
  YYSYMBOL_GROUP = 34,                     /* GROUP  */
  YYSYMBOL_GAUGE32 = 35,                   /* GAUGE32  */
  YYSYMBOL_IDENTIFIER = 36,                /* IDENTIFIER  */
  YYSYMBOL_IMPLICIT = 37,                  /* IMPLICIT  */
  YYSYMBOL_IMPLIED = 38,                   /* IMPLIED  */
  YYSYMBOL_IMPORTS = 39,                   /* IMPORTS  */
  YYSYMBOL_INCLUDES = 40,                  /* INCLUDES  */
  YYSYMBOL_INDEX = 41,                     /* INDEX  */
  YYSYMBOL_INSTALL_ERRORS = 42,            /* INSTALL_ERRORS  */
  YYSYMBOL_INTEGER = 43,                   /* INTEGER  */
  YYSYMBOL_INTEGER32 = 44,                 /* INTEGER32  */
  YYSYMBOL_INTEGER64 = 45,                 /* INTEGER64  */
  YYSYMBOL_IPADDRESS = 46,                 /* IPADDRESS  */
  YYSYMBOL_LAST_UPDATED = 47,              /* LAST_UPDATED  */
  YYSYMBOL_MACRO = 48,                     /* MACRO  */
  YYSYMBOL_MANDATORY_GROUPS = 49,          /* MANDATORY_GROUPS  */
  YYSYMBOL_MAX_ACCESS = 50,                /* MAX_ACCESS  */
  YYSYMBOL_MIN_ACCESS = 51,                /* MIN_ACCESS  */
  YYSYMBOL_MODULE = 52,                    /* MODULE  */
  YYSYMBOL_MODULE_COMPLIANCE = 53,         /* MODULE_COMPLIANCE  */
  YYSYMBOL_MODULE_IDENTITY = 54,           /* MODULE_IDENTITY  */
  YYSYMBOL_NOT_ACCESSIBLE = 55,            /* NOT_ACCESSIBLE  */
  YYSYMBOL_NOTIFICATIONS = 56,             /* NOTIFICATIONS  */
  YYSYMBOL_NOTIFICATION_GROUP = 57,        /* NOTIFICATION_GROUP  */
  YYSYMBOL_NOTIFICATION_TYPE = 58,         /* NOTIFICATION_TYPE  */
  YYSYMBOL_OBJECT = 59,                    /* OBJECT  */
  YYSYMBOL_OBJECT_GROUP = 60,              /* OBJECT_GROUP  */
  YYSYMBOL_OBJECT_IDENTITY = 61,           /* OBJECT_IDENTITY  */
  YYSYMBOL_OBJECT_TYPE = 62,               /* OBJECT_TYPE  */
  YYSYMBOL_OBJECTS = 63,                   /* OBJECTS  */
  YYSYMBOL_OCTET = 64,                     /* OCTET  */
  YYSYMBOL_OF = 65,                        /* OF  */
  YYSYMBOL_ORGANIZATION = 66,              /* ORGANIZATION  */
  YYSYMBOL_OPAQUE = 67,                    /* OPAQUE  */
  YYSYMBOL_PIB_ACCESS = 68,                /* PIB_ACCESS  */
  YYSYMBOL_PIB_DEFINITIONS = 69,           /* PIB_DEFINITIONS  */
  YYSYMBOL_PIB_INDEX = 70,                 /* PIB_INDEX  */
  YYSYMBOL_PIB_MIN_ACCESS = 71,            /* PIB_MIN_ACCESS  */
  YYSYMBOL_PIB_REFERENCES = 72,            /* PIB_REFERENCES  */
  YYSYMBOL_PIB_TAG = 73,                   /* PIB_TAG  */
  YYSYMBOL_POLICY_ACCESS = 74,             /* POLICY_ACCESS  */
  YYSYMBOL_PRODUCT_RELEASE = 75,           /* PRODUCT_RELEASE  */
  YYSYMBOL_REFERENCE = 76,                 /* REFERENCE  */
  YYSYMBOL_REVISION = 77,                  /* REVISION  */
  YYSYMBOL_SEQUENCE = 78,                  /* SEQUENCE  */
  YYSYMBOL_SIZE = 79,                      /* SIZE  */
  YYSYMBOL_STATUS = 80,                    /* STATUS  */
  YYSYMBOL_STRING = 81,                    /* STRING  */
  YYSYMBOL_SUBJECT_CATEGORIES = 82,        /* SUBJECT_CATEGORIES  */
  YYSYMBOL_SUPPORTS = 83,                  /* SUPPORTS  */
  YYSYMBOL_SYNTAX = 84,                    /* SYNTAX  */
  YYSYMBOL_TEXTUAL_CONVENTION = 85,        /* TEXTUAL_CONVENTION  */
  YYSYMBOL_TIMETICKS = 86,                 /* TIMETICKS  */
  YYSYMBOL_TRAP_TYPE = 87,                 /* TRAP_TYPE  */
  YYSYMBOL_UNIQUENESS = 88,                /* UNIQUENESS  */
  YYSYMBOL_UNITS = 89,                     /* UNITS  */
  YYSYMBOL_UNIVERSAL = 90,                 /* UNIVERSAL  */
  YYSYMBOL_UNSIGNED32 = 91,                /* UNSIGNED32  */
  YYSYMBOL_UNSIGNED64 = 92,                /* UNSIGNED64  */
  YYSYMBOL_VALUE = 93,                     /* VALUE  */
  YYSYMBOL_VARIABLES = 94,                 /* VARIABLES  */
  YYSYMBOL_VARIATION = 95,                 /* VARIATION  */
  YYSYMBOL_WRITE_SYNTAX = 96,              /* WRITE_SYNTAX  */
  YYSYMBOL_97_ = 97,                       /* '{'  */
  YYSYMBOL_98_ = 98,                       /* '}'  */
  YYSYMBOL_99_ = 99,                       /* ';'  */
  YYSYMBOL_100_ = 100,                     /* ','  */
  YYSYMBOL_101_ = 101,                     /* '('  */
  YYSYMBOL_102_ = 102,                     /* ')'  */
  YYSYMBOL_103_ = 103,                     /* '['  */
  YYSYMBOL_104_ = 104,                     /* ']'  */
  YYSYMBOL_105_ = 105,                     /* '.'  */
  YYSYMBOL_106_ = 106,                     /* '|'  */
  YYSYMBOL_YYACCEPT = 107,                 /* $accept  */
  YYSYMBOL_mibFile = 108,                  /* mibFile  */
  YYSYMBOL_modules = 109,                  /* modules  */
  YYSYMBOL_module = 110,                   /* module  */
  YYSYMBOL_111_1 = 111,                    /* $@1  */
  YYSYMBOL_moduleOid = 112,                /* moduleOid  */
  YYSYMBOL_definitions = 113,              /* definitions  */
  YYSYMBOL_linkagePart = 114,              /* linkagePart  */
  YYSYMBOL_linkageClause = 115,            /* linkageClause  */
  YYSYMBOL_exportsClause = 116,            /* exportsClause  */
  YYSYMBOL_117_2 = 117,                    /* $@2  */
  YYSYMBOL_importPart = 118,               /* importPart  */
  YYSYMBOL_imports = 119,                  /* imports  */
  YYSYMBOL_import = 120,                   /* import  */
  YYSYMBOL_importIdentifiers = 121,        /* importIdentifiers  */
  YYSYMBOL_importIdentifier = 122,         /* importIdentifier  */
  YYSYMBOL_importedKeyword = 123,          /* importedKeyword  */
  YYSYMBOL_importedSMIKeyword = 124,       /* importedSMIKeyword  */
  YYSYMBOL_importedSPPIKeyword = 125,      /* importedSPPIKeyword  */
  YYSYMBOL_moduleName = 126,               /* moduleName  */
  YYSYMBOL_declarationPart = 127,          /* declarationPart  */
  YYSYMBOL_declarations = 128,             /* declarations  */
  YYSYMBOL_declaration = 129,              /* declaration  */
  YYSYMBOL_macroClause = 130,              /* macroClause  */
  YYSYMBOL_131_3 = 131,                    /* $@3  */
  YYSYMBOL_132_4 = 132,                    /* $@4  */
  YYSYMBOL_macroName = 133,                /* macroName  */
  YYSYMBOL_choiceClause = 134,             /* choiceClause  */
  YYSYMBOL_135_5 = 135,                    /* $@5  */
  YYSYMBOL_fuzzy_lowercase_identifier = 136, /* fuzzy_lowercase_identifier  */
  YYSYMBOL_valueDeclaration = 137,         /* valueDeclaration  */
  YYSYMBOL_138_6 = 138,                    /* $@6  */
  YYSYMBOL_typeDeclaration = 139,          /* typeDeclaration  */
  YYSYMBOL_140_7 = 140,                    /* $@7  */
  YYSYMBOL_typeName = 141,                 /* typeName  */
  YYSYMBOL_typeSMI = 142,                  /* typeSMI  */
  YYSYMBOL_typeSMIandSPPI = 143,           /* typeSMIandSPPI  */
  YYSYMBOL_typeSMIonly = 144,              /* typeSMIonly  */
  YYSYMBOL_typeSPPIonly = 145,             /* typeSPPIonly  */
  YYSYMBOL_typeDeclarationRHS = 146,       /* typeDeclarationRHS  */
  YYSYMBOL_147_8 = 147,                    /* $@8  */
  YYSYMBOL_148_9 = 148,                    /* $@9  */
  YYSYMBOL_conceptualTable = 149,          /* conceptualTable  */
  YYSYMBOL_row = 150,                      /* row  */
  YYSYMBOL_entryType = 151,                /* entryType  */
  YYSYMBOL_sequenceItems = 152,            /* sequenceItems  */
  YYSYMBOL_sequenceItem = 153,             /* sequenceItem  */
  YYSYMBOL_Syntax = 154,                   /* Syntax  */
  YYSYMBOL_sequenceSyntax = 155,           /* sequenceSyntax  */
  YYSYMBOL_NamedBits = 156,                /* NamedBits  */
  YYSYMBOL_NamedBit = 157,                 /* NamedBit  */
  YYSYMBOL_158_10 = 158,                   /* $@10  */
  YYSYMBOL_objectIdentityClause = 159,     /* objectIdentityClause  */
  YYSYMBOL_160_11 = 160,                   /* $@11  */
  YYSYMBOL_161_12 = 161,                   /* $@12  */
  YYSYMBOL_162_13 = 162,                   /* $@13  */
  YYSYMBOL_objectTypeClause = 163,         /* objectTypeClause  */
  YYSYMBOL_164_14 = 164,                   /* $@14  */
  YYSYMBOL_165_15 = 165,                   /* $@15  */
  YYSYMBOL_descriptionClause = 166,        /* descriptionClause  */
  YYSYMBOL_trapTypeClause = 167,           /* trapTypeClause  */
  YYSYMBOL_168_16 = 168,                   /* $@16  */
  YYSYMBOL_169_17 = 169,                   /* $@17  */
  YYSYMBOL_VarPart = 170,                  /* VarPart  */
  YYSYMBOL_VarTypes = 171,                 /* VarTypes  */
  YYSYMBOL_VarType = 172,                  /* VarType  */
  YYSYMBOL_DescrPart = 173,                /* DescrPart  */
  YYSYMBOL_MaxOrPIBAccessPart = 174,       /* MaxOrPIBAccessPart  */
  YYSYMBOL_PibAccessPart = 175,            /* PibAccessPart  */
  YYSYMBOL_PibAccess = 176,                /* PibAccess  */
  YYSYMBOL_SPPIPibReferencesPart = 177,    /* SPPIPibReferencesPart  */
  YYSYMBOL_178_18 = 178,                   /* $@18  */
  YYSYMBOL_SPPIPibTagPart = 179,           /* SPPIPibTagPart  */
  YYSYMBOL_180_19 = 180,                   /* $@19  */
  YYSYMBOL_SPPIUniquePart = 181,           /* SPPIUniquePart  */
  YYSYMBOL_182_20 = 182,                   /* $@20  */
  YYSYMBOL_UniqueTypesPart = 183,          /* UniqueTypesPart  */
  YYSYMBOL_UniqueTypes = 184,              /* UniqueTypes  */
  YYSYMBOL_UniqueType = 185,               /* UniqueType  */
  YYSYMBOL_SPPIErrorsPart = 186,           /* SPPIErrorsPart  */
  YYSYMBOL_187_21 = 187,                   /* $@21  */
  YYSYMBOL_Errors = 188,                   /* Errors  */
  YYSYMBOL_Error = 189,                    /* Error  */
  YYSYMBOL_MaxAccessPart = 190,            /* MaxAccessPart  */
  YYSYMBOL_191_22 = 191,                   /* $@22  */
  YYSYMBOL_192_23 = 192,                   /* $@23  */
  YYSYMBOL_notificationTypeClause = 193,   /* notificationTypeClause  */
  YYSYMBOL_194_24 = 194,                   /* $@24  */
  YYSYMBOL_195_25 = 195,                   /* $@25  */
  YYSYMBOL_196_26 = 196,                   /* $@26  */
  YYSYMBOL_moduleIdentityClause = 197,     /* moduleIdentityClause  */
  YYSYMBOL_198_27 = 198,                   /* $@27  */
  YYSYMBOL_199_28 = 199,                   /* $@28  */
  YYSYMBOL_200_29 = 200,                   /* $@29  */
  YYSYMBOL_201_30 = 201,                   /* $@30  */
  YYSYMBOL_202_31 = 202,                   /* $@31  */
  YYSYMBOL_203_32 = 203,                   /* $@32  */
  YYSYMBOL_204_33 = 204,                   /* $@33  */
  YYSYMBOL_205_34 = 205,                   /* $@34  */
  YYSYMBOL_SubjectCategoriesPart = 206,    /* SubjectCategoriesPart  */
  YYSYMBOL_SubjectCategories = 207,        /* SubjectCategories  */
  YYSYMBOL_CategoryIDs = 208,              /* CategoryIDs  */
  YYSYMBOL_CategoryID = 209,               /* CategoryID  */
  YYSYMBOL_ObjectSyntax = 210,             /* ObjectSyntax  */
  YYSYMBOL_typeTag = 211,                  /* typeTag  */
  YYSYMBOL_sequenceObjectSyntax = 212,     /* sequenceObjectSyntax  */
  YYSYMBOL_valueofObjectSyntax = 213,      /* valueofObjectSyntax  */
  YYSYMBOL_SimpleSyntax = 214,             /* SimpleSyntax  */
  YYSYMBOL_215_35 = 215,                   /* $@35  */
  YYSYMBOL_216_36 = 216,                   /* $@36  */
  YYSYMBOL_217_37 = 217,                   /* $@37  */
  YYSYMBOL_218_38 = 218,                   /* $@38  */
  YYSYMBOL_219_39 = 219,                   /* $@39  */
  YYSYMBOL_valueofSimpleSyntax = 220,      /* valueofSimpleSyntax  */
  YYSYMBOL_sequenceSimpleSyntax = 221,     /* sequenceSimpleSyntax  */
  YYSYMBOL_ApplicationSyntax = 222,        /* ApplicationSyntax  */
  YYSYMBOL_sequenceApplicationSyntax = 223, /* sequenceApplicationSyntax  */
  YYSYMBOL_anySubType = 224,               /* anySubType  */
  YYSYMBOL_integerSubType = 225,           /* integerSubType  */
  YYSYMBOL_octetStringSubType = 226,       /* octetStringSubType  */
  YYSYMBOL_ranges = 227,                   /* ranges  */
  YYSYMBOL_range = 228,                    /* range  */
  YYSYMBOL_value = 229,                    /* value  */
  YYSYMBOL_enumSpec = 230,                 /* enumSpec  */
  YYSYMBOL_enumItems = 231,                /* enumItems  */
  YYSYMBOL_enumItem = 232,                 /* enumItem  */
  YYSYMBOL_233_40 = 233,                   /* $@40  */
  YYSYMBOL_enumNumber = 234,               /* enumNumber  */
  YYSYMBOL_Status = 235,                   /* Status  */
  YYSYMBOL_Status_Capabilities = 236,      /* Status_Capabilities  */
  YYSYMBOL_DisplayPart = 237,              /* DisplayPart  */
  YYSYMBOL_UnitsPart = 238,                /* UnitsPart  */
  YYSYMBOL_Access = 239,                   /* Access  */
  YYSYMBOL_IndexPart = 240,                /* IndexPart  */
  YYSYMBOL_241_41 = 241,                   /* $@41  */
  YYSYMBOL_242_42 = 242,                   /* $@42  */
  YYSYMBOL_MibIndex = 243,                 /* MibIndex  */
  YYSYMBOL_244_43 = 244,                   /* $@43  */
  YYSYMBOL_IndexTypes = 245,               /* IndexTypes  */
  YYSYMBOL_IndexType = 246,                /* IndexType  */
  YYSYMBOL_Index = 247,                    /* Index  */
  YYSYMBOL_Entry = 248,                    /* Entry  */
  YYSYMBOL_DefValPart = 249,               /* DefValPart  */
  YYSYMBOL_Value = 250,                    /* Value  */
  YYSYMBOL_BitsValue = 251,                /* BitsValue  */
  YYSYMBOL_BitNames = 252,                 /* BitNames  */
  YYSYMBOL_ObjectName = 253,               /* ObjectName  */
  YYSYMBOL_NotificationName = 254,         /* NotificationName  */
  YYSYMBOL_ReferPart = 255,                /* ReferPart  */
  YYSYMBOL_RevisionPart = 256,             /* RevisionPart  */
  YYSYMBOL_Revisions = 257,                /* Revisions  */
  YYSYMBOL_Revision = 258,                 /* Revision  */
  YYSYMBOL_259_44 = 259,                   /* $@44  */
  YYSYMBOL_NotificationObjectsPart = 260,  /* NotificationObjectsPart  */
  YYSYMBOL_ObjectGroupObjectsPart = 261,   /* ObjectGroupObjectsPart  */
  YYSYMBOL_Objects = 262,                  /* Objects  */
  YYSYMBOL_Object = 263,                   /* Object  */
  YYSYMBOL_NotificationsPart = 264,        /* NotificationsPart  */
  YYSYMBOL_Notifications = 265,            /* Notifications  */
  YYSYMBOL_Notification = 266,             /* Notification  */
  YYSYMBOL_Text = 267,                     /* Text  */
  YYSYMBOL_ExtUTCTime = 268,               /* ExtUTCTime  */
  YYSYMBOL_objectIdentifier = 269,         /* objectIdentifier  */
  YYSYMBOL_270_45 = 270,                   /* $@45  */
  YYSYMBOL_subidentifiers = 271,           /* subidentifiers  */
  YYSYMBOL_subidentifier = 272,            /* subidentifier  */
  YYSYMBOL_objectIdentifier_defval = 273,  /* objectIdentifier_defval  */
  YYSYMBOL_subidentifiers_defval = 274,    /* subidentifiers_defval  */
  YYSYMBOL_subidentifier_defval = 275,     /* subidentifier_defval  */
  YYSYMBOL_objectGroupClause = 276,        /* objectGroupClause  */
  YYSYMBOL_277_46 = 277,                   /* $@46  */
  YYSYMBOL_278_47 = 278,                   /* $@47  */
  YYSYMBOL_279_48 = 279,                   /* $@48  */
  YYSYMBOL_notificationGroupClause = 280,  /* notificationGroupClause  */
  YYSYMBOL_281_49 = 281,                   /* $@49  */
  YYSYMBOL_282_50 = 282,                   /* $@50  */
  YYSYMBOL_283_51 = 283,                   /* $@51  */
  YYSYMBOL_moduleComplianceClause = 284,   /* moduleComplianceClause  */
  YYSYMBOL_285_52 = 285,                   /* $@52  */
  YYSYMBOL_286_53 = 286,                   /* $@53  */
  YYSYMBOL_287_54 = 287,                   /* $@54  */
  YYSYMBOL_ComplianceModulePart = 288,     /* ComplianceModulePart  */
  YYSYMBOL_ComplianceModules = 289,        /* ComplianceModules  */
  YYSYMBOL_ComplianceModule = 290,         /* ComplianceModule  */
  YYSYMBOL_291_55 = 291,                   /* $@55  */
  YYSYMBOL_ComplianceModuleName = 292,     /* ComplianceModuleName  */
  YYSYMBOL_MandatoryPart = 293,            /* MandatoryPart  */
  YYSYMBOL_MandatoryGroups = 294,          /* MandatoryGroups  */
  YYSYMBOL_MandatoryGroup = 295,           /* MandatoryGroup  */
  YYSYMBOL_CompliancePart = 296,           /* CompliancePart  */
  YYSYMBOL_Compliances = 297,              /* Compliances  */
  YYSYMBOL_Compliance = 298,               /* Compliance  */
  YYSYMBOL_ComplianceGroup = 299,          /* ComplianceGroup  */
  YYSYMBOL_300_56 = 300,                   /* $@56  */
  YYSYMBOL_ComplianceObject = 301,         /* ComplianceObject  */
  YYSYMBOL_302_57 = 302,                   /* $@57  */
  YYSYMBOL_SyntaxPart = 303,               /* SyntaxPart  */
  YYSYMBOL_WriteSyntaxPart = 304,          /* WriteSyntaxPart  */
  YYSYMBOL_WriteSyntax = 305,              /* WriteSyntax  */
  YYSYMBOL_AccessPart = 306,               /* AccessPart  */
  YYSYMBOL_agentCapabilitiesClause = 307,  /* agentCapabilitiesClause  */
  YYSYMBOL_308_58 = 308,                   /* $@58  */
  YYSYMBOL_309_59 = 309,                   /* $@59  */
  YYSYMBOL_310_60 = 310,                   /* $@60  */
  YYSYMBOL_ModulePart_Capabilities = 311,  /* ModulePart_Capabilities  */
  YYSYMBOL_Modules_Capabilities = 312,     /* Modules_Capabilities  */
  YYSYMBOL_Module_Capabilities = 313,      /* Module_Capabilities  */
  YYSYMBOL_314_61 = 314,                   /* $@61  */
  YYSYMBOL_CapabilitiesGroups = 315,       /* CapabilitiesGroups  */
  YYSYMBOL_CapabilitiesGroup = 316,        /* CapabilitiesGroup  */
  YYSYMBOL_ModuleName_Capabilities = 317,  /* ModuleName_Capabilities  */
  YYSYMBOL_VariationPart = 318,            /* VariationPart  */
  YYSYMBOL_Variations = 319,               /* Variations  */
  YYSYMBOL_Variation = 320,                /* Variation  */
  YYSYMBOL_321_62 = 321,                   /* $@62  */
  YYSYMBOL_322_63 = 322,                   /* $@63  */
  YYSYMBOL_323_64 = 323,                   /* $@64  */
  YYSYMBOL_324_65 = 324,                   /* $@65  */
  YYSYMBOL_325_66 = 325,                   /* $@66  */
  YYSYMBOL_VariationAccessPart = 326,      /* VariationAccessPart  */
  YYSYMBOL_VariationAccess = 327,          /* VariationAccess  */
  YYSYMBOL_CreationPart = 328,             /* CreationPart  */
  YYSYMBOL_Cells = 329,                    /* Cells  */
  YYSYMBOL_Cell = 330                      /* Cell  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  6
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   664

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  107
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  224
/* YYNRULES -- Number of rules.  */
#define YYNRULES  427
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  712

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   351


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     101,   102,     2,     2,   100,     2,   105,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    99,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   103,     2,   104,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    97,   106,    98,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,  1581,  1581,  1586,  1591,  1593,  1602,  1601,  1663,  1666,
    1669,  1671,  1680,  1683,  1686,  1701,  1703,  1702,  1723,  1726,
    1730,  1732,  1736,  1781,  1783,  1791,  1797,  1803,  1819,  1829,
    1835,  1836,  1837,  1838,  1839,  1840,  1841,  1842,  1843,  1844,
    1845,  1846,  1847,  1850,  1851,  1852,  1853,  1854,  1855,  1856,
    1859,  1860,  1863,  1875,  1878,  1882,  1884,  1888,  1893,  1898,
    1903,  1908,  1913,  1918,  1923,  1928,  1933,  1938,  1943,  1948,
    1963,  1975,  1962,  2008,  2009,  2010,  2011,  2012,  2013,  2014,
    2015,  2016,  2017,  2021,  2020,  2050,  2055,  2071,  2070,  2111,
    2110,  2276,  2280,  2304,  2318,  2319,  2328,  2329,  2330,  2331,
    2332,  2335,  2336,  2337,  2340,  2341,  2344,  2361,  2392,  2360,
    2428,  2436,  2450,  2495,  2503,  2509,  2529,  2612,  2618,  2640,
    2644,  2649,  2682,  2688,  2702,  2701,  2737,  2747,  2772,  2736,
    2800,  2810,  2799,  3106,  3115,  3123,  3133,  3122,  3205,  3210,
    3215,  3225,  3247,  3253,  3259,  3262,  3266,  3275,  3278,  3282,
    3286,  3291,  3290,  3298,  3302,  3301,  3309,  3314,  3313,  3321,
    3324,  3327,  3330,  3336,  3350,  3355,  3354,  3362,  3365,  3371,
    3385,  3407,  3406,  3418,  3417,  3431,  3441,  3461,  3430,  3492,
    3502,  3527,  3531,  3535,  3542,  3549,  3553,  3491,  3599,  3606,
    3613,  3620,  3626,  3641,  3662,  3685,  3689,  3709,  3714,  3719,
    3724,  3741,  3743,  3751,  3756,  3773,  3782,  3796,  3795,  3815,
    3814,  3829,  3856,  3855,  3887,  3886,  3940,  3987,  4042,  4092,
    4098,  4097,  4109,  4155,  4196,  4203,  4210,  4216,  4223,  4230,
    4256,  4279,  4299,  4316,  4349,  4353,  4378,  4382,  4388,  4416,
    4442,  4479,  4505,  4538,  4562,  4589,  4617,  4655,  4701,  4727,
    4764,  4790,  4827,  4853,  4896,  4924,  4950,  4976,  5000,  5028,
    5068,  5094,  5119,  5146,  5163,  5180,  5199,  5206,  5216,  5228,
    5234,  5248,  5255,  5265,  5271,  5277,  5283,  5289,  5312,  5339,
    5345,  5351,  5365,  5364,  5386,  5401,  5410,  5469,  5485,  5495,
    5500,  5510,  5515,  5582,  5581,  5599,  5610,  5609,  5623,  5629,
    5628,  5662,  5667,  5673,  5687,  5692,  5698,  5708,  5714,  5729,
    5733,  5735,  5743,  5746,  5749,  5755,  5768,  5774,  5780,  5790,
    5793,  5796,  5799,  5801,  5806,  5805,  5836,  5841,  5846,  5852,
    5858,  5871,  5883,  5889,  5895,  5908,  5919,  5930,  5936,  5936,
    5951,  5955,  5964,  6058,  6162,  6186,  6246,  6315,  6319,  6321,
    6325,  6327,  6332,  6342,  6361,  6331,  6392,  6402,  6424,  6391,
    6456,  6466,  6484,  6455,  6548,  6554,  6558,  6594,  6593,  6622,
    6631,  6641,  6646,  6651,  6656,  6662,  6675,  6698,  6705,  6712,
    6716,  6783,  6789,  6798,  6797,  6831,  6830,  6877,  6886,  6891,
    6903,  6908,  6914,  6920,  6929,  6935,  6945,  6967,  6934,  7002,
    7005,  7008,  7010,  7015,  7014,  7041,  7051,  7068,  7074,  7083,
    7093,  7096,  7099,  7101,  7106,  7114,  7121,  7129,  7136,  7105,
    7159,  7162,  7165,  7230,  7233,  7236,  7238,  7242
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "DOT_DOT",
  "COLON_COLON_EQUAL", "UPPERCASE_IDENTIFIER", "LOWERCASE_IDENTIFIER",
  "NUMBER", "NEGATIVENUMBER", "NUMBER64", "NEGATIVENUMBER64", "BIN_STRING",
  "HEX_STRING", "QUOTED_STRING", "ACCESS", "AGENT_CAPABILITIES",
  "APPLICATION", "AUGMENTS", "BEGIN_", "BITS", "CHOICE", "CONTACT_INFO",
  "CREATION_REQUIRES", "COUNTER32", "COUNTER64", "DEFINITIONS", "DEFVAL",
  "DESCRIPTION", "DISPLAY_HINT", "END", "ENTERPRISE", "EXPORTS", "EXTENDS",
  "FROM", "GROUP", "GAUGE32", "IDENTIFIER", "IMPLICIT", "IMPLIED",
  "IMPORTS", "INCLUDES", "INDEX", "INSTALL_ERRORS", "INTEGER", "INTEGER32",
  "INTEGER64", "IPADDRESS", "LAST_UPDATED", "MACRO", "MANDATORY_GROUPS",
  "MAX_ACCESS", "MIN_ACCESS", "MODULE", "MODULE_COMPLIANCE",
  "MODULE_IDENTITY", "NOT_ACCESSIBLE", "NOTIFICATIONS",
  "NOTIFICATION_GROUP", "NOTIFICATION_TYPE", "OBJECT", "OBJECT_GROUP",
  "OBJECT_IDENTITY", "OBJECT_TYPE", "OBJECTS", "OCTET", "OF",
  "ORGANIZATION", "OPAQUE", "PIB_ACCESS", "PIB_DEFINITIONS", "PIB_INDEX",
  "PIB_MIN_ACCESS", "PIB_REFERENCES", "PIB_TAG", "POLICY_ACCESS",
  "PRODUCT_RELEASE", "REFERENCE", "REVISION", "SEQUENCE", "SIZE", "STATUS",
  "STRING", "SUBJECT_CATEGORIES", "SUPPORTS", "SYNTAX",
  "TEXTUAL_CONVENTION", "TIMETICKS", "TRAP_TYPE", "UNIQUENESS", "UNITS",
  "UNIVERSAL", "UNSIGNED32", "UNSIGNED64", "VALUE", "VARIABLES",
  "VARIATION", "WRITE_SYNTAX", "'{'", "'}'", "';'", "','", "'('", "')'",
  "'['", "']'", "'.'", "'|'", "$accept", "mibFile", "modules", "module",
  "$@1", "moduleOid", "definitions", "linkagePart", "linkageClause",
  "exportsClause", "$@2", "importPart", "imports", "import",
  "importIdentifiers", "importIdentifier", "importedKeyword",
  "importedSMIKeyword", "importedSPPIKeyword", "moduleName",
  "declarationPart", "declarations", "declaration", "macroClause", "$@3",
  "$@4", "macroName", "choiceClause", "$@5", "fuzzy_lowercase_identifier",
  "valueDeclaration", "$@6", "typeDeclaration", "$@7", "typeName",
  "typeSMI", "typeSMIandSPPI", "typeSMIonly", "typeSPPIonly",
  "typeDeclarationRHS", "$@8", "$@9", "conceptualTable", "row",
  "entryType", "sequenceItems", "sequenceItem", "Syntax", "sequenceSyntax",
  "NamedBits", "NamedBit", "$@10", "objectIdentityClause", "$@11", "$@12",
  "$@13", "objectTypeClause", "$@14", "$@15", "descriptionClause",
  "trapTypeClause", "$@16", "$@17", "VarPart", "VarTypes", "VarType",
  "DescrPart", "MaxOrPIBAccessPart", "PibAccessPart", "PibAccess",
  "SPPIPibReferencesPart", "$@18", "SPPIPibTagPart", "$@19",
  "SPPIUniquePart", "$@20", "UniqueTypesPart", "UniqueTypes", "UniqueType",
  "SPPIErrorsPart", "$@21", "Errors", "Error", "MaxAccessPart", "$@22",
  "$@23", "notificationTypeClause", "$@24", "$@25", "$@26",
  "moduleIdentityClause", "$@27", "$@28", "$@29", "$@30", "$@31", "$@32",
  "$@33", "$@34", "SubjectCategoriesPart", "SubjectCategories",
  "CategoryIDs", "CategoryID", "ObjectSyntax", "typeTag",
  "sequenceObjectSyntax", "valueofObjectSyntax", "SimpleSyntax", "$@35",
  "$@36", "$@37", "$@38", "$@39", "valueofSimpleSyntax",
  "sequenceSimpleSyntax", "ApplicationSyntax", "sequenceApplicationSyntax",
  "anySubType", "integerSubType", "octetStringSubType", "ranges", "range",
  "value", "enumSpec", "enumItems", "enumItem", "$@40", "enumNumber",
  "Status", "Status_Capabilities", "DisplayPart", "UnitsPart", "Access",
  "IndexPart", "$@41", "$@42", "MibIndex", "$@43", "IndexTypes",
  "IndexType", "Index", "Entry", "DefValPart", "Value", "BitsValue",
  "BitNames", "ObjectName", "NotificationName", "ReferPart",
  "RevisionPart", "Revisions", "Revision", "$@44",
  "NotificationObjectsPart", "ObjectGroupObjectsPart", "Objects", "Object",
  "NotificationsPart", "Notifications", "Notification", "Text",
  "ExtUTCTime", "objectIdentifier", "$@45", "subidentifiers",
  "subidentifier", "objectIdentifier_defval", "subidentifiers_defval",
  "subidentifier_defval", "objectGroupClause", "$@46", "$@47", "$@48",
  "notificationGroupClause", "$@49", "$@50", "$@51",
  "moduleComplianceClause", "$@52", "$@53", "$@54", "ComplianceModulePart",
  "ComplianceModules", "ComplianceModule", "$@55", "ComplianceModuleName",
  "MandatoryPart", "MandatoryGroups", "MandatoryGroup", "CompliancePart",
  "Compliances", "Compliance", "ComplianceGroup", "$@56",
  "ComplianceObject", "$@57", "SyntaxPart", "WriteSyntaxPart",
  "WriteSyntax", "AccessPart", "agentCapabilitiesClause", "$@58", "$@59",
  "$@60", "ModulePart_Capabilities", "Modules_Capabilities",
  "Module_Capabilities", "$@61", "CapabilitiesGroups", "CapabilitiesGroup",
  "ModuleName_Capabilities", "VariationPart", "Variations", "Variation",
  "$@62", "$@63", "$@64", "$@65", "$@66", "VariationAccessPart",
  "VariationAccess", "CreationPart", "Cells", "Cell", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-461)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-410)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      19,  -461,    36,    19,  -461,  -461,  -461,  -461,   -58,  -461,
      -5,   -31,    54,  -461,  -461,    78,  -461,    -1,     9,  -461,
      38,  -461,    54,  -461,   107,   154,   160,  -461,   138,    88,
      90,  -461,   153,  -461,   186,    95,   561,   350,  -461,    93,
    -461,  -461,  -461,  -461,  -461,  -461,  -461,  -461,  -461,  -461,
    -461,  -461,  -461,  -461,  -461,  -461,  -461,  -461,  -461,  -461,
    -461,  -461,  -461,  -461,  -461,    97,   561,  -461,   -23,  -461,
    -461,  -461,  -461,    99,   195,    70,  -461,  -461,  -461,  -461,
    -461,  -461,  -461,  -461,  -461,  -461,  -461,  -461,  -461,  -461,
    -461,  -461,  -461,  -461,  -461,  -461,   171,   496,  -461,  -461,
    -461,   115,  -461,  -461,  -461,  -461,  -461,  -461,  -461,  -461,
    -461,  -461,  -461,  -461,  -461,  -461,  -461,  -461,  -461,  -461,
    -461,    19,   561,  -461,   140,   141,   146,   151,   149,   155,
     158,   191,  -461,  -461,   166,   156,   129,   213,  -461,  -461,
    -461,  -461,  -461,  -461,  -461,  -461,  -461,  -461,  -461,   183,
    -461,   202,   143,   134,   157,   142,   167,   173,   152,   161,
     204,   227,   205,     2,   145,  -461,   -47,   -47,   150,   -18,
     159,   150,   -47,   203,   162,   169,   -49,  -461,   -47,   150,
     150,    -2,   148,  -461,  -461,  -461,  -461,  -461,  -461,  -461,
      52,  -461,  -461,   244,   233,   165,   174,   170,  -461,   176,
     178,   177,   179,   244,   242,  -461,   184,  -461,    35,   185,
    -461,  -461,   257,   187,   265,  -461,  -461,  -461,  -461,  -461,
    -461,   175,  -461,   150,   185,   150,  -461,  -461,  -461,   -47,
     188,   193,  -461,   270,   277,   256,  -461,  -461,  -461,   279,
     283,   286,     5,  -461,  -461,   268,   207,  -461,   244,   292,
     254,  -461,   244,  -461,   244,   275,  -461,   223,  -461,   210,
    -461,  -461,  -461,  -461,  -461,  -461,   206,     3,  -461,   303,
    -461,  -461,    15,  -461,  -461,  -461,    37,  -461,  -461,  -461,
    -461,  -461,   169,  -461,  -461,   441,    41,  -461,   242,   229,
     208,   209,   -47,   242,   242,    13,  -461,    44,  -461,  -461,
     287,   214,   212,   217,  -461,   305,    48,   293,  -461,    51,
    -461,  -461,   294,   242,   316,   225,   230,   299,   175,  -461,
     175,   175,   228,  -461,   257,   231,  -461,   265,  -461,   -47,
    -461,   -47,   -47,   -47,   -47,   -47,  -461,   -47,   295,   247,
    -461,   -47,   -47,  -461,  -461,  -461,  -461,  -461,  -461,   277,
    -461,   244,   296,   297,  -461,  -461,  -461,  -461,  -461,  -461,
    -461,  -461,  -461,   258,  -461,   329,  -461,  -461,  -461,   242,
     330,  -461,   292,  -461,  -461,  -461,   242,  -461,  -461,   242,
    -461,  -461,   311,  -461,  -461,   242,   263,     6,  -461,  -461,
     333,  -461,   126,  -461,  -461,  -461,  -461,  -461,  -461,  -461,
    -461,   -47,   -47,  -461,  -461,  -461,   314,  -461,  -461,   263,
     329,   329,  -461,   269,  -461,  -461,  -461,  -461,   241,  -461,
     278,  -461,  -461,  -461,   263,   242,    55,  -461,  -461,  -461,
     242,   341,   245,   246,  -461,  -461,   248,  -461,  -461,   242,
     342,  -461,  -461,   255,  -461,   273,   263,  -461,   242,   263,
     263,   302,  -461,  -461,  -461,  -461,   351,  -461,  -461,  -461,
    -461,   260,  -461,   262,   244,   356,  -461,   357,   358,   359,
     363,   302,  -461,   263,  -461,  -461,   263,  -461,   272,  -461,
    -461,   336,   271,   354,   280,   281,   114,  -461,   284,  -461,
     300,   304,   282,  -461,   288,   242,   334,  -461,   242,  -461,
    -461,  -461,   335,  -461,   385,   387,   300,  -461,   233,  -461,
    -461,  -461,  -461,   263,   301,  -461,   307,   317,   312,    -3,
     320,   352,  -461,   322,  -461,  -461,   323,    20,  -461,   370,
    -461,  -461,  -461,  -461,  -461,  -461,    -3,  -461,  -461,  -461,
    -461,  -461,   360,  -461,   392,   324,  -461,  -461,   361,   242,
    -461,    58,  -461,  -461,  -461,  -461,   325,   326,   313,    59,
    -461,  -461,   331,   332,  -461,   338,  -461,  -461,  -461,   374,
     339,  -461,  -461,   420,  -461,   392,   340,  -461,  -461,   337,
    -461,   404,   355,  -461,   242,   233,   343,  -461,    64,  -461,
     345,  -461,  -461,   346,   347,   393,   353,   362,   429,   305,
    -461,   355,  -461,  -461,  -461,   233,   -13,   348,  -461,  -461,
    -461,  -461,  -461,    67,  -461,  -461,  -461,   364,    63,   366,
    -461,   436,  -461,  -461,  -461,   329,   329,   421,  -461,  -461,
     348,  -461,  -461,  -461,  -461,   393,   368,   349,  -461,  -461,
    -461,  -461,  -461,  -461,  -461,  -461,  -461,  -461,   172,  -461,
    -461,   369,  -461,   424,   372,  -461,  -461,   242,  -461,  -461,
    -461,  -461,  -461,   371,  -461,   373,   375,   376,   182,  -461,
    -461,   380,   242,  -461,  -461,   339,  -461,   445,  -461,   447,
    -461,   371,  -461,  -461,  -461,   381,  -461,   378,  -461,  -461,
     343,  -461,  -461,   442,   449,   435,  -461,  -461,   384,  -461,
    -461,   404,  -461,    77,  -461,  -461,  -461,  -461,   431,  -461,
     242,  -461
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       3,    52,     0,     2,     4,     6,     1,     5,     9,   338,
       0,     0,     0,    10,    11,     0,     8,    86,    85,   344,
       0,   342,   339,   340,     0,     0,     0,   341,    15,     0,
     343,    16,    13,   345,     0,     0,    19,     0,    12,     0,
      17,    26,    25,    43,    30,    44,    45,    46,    31,    50,
      32,    33,    34,    35,    47,    48,    36,    37,    38,    39,
      40,    41,    49,    42,    51,     0,    18,    20,     0,    23,
      27,    28,    29,     0,    86,    85,    82,   101,   103,   102,
      99,   104,    96,    81,    73,    80,    76,    79,    77,    74,
      98,    78,    97,    75,   100,   105,     0,     0,    55,    68,
      70,    87,    58,    57,    89,    92,    94,    95,    93,    59,
      60,    61,    62,    63,    65,    66,    64,    67,   346,    14,
      21,     0,     0,    69,     0,     0,     0,     0,     0,     0,
       0,     0,     7,    56,     0,     0,     0,     0,    22,    24,
     127,   131,   176,   180,   353,   357,   361,   396,    71,     0,
     136,     0,     0,     0,   327,   189,     0,     0,     0,     0,
       0,     0,     0,   112,     0,    83,   266,   266,   241,   206,
     211,   250,   266,     0,     0,   246,     0,   107,   266,   243,
     252,     0,     0,   110,    90,   197,   198,   199,   106,   117,
       0,   195,   200,     0,     0,     0,     0,     0,   181,     0,
       0,     0,     0,     0,     0,    72,     0,   338,     0,     0,
     217,   222,     0,     0,     0,   239,   240,   264,   265,   248,
     249,     0,   242,     0,     0,     0,   251,   238,   263,   266,
     219,     0,   247,     0,     0,   289,   245,   244,   253,     0,
       0,     0,    52,   196,   286,     0,   291,   338,     0,     0,
       0,   338,     0,   338,     0,     0,   336,     0,   338,   139,
     274,   273,   276,   275,   278,   277,     0,     0,   269,   271,
     215,   124,     0,   122,    84,   282,     0,   280,   208,   210,
     213,   224,     0,   112,   111,     0,     0,   114,     0,     0,
       0,     0,     0,     0,     0,   147,   331,     0,   329,   316,
       0,   193,     0,   190,   191,     0,     0,     0,   335,     0,
     333,   317,     0,     0,     0,     0,     0,   144,     0,   267,
       0,     0,     0,   118,     0,     0,   279,     0,   221,   266,
     120,   266,   266,   266,   266,   266,   261,   266,     0,     0,
     259,   266,   266,   262,   116,   119,   203,   204,   113,     0,
     288,     0,     0,     0,   218,   223,   216,   128,   290,   173,
     171,   150,   149,   153,   146,     0,   145,   326,   338,     0,
       0,   188,     0,   337,   182,   328,     0,   332,   338,     0,
     362,   287,     0,    88,   338,     0,   319,     0,   270,   272,
       0,   123,     0,   281,   121,   255,   260,   256,   234,   235,
     254,   266,   266,   258,   257,   115,     0,   201,   202,   319,
       0,     0,   151,   156,   292,   148,   330,   177,     0,   192,
       0,   354,   334,   358,   319,     0,     0,   140,   142,   143,
       0,     0,     0,     0,   284,   285,     0,   237,   236,     0,
       0,   174,   172,     0,   154,     0,   319,   194,     0,   319,
     319,     0,   397,   138,   338,   318,     0,   268,   125,   283,
     108,     0,   338,     0,     0,     0,   183,     0,     0,   371,
       0,   364,   365,   319,   141,   137,   319,   338,     0,   307,
     338,   133,     0,     0,     0,     0,   370,   367,     0,   366,
     400,     0,     0,   152,     0,     0,   167,   338,     0,   338,
     338,   369,   373,   338,     0,     0,   399,   401,     0,   129,
     155,   134,   165,   319,     0,   184,     0,     0,     0,   378,
       0,   338,   403,     0,   402,   109,     0,   298,   178,     0,
     355,   359,   338,   383,   385,   368,   377,   379,   381,   382,
     363,   408,     0,   338,     0,     0,   296,   293,   301,     0,
     376,     0,   374,   338,   338,   380,     0,     0,     0,     0,
     168,   338,     0,     0,   299,   159,   185,   372,   338,     0,
     388,   338,   398,     0,   166,     0,     0,   338,   338,     0,
     157,   309,   321,   375,     0,     0,   390,   407,     0,   405,
       0,   169,   295,     0,     0,   338,     0,     0,     0,     0,
     186,   320,   322,   384,   387,     0,   394,   411,   338,   170,
     297,   294,   338,     0,   302,   305,   306,   338,     0,     0,
     324,     0,   323,   391,   389,     0,     0,     0,   338,   404,
     410,   412,   406,   304,   300,   338,     0,   160,   162,   164,
     231,   225,   226,   227,   228,   229,   230,   232,   313,   310,
     205,     0,   338,     0,     0,   392,   393,     0,   414,   413,
     303,   158,   338,   314,   351,     0,   312,     0,   347,   348,
     308,     0,     0,   338,   386,   388,   163,     0,   311,     0,
     233,     0,   349,   132,   325,     0,   415,     0,   315,   187,
     390,   350,   416,   421,     0,   424,   422,   420,     0,   417,
     338,   309,   427,     0,   425,   418,   423,   338,     0,   426,
       0,   419
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -461,  -461,  -461,   467,  -461,  -461,  -461,  -461,  -461,  -461,
    -461,  -461,  -461,   407,  -461,   367,  -461,  -461,  -461,    29,
    -461,  -461,   386,  -461,  -461,  -461,  -461,  -461,  -461,    -4,
    -461,  -461,  -461,  -461,  -461,  -461,  -461,  -461,  -461,  -461,
    -461,  -461,  -461,   249,  -461,  -461,   144,  -192,  -461,  -461,
     168,  -461,  -461,  -461,  -461,  -461,  -461,  -461,  -461,  -461,
    -461,  -461,  -461,  -461,  -461,    42,  -461,  -461,  -461,  -461,
    -461,  -461,  -461,  -461,  -461,  -461,  -461,  -461,  -167,  -461,
    -461,  -461,   -77,  -461,  -461,  -461,  -461,  -461,  -461,  -461,
    -461,  -461,  -461,  -461,  -461,  -461,  -461,  -461,  -461,  -461,
    -461,  -461,   127,  -461,  -461,  -461,  -461,   319,  -461,  -461,
    -461,  -461,  -461,  -461,  -461,  -461,  -461,  -161,  -145,  -156,
     189,   190,   192,  -194,  -461,   194,  -461,  -461,  -199,  -461,
    -461,  -461,  -398,  -461,  -461,  -461,  -461,  -461,  -461,  -132,
    -108,  -460,  -195,  -461,  -461,  -461,  -246,    17,  -384,  -461,
    -461,   -86,  -461,  -461,  -461,   266,   180,  -461,  -461,   196,
    -285,   -83,    -9,  -461,  -461,   500,  -461,  -461,  -150,  -461,
    -461,  -461,  -461,  -461,  -461,  -461,  -461,  -461,  -461,  -461,
    -461,  -461,  -461,    53,  -461,  -461,  -461,  -461,   -42,  -461,
    -461,    -8,  -461,  -461,  -461,  -461,  -146,  -160,  -461,  -461,
    -461,  -461,  -461,  -461,  -461,  -461,    30,  -461,  -461,   -73,
    -461,  -461,  -461,   -93,  -461,  -461,  -461,  -461,  -461,  -461,
    -461,  -461,  -461,  -169
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     2,     3,     4,     8,    10,    15,    37,    38,    32,
      35,    65,    66,    67,    68,    69,    70,    71,    72,   182,
      96,    97,    98,    99,   134,   160,   100,   183,   213,    21,
     102,   135,   103,   137,   104,   105,   106,   107,   108,   184,
     235,   476,   185,   186,   187,   286,   287,   188,   344,   272,
     273,   322,   109,   124,   152,   409,   110,   125,   153,   496,
     111,   136,   162,   317,   426,   427,   386,   363,   364,   365,
     413,   443,   445,   463,   581,   596,   636,   637,   638,   513,
     526,   559,   560,   366,   411,   410,   112,   126,   154,   446,
     113,   127,   155,   250,   420,   483,   529,   582,   621,   198,
     302,   303,   304,   189,   190,   345,   649,   191,   223,   224,
     225,   209,   282,   650,   346,   192,   347,   215,   228,   217,
     267,   268,   269,   218,   276,   277,   325,   436,   245,   382,
     289,   295,   415,   548,   563,   562,   565,   579,   613,   614,
     615,   478,   598,   651,   665,   666,   479,   308,   431,   600,
     601,   602,   653,   196,   200,   297,   298,   202,   309,   310,
     257,   374,   299,    12,    22,    23,   667,   668,   669,   114,
     128,   156,   449,   115,   129,   157,   450,   116,   130,   158,
     424,   470,   471,   472,   502,   487,   519,   551,   552,   535,
     536,   537,   538,   553,   539,   554,   586,   606,   624,   627,
     117,   131,   159,   473,   505,   506,   507,   542,   588,   589,
     522,   629,   630,   631,   675,   690,   693,   701,   708,   695,
     697,   699,   703,   704
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      11,   296,   246,   350,   255,   296,   219,   211,   357,   358,
     121,   227,   441,   442,   239,   270,   233,   236,   210,   232,
      13,   216,   220,   222,     1,   440,   226,   359,   380,     5,
     279,   533,     5,   101,   237,   238,     6,   545,   625,     9,
     451,    20,   260,   261,   262,   263,   264,   265,   234,   300,
     214,    20,   546,   307,   208,   312,   534,   242,   626,    17,
      18,    19,   465,   360,    14,   467,   468,    16,   281,   640,
     641,   642,   643,   644,   645,   646,   647,   122,   278,  -209,
     280,   361,    24,  -207,   417,  -395,   211,   362,   240,   490,
     547,   421,   491,   101,   423,   169,   170,   210,   356,  -214,
     429,   576,  -214,   208,   -52,   319,   208,   -52,   432,   320,
      25,   173,   320,   323,   266,   324,   174,   593,   594,  -338,
    -338,  -338,   296,  -360,  -179,    28,   328,  -356,  -175,   527,
    -352,  -126,  -130,   434,   435,   326,   355,   327,   428,   348,
     452,   349,   367,    26,   368,   455,   375,   354,   368,   377,
     138,   378,   406,   453,   460,   454,   567,   574,   568,   575,
     648,    29,   607,   466,   608,   634,    30,   635,   394,    31,
     395,   396,   397,   398,   399,   706,   400,   707,   663,   664,
     403,   404,   260,   261,   262,   263,   264,   265,   681,   664,
      33,    34,    36,    39,    40,   118,   119,   123,   259,   -91,
     132,   140,  -135,   141,   142,   143,   147,   163,   428,   144,
     511,   146,   145,   515,   148,   149,   150,   151,   194,   161,
     195,   164,   165,   193,   197,   166,   167,   655,   656,   201,
     199,   206,   203,   205,   494,   207,   204,   168,   163,   229,
     437,   438,   212,   230,   311,   169,   170,   171,   172,   315,
     244,   221,   164,   241,   248,   256,   166,   167,   252,   254,
    -212,   173,   247,   271,   566,   481,   174,   249,   168,   175,
     231,   275,   266,   251,   253,   283,   169,   170,   171,   172,
     176,   258,   214,   285,   288,   274,   290,   177,   178,  -220,
     291,   292,   173,   179,   180,   293,   294,   174,   301,   603,
     175,   305,   313,   314,   316,   181,   321,   318,   570,   351,
     371,   176,   352,   353,   369,   370,   525,   372,   373,   178,
     376,   379,   381,   383,   179,   180,   385,   384,   402,   390,
     412,   401,   392,   407,   408,   414,   181,   418,   425,   430,
     433,   439,   444,   447,   448,   456,   461,   457,   458,   616,
     459,    73,   462,   464,   469,    74,    75,   477,   475,   480,
     482,   484,   485,   495,   486,    76,   616,   488,   497,   311,
     493,   639,   674,    77,    78,   498,   512,   499,   500,   -54,
     509,   503,   658,   504,   518,    79,   510,   684,   508,   616,
     521,   523,  -409,   604,    80,    81,    82,   549,   558,   528,
     556,   584,   564,    83,    84,   530,   671,    85,    86,   532,
      87,    88,    89,   623,   573,   531,   639,    90,   540,   543,
     544,   561,   571,   585,   572,   711,   580,   590,   577,   578,
     597,   612,   599,   619,   595,    91,    92,    93,   592,   605,
     654,    94,    95,   628,   610,   611,   329,   609,   657,   662,
     617,   672,   687,   688,   702,   696,   694,   698,   710,   618,
     330,   702,  -161,   652,   331,   332,   661,   670,   492,   673,
       7,   678,   677,   120,   680,   679,   333,   501,   683,   689,
     691,   700,   284,   133,   334,   335,   336,   337,   311,   139,
     516,   517,   391,   405,   520,   676,   474,    73,   591,   419,
     338,    74,    75,   660,   633,   339,   705,   387,   340,   243,
     388,    76,   541,   389,   514,   622,   620,   306,   682,    77,
      78,   393,    27,   550,   489,   -53,   583,   341,   555,   686,
     692,    79,   342,   343,   557,   632,   524,   659,   709,     0,
      80,    81,    82,     0,   569,     0,     0,     0,   416,    83,
      84,     0,     0,    85,    86,     0,    87,    88,    89,   550,
       0,     0,   587,    90,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,   422,     0,    43,     0,     0,     0,
      44,    91,    92,    93,    45,    46,     0,    94,    95,     0,
       0,     0,     0,     0,     0,     0,    47,     0,     0,   587,
       0,     0,     0,     0,     0,    48,    49,    50,     0,     0,
      51,     0,     0,     0,    52,    53,     0,     0,    54,    55,
       0,    56,    57,    58,     0,     0,     0,     0,    59,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    60,    61,    62,     0,
       0,     0,    63,    64,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   685
};

static const yytype_int16 yycheck[] =
{
       9,   247,   194,   288,   203,   251,   167,   163,   293,   294,
      33,   172,   410,   411,    16,   209,    65,   178,   163,   175,
      25,   166,   167,   168,     5,   409,   171,    14,   313,     0,
     224,    34,     3,    37,   179,   180,     0,    17,    51,    97,
     424,    12,     7,     8,     9,    10,    11,    12,    97,   248,
      97,    22,    32,   252,   101,   254,    59,     5,    71,     5,
       6,     7,   446,    50,    69,   449,   450,    98,   229,     6,
       7,     8,     9,    10,    11,    12,    13,   100,   223,    97,
     225,    68,     4,   101,   369,    15,   242,    74,    90,   473,
      70,   376,   476,    97,   379,    43,    44,   242,   292,    97,
     385,   561,    97,   101,   105,   102,   101,   105,   102,   106,
     101,    59,   106,    98,    79,   100,    64,   577,   578,     5,
       6,     7,   368,    53,    54,    18,   282,    57,    58,   513,
      60,    61,    62,     7,     8,    98,   292,   100,   384,    98,
     425,   100,    98,   105,   100,   430,    98,   292,   100,    98,
     121,   100,   351,    98,   439,   100,    98,    98,   100,   100,
      97,     7,    98,   448,   100,    98,     6,   100,   329,    31,
     331,   332,   333,   334,   335,    98,   337,   100,     6,     7,
     341,   342,     7,     8,     9,    10,    11,    12,     6,     7,
     102,   101,    39,     7,    99,   102,    99,    98,   207,     4,
      29,    61,    87,    62,    58,    54,    15,     5,   454,    60,
     495,    53,    57,   498,    48,    59,    87,     4,    84,    36,
      63,    19,    20,    80,    82,    23,    24,   625,   626,    56,
      63,     4,    80,    29,   480,    30,    75,    35,     5,    36,
     401,   402,    97,    81,   253,    43,    44,    45,    46,   258,
       6,   101,    19,   105,    80,    13,    23,    24,    80,    80,
     101,    59,    97,     6,   549,   464,    64,    97,    35,    67,
     101,     6,    79,    97,    97,     5,    43,    44,    45,    46,
      78,    97,    97,     6,    28,    98,     7,    85,    86,   101,
       7,     5,    59,    91,    92,    27,    89,    64,     6,   584,
      67,    47,    27,    80,    94,   103,     3,   101,   554,    80,
      98,    78,   104,   104,    27,   101,   508,   100,    13,    86,
      27,    27,     6,    98,    91,    92,    27,    97,    81,   101,
      72,    36,   101,    37,    37,     6,   103,     7,    27,    76,
       7,    27,    73,   102,    66,     4,     4,   102,   102,   595,
     102,     1,    97,    80,    52,     5,     6,    97,     7,    97,
       4,     4,     4,    27,     5,    15,   612,     4,    97,   378,
      98,   617,   657,    23,    24,    21,    42,    97,    97,    29,
      98,    97,   628,    83,    49,    35,    98,   672,    84,   635,
       5,     4,    40,   585,    44,    45,    46,    27,     6,    98,
      40,    27,    41,    53,    54,    98,   652,    57,    58,    97,
      60,    61,    62,   605,   101,    98,   662,    67,    98,    97,
      97,    97,    97,    84,    98,   710,    88,     7,    97,    97,
      26,    38,    77,     4,    97,    85,    86,    87,    98,    96,
       4,    91,    92,    95,    98,    98,     5,   102,    27,   100,
      97,    27,     7,     6,   700,     6,    14,    22,    27,    97,
      19,   707,    98,    97,    23,    24,    98,    98,   477,    97,
       3,    98,   101,    66,    98,   100,    35,   486,    98,    98,
     102,    97,   233,    97,    43,    44,    45,    46,   497,   122,
     499,   500,   324,   349,   503,   662,   454,     1,   575,   372,
      59,     5,     6,   635,   612,    64,   701,   318,    67,   190,
     320,    15,   521,   321,   497,   601,   599,   251,   668,    23,
      24,   327,    22,   532,   471,    29,   568,    86,   536,   675,
     690,    35,    91,    92,   543,   608,   506,   630,   707,    -1,
      44,    45,    46,    -1,   553,    -1,    -1,    -1,   368,    53,
      54,    -1,    -1,    57,    58,    -1,    60,    61,    62,   568,
      -1,    -1,   571,    67,    -1,    -1,     5,     6,    -1,    -1,
      -1,    -1,    -1,    -1,   378,    -1,    15,    -1,    -1,    -1,
      19,    85,    86,    87,    23,    24,    -1,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,   608,
      -1,    -1,    -1,    -1,    -1,    44,    45,    46,    -1,    -1,
      49,    -1,    -1,    -1,    53,    54,    -1,    -1,    57,    58,
      -1,    60,    61,    62,    -1,    -1,    -1,    -1,    67,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    85,    86,    87,    -1,
      -1,    -1,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   673
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     5,   108,   109,   110,   126,     0,   110,   111,    97,
     112,   269,   270,    25,    69,   113,    98,     5,     6,     7,
     126,   136,   271,   272,     4,   101,   105,   272,    18,     7,
       6,    31,   116,   102,   101,   117,    39,   114,   115,     7,
      99,     5,     6,    15,    19,    23,    24,    35,    44,    45,
      46,    49,    53,    54,    57,    58,    60,    61,    62,    67,
      85,    86,    87,    91,    92,   118,   119,   120,   121,   122,
     123,   124,   125,     1,     5,     6,    15,    23,    24,    35,
      44,    45,    46,    53,    54,    57,    58,    60,    61,    62,
      67,    85,    86,    87,    91,    92,   127,   128,   129,   130,
     133,   136,   137,   139,   141,   142,   143,   144,   145,   159,
     163,   167,   193,   197,   276,   280,   284,   307,   102,    99,
     120,    33,   100,    98,   160,   164,   194,   198,   277,   281,
     285,   308,    29,   129,   131,   138,   168,   140,   126,   122,
      61,    62,    58,    54,    60,    57,    53,    15,    48,    59,
      87,     4,   161,   165,   195,   199,   278,   282,   286,   309,
     132,    36,   169,     5,    19,    20,    23,    24,    35,    43,
      44,    45,    46,    59,    64,    67,    78,    85,    86,    91,
      92,   103,   126,   134,   146,   149,   150,   151,   154,   210,
     211,   214,   222,    80,    84,    63,   260,    82,   206,    63,
     261,    56,   264,    80,    75,    29,     4,    30,   101,   218,
     225,   226,    97,   135,    97,   224,   225,   226,   230,   224,
     225,   101,   225,   215,   216,   217,   225,   224,   225,    36,
      81,   101,   226,    65,    97,   147,   224,   225,   225,    16,
      90,   105,     5,   214,     6,   235,   154,    97,    80,    97,
     200,    97,    80,    97,    80,   235,    13,   267,    97,   269,
       7,     8,     9,    10,    11,    12,    79,   227,   228,   229,
     230,     6,   156,   157,    98,     6,   231,   232,   225,   230,
     225,   224,   219,     5,   150,     6,   152,   153,    28,   237,
       7,     7,     5,    27,    89,   238,   253,   262,   263,   269,
     235,     6,   207,   208,   209,    47,   262,   235,   254,   265,
     266,   269,   235,    27,    80,   269,    94,   170,   101,   102,
     106,     3,   158,    98,   100,   233,    98,   100,   226,     5,
      19,    23,    24,    35,    43,    44,    45,    46,    59,    64,
      67,    86,    91,    92,   155,   212,   221,   223,    98,   100,
     267,    80,   104,   104,   225,   226,   230,   267,   267,    14,
      50,    68,    74,   174,   175,   176,   190,    98,   100,    27,
     101,    98,   100,    13,   268,    98,    27,    98,   100,    27,
     267,     6,   236,    98,    97,    27,   173,   227,   228,   229,
     101,   157,   101,   232,   224,   224,   224,   224,   224,   224,
     224,    36,    81,   224,   224,   153,   235,    37,    37,   162,
     192,   191,    72,   177,     6,   239,   263,   267,     7,   209,
     201,   267,   266,   267,   287,    27,   171,   172,   253,   267,
      76,   255,   102,     7,     7,     8,   234,   224,   224,    27,
     255,   239,   239,   178,    73,   179,   196,   102,    66,   279,
     283,   255,   267,    98,   100,   267,     4,   102,   102,   102,
     267,     4,    97,   180,    80,   255,   267,   255,   255,    52,
     288,   289,   290,   310,   172,     7,   148,    97,   248,   253,
      97,   235,     4,   202,     4,     4,     5,   292,     4,   290,
     255,   255,   269,    98,   253,    27,   166,    97,    21,    97,
      97,   269,   291,    97,    83,   311,   312,   313,    84,    98,
      98,   267,    42,   186,   254,   267,   269,   269,    49,   293,
     269,     5,   317,     4,   313,   154,   187,   255,    98,   203,
      98,    98,    97,    34,    59,   296,   297,   298,   299,   301,
      98,   269,   314,    97,    97,    17,    32,    70,   240,    27,
     269,   294,   295,   300,   302,   298,    40,   269,     6,   188,
     189,    97,   242,   241,    41,   243,   267,    98,   100,   269,
     253,    97,    98,   101,    98,   100,   248,    97,    97,   244,
      88,   181,   204,   295,    27,    84,   303,   269,   315,   316,
       7,   189,    98,   248,   248,    97,   182,    26,   249,    77,
     256,   257,   258,   267,   154,    96,   304,    98,   100,   102,
      98,    98,    38,   245,   246,   247,   253,    97,    97,     4,
     268,   205,   258,   154,   305,    51,    71,   306,    95,   318,
     319,   320,   316,   247,    98,   100,   183,   184,   185,   253,
       6,     7,     8,     9,    10,    11,    12,    13,    97,   213,
     220,   250,    97,   259,     4,   239,   239,    27,   253,   320,
     246,    98,   100,     6,     7,   251,   252,   273,   274,   275,
      98,   253,    27,    97,   267,   321,   185,   101,    98,   100,
      98,     6,   275,    98,   267,   269,   303,     7,     6,    98,
     322,   102,   304,   323,    14,   326,     6,   327,    22,   328,
      97,   324,   253,   329,   330,   249,    98,   100,   325,   330,
      27,   267
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   107,   108,   108,   109,   109,   111,   110,   112,   112,
     113,   113,   114,   114,   115,   116,   117,   116,   118,   118,
     119,   119,   120,   121,   121,   122,   122,   122,   123,   123,
     123,   123,   123,   123,   123,   123,   123,   123,   123,   123,
     123,   123,   123,   124,   124,   124,   124,   124,   124,   124,
     125,   125,   126,   127,   127,   128,   128,   129,   129,   129,
     129,   129,   129,   129,   129,   129,   129,   129,   129,   129,
     131,   132,   130,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   135,   134,   136,   136,   138,   137,   140,
     139,   141,   141,   141,   142,   142,   143,   143,   143,   143,
     143,   144,   144,   144,   145,   145,   146,   147,   148,   146,
     146,   149,   150,   151,   152,   152,   153,   154,   154,   155,
     155,   155,   156,   156,   158,   157,   160,   161,   162,   159,
     164,   165,   163,   166,   166,   168,   169,   167,   170,   170,
     171,   171,   172,   173,   173,   174,   174,   174,   175,   176,
     176,   178,   177,   177,   180,   179,   179,   182,   181,   181,
     183,   183,   184,   184,   185,   187,   186,   186,   188,   188,
     189,   191,   190,   192,   190,   194,   195,   196,   193,   198,
     199,   200,   201,   202,   203,   204,   205,   197,   206,   206,
     207,   208,   208,   209,   209,   210,   210,   210,   210,   210,
     210,   211,   211,   212,   212,   213,   214,   215,   214,   216,
     214,   214,   217,   214,   218,   214,   214,   214,   214,   214,
     219,   214,   214,   214,   214,   220,   220,   220,   220,   220,
     220,   220,   220,   220,   221,   221,   221,   221,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   224,   224,   224,   224,   225,   226,   227,
     227,   228,   228,   229,   229,   229,   229,   229,   229,   230,
     231,   231,   233,   232,   234,   234,   235,   236,   237,   237,
     238,   238,   239,   241,   240,   240,   242,   240,   240,   244,
     243,   243,   245,   245,   246,   246,   247,   248,   249,   249,
     250,   250,   251,   251,   252,   252,   253,   254,   255,   255,
     256,   256,   257,   257,   259,   258,   260,   260,   261,   262,
     262,   263,   264,   265,   265,   266,   267,   268,   270,   269,
     271,   271,   272,   272,   272,   272,   272,   273,   274,   274,
     275,   275,   277,   278,   279,   276,   281,   282,   283,   280,
     285,   286,   287,   284,   288,   289,   289,   291,   290,   292,
     292,   292,   293,   293,   294,   294,   295,   296,   296,   297,
     297,   298,   298,   300,   299,   302,   301,   303,   303,   304,
     304,   305,   306,   306,   306,   308,   309,   310,   307,   311,
     311,   312,   312,   314,   313,   315,   315,   316,   317,   317,
     318,   318,   319,   319,   321,   322,   323,   324,   325,   320,
     326,   326,   327,   328,   328,   329,   329,   330
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     0,     1,     2,     0,    10,     3,     0,
       1,     1,     1,     0,     3,     0,     0,     3,     1,     0,
       1,     2,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       0,     0,     5,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     3,     1,     1,     0,     8,     0,
       4,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     0,    11,
       1,     3,     1,     4,     1,     3,     2,     1,     4,     1,
       1,     2,     1,     3,     0,     5,     0,     0,     0,    14,
       0,     0,    23,     0,     2,     0,     0,    11,     4,     0,
       1,     3,     1,     2,     0,     1,     1,     0,     2,     1,
       1,     0,     5,     0,     0,     5,     0,     0,     5,     0,
       1,     0,     1,     3,     1,     0,     5,     0,     1,     3,
       4,     0,     3,     0,     3,     0,     0,     0,    15,     0,
       0,     0,     0,     0,     0,     0,     0,    24,     4,     0,
       1,     1,     3,     1,     4,     1,     2,     1,     1,     1,
       1,     5,     5,     1,     1,     1,     1,     0,     3,     0,
       3,     1,     0,     3,     0,     3,     4,     2,     4,     2,
       0,     4,     2,     4,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     2,     2,     3,     3,     2,     2,
       2,     1,     2,     1,     2,     2,     1,     2,     2,     2,
       1,     2,     1,     2,     2,     2,     2,     2,     2,     1,
       2,     1,     1,     1,     1,     1,     0,     3,     6,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     3,
       1,     3,     0,     5,     1,     1,     1,     1,     2,     0,
       2,     0,     1,     0,     5,     4,     0,     5,     0,     0,
       5,     0,     1,     3,     2,     1,     1,     1,     4,     0,
       1,     3,     1,     0,     1,     3,     1,     1,     2,     0,
       1,     0,     1,     2,     0,     5,     4,     0,     4,     1,
       3,     1,     4,     1,     3,     1,     1,     1,     0,     2,
       1,     2,     1,     3,     1,     4,     6,     1,     1,     2,
       4,     1,     0,     0,     0,    15,     0,     0,     0,    15,
       0,     0,     0,    15,     1,     1,     2,     0,     5,     2,
       1,     0,     4,     0,     1,     3,     1,     1,     0,     1,
       2,     1,     1,     0,     5,     0,     8,     2,     0,     2,
       0,     1,     2,     2,     0,     0,     0,     0,    17,     1,
       0,     1,     2,     0,     8,     1,     3,     1,     2,     1,
       1,     0,     1,     2,     0,     0,     0,     0,     0,    14,
       2,     0,     1,     4,     0,     1,     3,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (parserPtr, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, parserPtr); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, struct Parser *parserPtr)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (parserPtr);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, struct Parser *parserPtr)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, parserPtr);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, struct Parser *parserPtr)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], parserPtr);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, parserPtr); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, struct Parser *parserPtr)
{
  YY_USE (yyvaluep);
  YY_USE (parserPtr);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (struct Parser *parserPtr)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, parserPtr);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* mibFile: modules  */
#line 1582 "parser-smi.y"
    {
        (yyval.err) = 0;
    }
#line 3230 "parser-smi.c"
    break;

  case 3: /* mibFile: %empty  */
#line 1586 "parser-smi.y"
    {
	(yyval.err) = 0;
    }
#line 3238 "parser-smi.c"
    break;

  case 4: /* modules: module  */
#line 1592 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3244 "parser-smi.c"
    break;

  case 5: /* modules: modules module  */
#line 1594 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3250 "parser-smi.c"
    break;

  case 6: /* $@1: %empty  */
#line 1602 "parser-smi.y"
                        {
			    thisParserPtr->firstStatementLine = thisParserPtr->line;
			    thisParserPtr->currentDecl = SMI_DECL_MODULE;
			    
			    thisParserPtr->modulePtr = findModuleByName((yyvsp[0].id));
			    if (!thisParserPtr->modulePtr) {
				thisParserPtr->modulePtr =
				    addModule((yyvsp[0].id),
					      smiStrdup(thisParserPtr->path),
					      0,
					      thisParserPtr);
				thisParserPtr->modulePtr->
				    numImportedIdentifiers = 0;
				thisParserPtr->modulePtr->
				    numStatements = 0;
				thisParserPtr->modulePtr->
				    numModuleIdentities = 0;
				if (!strcmp((yyvsp[0].id), "SNMPv2-SMI")) {
			            /*
				     * SNMPv2-SMI is an SMIv2 module
				     * that cannot be identified by
				     * importing from SNMPv2-SMI.
				     */
				    thisModulePtr->export.language =
					SMI_LANGUAGE_SMIV2;
				}
			    } else {
			        smiPrintError(thisParserPtr,
					      ERR_MODULE_ALREADY_LOADED,
					      (yyvsp[0].id));
				/*
				 * this aborts parsing the whole file,
				 * not only the current module.
				 */
				YYABORT;
			    }
			}
#line 3292 "parser-smi.c"
    break;

  case 7: /* module: moduleName $@1 moduleOid definitions COLON_COLON_EQUAL BEGIN_ exportsClause linkagePart declarationPart END  */
#line 1646 "parser-smi.y"
                        {
			    if (thisModulePtr->export.language == SMI_LANGUAGE_UNKNOWN)
				thisModulePtr->export.language = SMI_LANGUAGE_SMIV1;
			    checkModuleName(thisParserPtr, thisModulePtr);
			    checkModuleIdentity(thisParserPtr, thisModulePtr);
			    checkObjects(thisParserPtr, thisModulePtr);
			    checkTypes(thisParserPtr, thisModulePtr);
			    checkDefvals(thisParserPtr, thisModulePtr);
			    checkImportsUsage(thisParserPtr, thisModulePtr);
			    smiCheckTypeUsage(thisParserPtr, thisModulePtr);
			    
			    thisParserPtr->capabilitiesModulePtr = NULL;

                            (yyval.err) = 0;
			}
#line 3312 "parser-smi.c"
    break;

  case 8: /* moduleOid: '{' objectIdentifier '}'  */
#line 1664 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3318 "parser-smi.c"
    break;

  case 9: /* moduleOid: %empty  */
#line 1666 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3324 "parser-smi.c"
    break;

  case 10: /* definitions: DEFINITIONS  */
#line 1670 "parser-smi.y"
                        { }
#line 3330 "parser-smi.c"
    break;

  case 11: /* definitions: PIB_DEFINITIONS  */
#line 1672 "parser-smi.y"
                        {
                            thisModulePtr->export.language = SMI_LANGUAGE_SPPI;
                        }
#line 3338 "parser-smi.c"
    break;

  case 12: /* linkagePart: linkageClause  */
#line 1681 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3344 "parser-smi.c"
    break;

  case 13: /* linkagePart: %empty  */
#line 1683 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3350 "parser-smi.c"
    break;

  case 14: /* linkageClause: IMPORTS importPart ';'  */
#line 1687 "parser-smi.y"
                        {
			    thisParserPtr->firstStatementLine = thisParserPtr->line;
			    thisParserPtr->currentDecl = SMI_DECL_MODULE;

			    if ((thisModulePtr->export.language != SMI_LANGUAGE_SMIV2) &&
                                (thisModulePtr->export.language != SMI_LANGUAGE_SPPI))
				thisModulePtr->export.language = SMI_LANGUAGE_SMIV1;
			    
			    (yyval.err) = 0;
			}
#line 3365 "parser-smi.c"
    break;

  case 15: /* exportsClause: %empty  */
#line 1701 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3371 "parser-smi.c"
    break;

  case 16: /* $@2: %empty  */
#line 1703 "parser-smi.y"
                        {
                            if (thisParserPtr->modulePtr->export.language ==
                                 SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "EXPORTS");
                            
			    thisParserPtr->firstStatementLine = thisParserPtr->line;
			    thisParserPtr->currentDecl = SMI_DECL_MODULE;

			    if (strcmp(thisParserPtr->modulePtr->export.name,
				       "RFC1155-SMI") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "RFC1065-SMI")) {
			        smiPrintError(thisParserPtr, ERR_EXPORTS);
			    }
			}
#line 3391 "parser-smi.c"
    break;

  case 17: /* exportsClause: EXPORTS $@2 ';'  */
#line 1720 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3397 "parser-smi.c"
    break;

  case 18: /* importPart: imports  */
#line 1724 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3403 "parser-smi.c"
    break;

  case 19: /* importPart: %empty  */
#line 1726 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3409 "parser-smi.c"
    break;

  case 20: /* imports: import  */
#line 1731 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3415 "parser-smi.c"
    break;

  case 21: /* imports: imports import  */
#line 1733 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3421 "parser-smi.c"
    break;

  case 22: /* import: importIdentifiers FROM moduleName  */
#line 1739 "parser-smi.y"
                        {
			    Import      *importPtr;
			    Module      *modulePtr;
                            
			    /*
			     * Recursively call the parser to suffer
			     * the IMPORTS, if the module is not yet
			     * loaded.
			     */
			    modulePtr = findModuleByName((yyvsp[0].id));
			    if (!modulePtr) {
				modulePtr = loadModule((yyvsp[0].id), thisParserPtr);
			    }
			    checkImports(modulePtr, thisParserPtr);

			    if (modulePtr && !strcmp((yyvsp[0].id), "SNMPv2-SMI")) {
			        /*
				 * A module that imports a macro or
				 * type definition from SNMPv2-SMI
				 * seems to be SMIv2 style - but only if
                                 * it is not SPPI yet.
				 */
                                if (thisModulePtr->export.language != SMI_LANGUAGE_SPPI) {
				    for (importPtr =
					     thisModulePtr->firstImportPtr;
				         importPtr;
				         importPtr = importPtr->nextPtr) {
				        if ((!strcmp(importPtr->export.module,
						     (yyvsp[0].id))) &&
					    ((importPtr->kind == KIND_MACRO) ||
					     (importPtr->kind == KIND_TYPE))) {
					    thisModulePtr->export.language =
					        SMI_LANGUAGE_SMIV2;
				        }
				    }
                                }
			    }

			    smiFree((yyvsp[0].id));
			}
#line 3466 "parser-smi.c"
    break;

  case 23: /* importIdentifiers: importIdentifier  */
#line 1782 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3472 "parser-smi.c"
    break;

  case 24: /* importIdentifiers: importIdentifiers ',' importIdentifier  */
#line 1785 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3478 "parser-smi.c"
    break;

  case 25: /* importIdentifier: LOWERCASE_IDENTIFIER  */
#line 1792 "parser-smi.y"
                        {
			    addImport((yyvsp[0].id), thisParserPtr);
			    thisParserPtr->modulePtr->numImportedIdentifiers++;
			    (yyval.id) = 0;
			}
#line 3488 "parser-smi.c"
    break;

  case 26: /* importIdentifier: UPPERCASE_IDENTIFIER  */
#line 1798 "parser-smi.y"
                        {
			    addImport((yyvsp[0].id), thisParserPtr);
			    thisParserPtr->modulePtr->numImportedIdentifiers++;
			    (yyval.id) = 0;
			}
#line 3498 "parser-smi.c"
    break;

  case 27: /* importIdentifier: importedKeyword  */
#line 1804 "parser-smi.y"
                        {
			    addImport(smiStrdup((yyvsp[0].id)), thisParserPtr);
			    thisParserPtr->modulePtr->numImportedIdentifiers++;
			    (yyval.id) = 0;
			}
#line 3508 "parser-smi.c"
    break;

  case 28: /* importedKeyword: importedSMIKeyword  */
#line 1820 "parser-smi.y"
                        {
                            /*
                             * There are PIBs that import e.g. Counter64 - so
                             * don't complain here about SMI keywords.
                             */
                           /* if (thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI)
                              smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, $1);*/
                            (yyval.id) = (yyvsp[0].id);
                        }
#line 3522 "parser-smi.c"
    break;

  case 29: /* importedKeyword: importedSPPIKeyword  */
#line 1830 "parser-smi.y"
                        {
                            if (thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)
				smiPrintError(thisParserPtr, ERR_SPPI_TYPE_IN_MIB, (yyvsp[0].id));
                            (yyval.id) = (yyvsp[0].id);
                        }
#line 3532 "parser-smi.c"
    break;

  case 52: /* moduleName: UPPERCASE_IDENTIFIER  */
#line 1864 "parser-smi.y"
                        {
			    checkNameLen(thisParserPtr, (yyvsp[0].id),
					 ERR_MODULENAME_32, ERR_MODULENAME_64);
			    (yyval.id) = (yyvsp[0].id);
			}
#line 3542 "parser-smi.c"
    break;

  case 53: /* declarationPart: declarations  */
#line 1876 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3548 "parser-smi.c"
    break;

  case 54: /* declarationPart: %empty  */
#line 1878 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3554 "parser-smi.c"
    break;

  case 55: /* declarations: declaration  */
#line 1883 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3560 "parser-smi.c"
    break;

  case 56: /* declarations: declarations declaration  */
#line 1885 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3566 "parser-smi.c"
    break;

  case 57: /* declaration: typeDeclaration  */
#line 1889 "parser-smi.y"
                        { 
			    thisParserPtr->modulePtr->numStatements++;
			    (yyval.err) = 0;
			}
#line 3575 "parser-smi.c"
    break;

  case 58: /* declaration: valueDeclaration  */
#line 1894 "parser-smi.y"
                        { 
			    thisParserPtr->modulePtr->numStatements++;
			    (yyval.err) = 0;
			}
#line 3584 "parser-smi.c"
    break;

  case 59: /* declaration: objectIdentityClause  */
#line 1899 "parser-smi.y"
                        { 
			    thisParserPtr->modulePtr->numStatements++;
			    (yyval.err) = 0;
			}
#line 3593 "parser-smi.c"
    break;

  case 60: /* declaration: objectTypeClause  */
#line 1904 "parser-smi.y"
                        { 
			    thisParserPtr->modulePtr->numStatements++;
			    (yyval.err) = 0;
			}
#line 3602 "parser-smi.c"
    break;

  case 61: /* declaration: trapTypeClause  */
#line 1909 "parser-smi.y"
                        { 
			    thisParserPtr->modulePtr->numStatements++;
			    (yyval.err) = 0;
			}
#line 3611 "parser-smi.c"
    break;

  case 62: /* declaration: notificationTypeClause  */
#line 1914 "parser-smi.y"
                        { 
			    thisParserPtr->modulePtr->numStatements++;
			    (yyval.err) = 0;
			}
#line 3620 "parser-smi.c"
    break;

  case 63: /* declaration: moduleIdentityClause  */
#line 1919 "parser-smi.y"
                        { 
			    thisParserPtr->modulePtr->numStatements++;
			    (yyval.err) = 0;
			}
#line 3629 "parser-smi.c"
    break;

  case 64: /* declaration: moduleComplianceClause  */
#line 1924 "parser-smi.y"
                        { 
			    thisParserPtr->modulePtr->numStatements++;
			    (yyval.err) = 0;
			}
#line 3638 "parser-smi.c"
    break;

  case 65: /* declaration: objectGroupClause  */
#line 1929 "parser-smi.y"
                        { 
			    thisParserPtr->modulePtr->numStatements++;
			    (yyval.err) = 0;
			}
#line 3647 "parser-smi.c"
    break;

  case 66: /* declaration: notificationGroupClause  */
#line 1934 "parser-smi.y"
                        {
			    thisParserPtr->modulePtr->numStatements++;
			    (yyval.err) = 0;
			}
#line 3656 "parser-smi.c"
    break;

  case 67: /* declaration: agentCapabilitiesClause  */
#line 1939 "parser-smi.y"
                        { 
			    thisParserPtr->modulePtr->numStatements++;
			    (yyval.err) = 0;
			}
#line 3665 "parser-smi.c"
    break;

  case 68: /* declaration: macroClause  */
#line 1944 "parser-smi.y"
                        { 
			    thisParserPtr->modulePtr->numStatements++;
			    (yyval.err) = 0;
			}
#line 3674 "parser-smi.c"
    break;

  case 69: /* declaration: error '}'  */
#line 1949 "parser-smi.y"
                        {
			    smiPrintError(thisParserPtr,
					  ERR_FLUSH_DECLARATION);
			    yyerrok;
			    (yyval.err) = 1;
			}
#line 3685 "parser-smi.c"
    break;

  case 70: /* $@3: %empty  */
#line 1963 "parser-smi.y"
                        {
			    Macro *macroPtr;

			    thisParserPtr->firstStatementLine = thisParserPtr->line;
			    thisParserPtr->currentDecl = SMI_DECL_MACRO;

			    macroPtr = addMacro(smiStrdup((yyvsp[0].id)),
						0, thisParserPtr);
			    setMacroLine(macroPtr, thisParserPtr->firstStatementLine,
					 thisParserPtr);
			}
#line 3701 "parser-smi.c"
    break;

  case 71: /* $@4: %empty  */
#line 1975 "parser-smi.y"
                        {
			    /*
			     * ASN.1 macros are known to be in these
			     * modules.
			     */
			    if (strcmp(thisParserPtr->modulePtr->export.name,
				       "SNMPv2-SMI") &&
			        strcmp(thisParserPtr->modulePtr->export.name,
				       "SNMPv2-TC") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "SNMPv2-CONF") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "RFC-1212") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "RFC-1215") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "RFC1065-SMI") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "RFC1155-SMI") &&
                                strcmp(thisParserPtr->modulePtr->export.name,
                                       "COPS-PR-SPPI") &&
                                strcmp(thisParserPtr->modulePtr->export.name,
                                       "COPS-PR-SPPI-TC")) {
			        smiPrintError(thisParserPtr, ERR_MACRO);
			    }
			}
#line 3732 "parser-smi.c"
    break;

  case 72: /* macroClause: macroName $@3 MACRO $@4 END  */
#line 2003 "parser-smi.y"
                        {
			    (yyval.err) = 0;
                        }
#line 3740 "parser-smi.c"
    break;

  case 73: /* macroName: MODULE_IDENTITY  */
#line 2008 "parser-smi.y"
                                            { (yyval.id) = (yyvsp[0].id); }
#line 3746 "parser-smi.c"
    break;

  case 74: /* macroName: OBJECT_TYPE  */
#line 2009 "parser-smi.y"
                                            { (yyval.id) = (yyvsp[0].id); }
#line 3752 "parser-smi.c"
    break;

  case 75: /* macroName: TRAP_TYPE  */
#line 2010 "parser-smi.y"
                                            { (yyval.id) = (yyvsp[0].id); }
#line 3758 "parser-smi.c"
    break;

  case 76: /* macroName: NOTIFICATION_TYPE  */
#line 2011 "parser-smi.y"
                                            { (yyval.id) = (yyvsp[0].id); }
#line 3764 "parser-smi.c"
    break;

  case 77: /* macroName: OBJECT_IDENTITY  */
#line 2012 "parser-smi.y"
                                            { (yyval.id) = (yyvsp[0].id); }
#line 3770 "parser-smi.c"
    break;

  case 78: /* macroName: TEXTUAL_CONVENTION  */
#line 2013 "parser-smi.y"
                                            { (yyval.id) = (yyvsp[0].id); }
#line 3776 "parser-smi.c"
    break;

  case 79: /* macroName: OBJECT_GROUP  */
#line 2014 "parser-smi.y"
                                            { (yyval.id) = (yyvsp[0].id); }
#line 3782 "parser-smi.c"
    break;

  case 80: /* macroName: NOTIFICATION_GROUP  */
#line 2015 "parser-smi.y"
                                            { (yyval.id) = (yyvsp[0].id); }
#line 3788 "parser-smi.c"
    break;

  case 81: /* macroName: MODULE_COMPLIANCE  */
#line 2016 "parser-smi.y"
                                            { (yyval.id) = (yyvsp[0].id); }
#line 3794 "parser-smi.c"
    break;

  case 82: /* macroName: AGENT_CAPABILITIES  */
#line 2017 "parser-smi.y"
                                            { (yyval.id) = (yyvsp[0].id); }
#line 3800 "parser-smi.c"
    break;

  case 83: /* $@5: %empty  */
#line 2021 "parser-smi.y"
                        {
			    if (strcmp(thisParserPtr->modulePtr->export.name,
				       "SNMPv2-SMI") &&
			        strcmp(thisParserPtr->modulePtr->export.name,
				       "SNMPv2-TC") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "SNMPv2-CONF") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "RFC-1212") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "RFC1065-SMI") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "RFC1155-SMI") && 
                                strcmp(thisParserPtr->modulePtr->export.name,
                                       "COPS-PR-SPPI")) {
			        smiPrintError(thisParserPtr, ERR_CHOICE);
			    }
			}
#line 3823 "parser-smi.c"
    break;

  case 84: /* choiceClause: CHOICE $@5 '}'  */
#line 2041 "parser-smi.y"
                        {
			    (yyval.typePtr) = addType(NULL, SMI_BASETYPE_UNKNOWN, 0,
					 thisParserPtr);
			}
#line 3832 "parser-smi.c"
    break;

  case 85: /* fuzzy_lowercase_identifier: LOWERCASE_IDENTIFIER  */
#line 2051 "parser-smi.y"
                        {
			  (yyval.id) = (yyvsp[0].id);
			}
#line 3840 "parser-smi.c"
    break;

  case 86: /* fuzzy_lowercase_identifier: UPPERCASE_IDENTIFIER  */
#line 2056 "parser-smi.y"
                        {
			    smiPrintError (thisParserPtr,
					   ERR_BAD_LOWER_IDENTIFIER_CASE,
					   (yyvsp[0].id));
			    /* xxx
			    if ((thisParserPtr->flags & SMI_FLAG_BE_LAX) == 0) {
			        YYERROR;
			    }
			    */
			  (yyval.id) = (yyvsp[0].id);
			}
#line 3856 "parser-smi.c"
    break;

  case 87: /* $@6: %empty  */
#line 2071 "parser-smi.y"
                        {
			    thisParserPtr->firstStatementLine = thisParserPtr->line;
			    thisParserPtr->currentDecl = SMI_DECL_VALUEASSIGNMENT;

			    checkNameLen(thisParserPtr, (yyvsp[0].id),
					 ERR_OIDNAME_32, ERR_OIDNAME_64);
			    smiCheckObjectName(thisParserPtr,
					       thisModulePtr, (yyvsp[0].id));
			    if (thisModulePtr->export.language == SMI_LANGUAGE_SMIV2)
			    {
			        if (strchr((yyvsp[0].id), '-') &&
				    (strcmp((yyvsp[0].id), "mib-2") ||
				  strcmp(thisModulePtr->export.name, "SNMPv2-SMI"))) {
				    smiPrintError(thisParserPtr,
						  ERR_OIDNAME_INCLUDES_HYPHEN,
						  (yyvsp[0].id));
				}
			    }
			}
#line 3880 "parser-smi.c"
    break;

  case 88: /* valueDeclaration: fuzzy_lowercase_identifier $@6 OBJECT IDENTIFIER COLON_COLON_EQUAL '{' objectIdentifier '}'  */
#line 2092 "parser-smi.y"
                        {
			    Object *objectPtr;
			    
			    objectPtr = (yyvsp[-1].objectPtr);
			    smiCheckObjectReuse(thisParserPtr, (yyvsp[-7].id), &objectPtr);
			    objectPtr = setObjectName(objectPtr, (yyvsp[-7].id), thisParserPtr);
			    deleteObjectFlags(objectPtr, FLAG_INCOMPLETE);
			    setObjectLine(objectPtr, thisParserPtr->firstStatementLine,
					  thisParserPtr);
			    setObjectDecl(objectPtr,
					  SMI_DECL_VALUEASSIGNMENT);
			    (yyval.err) = 0;
			}
#line 3898 "parser-smi.c"
    break;

  case 89: /* $@7: %empty  */
#line 2111 "parser-smi.y"
                        {
			    thisParserPtr->firstStatementLine = thisParserPtr->line;
			    thisParserPtr->currentDecl = SMI_DECL_TYPEASSIGNMENT;

			    checkNameLen(thisParserPtr, (yyvsp[0].id),
					 ERR_TYPENAME_32, ERR_TYPENAME_64);
			}
#line 3910 "parser-smi.c"
    break;

  case 90: /* typeDeclaration: typeName $@7 COLON_COLON_EQUAL typeDeclarationRHS  */
#line 2119 "parser-smi.y"
                        {
			    Type *typePtr;
			    
			    if (strlen((yyvsp[-3].id))) {
				if ((yyvsp[0].typePtr)->export.basetype != SMI_BASETYPE_UNKNOWN) {
				    smiCheckTypeName(thisParserPtr,
						     thisModulePtr, (yyvsp[-3].id),
						     thisParserPtr->firstStatementLine);
				}
				setTypeLine((yyvsp[0].typePtr), thisParserPtr->firstStatementLine,
					    thisParserPtr);
				setTypeName((yyvsp[0].typePtr), (yyvsp[-3].id));
				(yyval.err) = 0;
			    } else {
				(yyval.err) = 0;
			    }

			    /*
			     * If we are in an SMI module, some type
			     * definitions derived from ASN.1 `INTEGER'
			     * must be modified to libsmi basetypes.
			     */
			    if (thisModulePtr &&
				(!strcmp(thisModulePtr->export.name, "SNMPv2-SMI"))) {
				if (!strcmp((yyvsp[-3].id), "Counter32")) {
				    (yyvsp[0].typePtr)->export.basetype = SMI_BASETYPE_UNSIGNED32;
				    setTypeParent((yyvsp[0].typePtr), smiHandle->typeUnsigned32Ptr);
				    if ((yyvsp[0].typePtr)->listPtr) {
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.value.unsigned32 = 0;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.value.unsigned32 = 4294967295U;
				    }
				} else if (!strcmp((yyvsp[-3].id), "Gauge32")) {
				    (yyvsp[0].typePtr)->export.basetype = SMI_BASETYPE_UNSIGNED32;
				    setTypeParent((yyvsp[0].typePtr), smiHandle->typeUnsigned32Ptr);
				    if ((yyvsp[0].typePtr)->listPtr) {
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.value.unsigned32 = 0;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.value.unsigned32 = 4294967295U;
				    }
				} else if (!strcmp((yyvsp[-3].id), "Unsigned32")) {
				    (yyvsp[0].typePtr)->export.basetype = SMI_BASETYPE_UNSIGNED32;
				    setTypeParent((yyvsp[0].typePtr), smiHandle->typeUnsigned32Ptr);
				    if ((yyvsp[0].typePtr)->listPtr) {
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.value.unsigned32 = 0;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.value.unsigned32 = 4294967295U;
				    }
				} else if (!strcmp((yyvsp[-3].id), "TimeTicks")) {
				    (yyvsp[0].typePtr)->export.basetype = SMI_BASETYPE_UNSIGNED32;
				    setTypeParent((yyvsp[0].typePtr), smiHandle->typeUnsigned32Ptr);
				    if ((yyvsp[0].typePtr)->listPtr) {
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.value.unsigned32 = 0;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.value.unsigned32 = 4294967295U;
				    }
				} else if (!strcmp((yyvsp[-3].id), "Counter64")) {
				    (yyvsp[0].typePtr)->export.basetype = SMI_BASETYPE_UNSIGNED64;
				    if ((yyvsp[0].typePtr)->listPtr) {
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.basetype = SMI_BASETYPE_UNSIGNED64;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.value.unsigned64 = 0;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.basetype = SMI_BASETYPE_UNSIGNED64;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.value.unsigned64 = SMI_BASETYPE_UNSIGNED64_MAX;
				    }
				    setTypeParent((yyvsp[0].typePtr), smiHandle->typeUnsigned64Ptr);
				}
			    }
			    if (thisModulePtr &&
				(!strcmp(thisModulePtr->export.name, "RFC1155-SMI") ||
				 !strcmp(thisModulePtr->export.name, "RFC1065-SMI"))) {
				if (!strcmp((yyvsp[-3].id), "Counter")) {
				    (yyvsp[0].typePtr)->export.basetype = SMI_BASETYPE_UNSIGNED32;
				    setTypeParent((yyvsp[0].typePtr), smiHandle->typeUnsigned32Ptr);
				    if ((yyvsp[0].typePtr)->listPtr) {
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.value.unsigned32 = 0;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.value.unsigned32 = 4294967295U;
				    }
				} else if (!strcmp((yyvsp[-3].id), "Gauge")) {
				    (yyvsp[0].typePtr)->export.basetype = SMI_BASETYPE_UNSIGNED32;
				    setTypeParent((yyvsp[0].typePtr), smiHandle->typeUnsigned32Ptr);
				    if ((yyvsp[0].typePtr)->listPtr) {
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.value.unsigned32 = 0;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.value.unsigned32 = 4294967295U;
				    }
				} else if (!strcmp((yyvsp[-3].id), "TimeTicks")) {
				    (yyvsp[0].typePtr)->export.basetype = SMI_BASETYPE_UNSIGNED32;
				    setTypeParent((yyvsp[0].typePtr), smiHandle->typeUnsigned32Ptr);
				    if ((yyvsp[0].typePtr)->listPtr) {
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.value.unsigned32 = 0;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.value.unsigned32 = 4294967295U;
				    }
				} else if (!strcmp((yyvsp[-3].id), "NetworkAddress")) {
				    setTypeName((yyvsp[0].typePtr), smiStrdup("NetworkAddress"));
				    (yyvsp[0].typePtr)->export.basetype = SMI_BASETYPE_OCTETSTRING;
				    setTypeParent((yyvsp[0].typePtr), findTypeByModuleAndName(
					                   thisModulePtr,
						           "IpAddress"));
				} else if (!strcmp((yyvsp[-3].id), "IpAddress")) {
				    typePtr = findTypeByModuleAndName(
					thisModulePtr, "NetworkAddress");
				    if (typePtr) 
					setTypeParent(typePtr, (yyvsp[0].typePtr));
				}
			    }
			    if (thisModulePtr &&
				(!strcmp(thisModulePtr->export.name, "COPS-PR-SPPI"))) {
				if (!strcmp((yyvsp[-3].id), "Unsigned32")) {
				    (yyvsp[0].typePtr)->export.basetype = SMI_BASETYPE_UNSIGNED32;
				    setTypeParent((yyvsp[0].typePtr), smiHandle->typeUnsigned32Ptr);
				    if ((yyvsp[0].typePtr)->listPtr) {
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.value.unsigned32 = 0;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.value.unsigned32 = 4294967295U;
				    }
				} else if (!strcmp((yyvsp[-3].id), "TimeTicks")) {
				    (yyvsp[0].typePtr)->export.basetype = SMI_BASETYPE_UNSIGNED32;
				    setTypeParent((yyvsp[0].typePtr), smiHandle->typeUnsigned32Ptr);
				    if ((yyvsp[0].typePtr)->listPtr) {
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.value.unsigned32 = 0;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.value.unsigned32 = 4294967295U;
				    }
				} else if (!strcmp((yyvsp[-3].id), "Unsigned64")) {
				    (yyvsp[0].typePtr)->export.basetype = SMI_BASETYPE_UNSIGNED64;
				    if ((yyvsp[0].typePtr)->listPtr) {
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.basetype = SMI_BASETYPE_UNSIGNED64;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.value.unsigned64 = 0;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.basetype = SMI_BASETYPE_UNSIGNED64;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.value.unsigned64 = SMI_BASETYPE_UNSIGNED64_MAX;
				    }
				    setTypeParent((yyvsp[0].typePtr), smiHandle->typeUnsigned64Ptr);
				} else if (!strcmp((yyvsp[-3].id), "Integer64")) {
				    (yyvsp[0].typePtr)->export.basetype = SMI_BASETYPE_INTEGER64;
				    if ((yyvsp[0].typePtr)->listPtr) {
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.basetype = SMI_BASETYPE_INTEGER64;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.value.integer64 = SMI_BASETYPE_INTEGER64_MIN;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.basetype = SMI_BASETYPE_INTEGER64;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.value.integer64 = SMI_BASETYPE_INTEGER64_MAX;
				    }
				    setTypeParent((yyvsp[0].typePtr), smiHandle->typeInteger64Ptr);
				}
			    }
			}
#line 4070 "parser-smi.c"
    break;

  case 91: /* typeName: UPPERCASE_IDENTIFIER  */
#line 2277 "parser-smi.y"
                        {
			    (yyval.id) = (yyvsp[0].id);
			}
#line 4078 "parser-smi.c"
    break;

  case 92: /* typeName: typeSMI  */
#line 2281 "parser-smi.y"
                        {
			    (yyval.id) = smiStrdup((yyvsp[0].id));
			    /*
			     * well known types (keywords in this grammar)
			     * are known to be defined in these modules.
			     */
			    if (strcmp(thisParserPtr->modulePtr->export.name,
				       "SNMPv2-SMI") &&
			        strcmp(thisParserPtr->modulePtr->export.name,
				       "SNMPv2-TC") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "SNMPv2-CONF") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "RFC-1212") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "RFC1065-SMI") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "RFC1155-SMI") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "COPS-PR-SPPI")) {
			        smiPrintError(thisParserPtr, ERR_TYPE_SMI_OR_SPPI, (yyvsp[0].id));
			    }
			}
#line 4106 "parser-smi.c"
    break;

  case 93: /* typeName: typeSPPIonly  */
#line 2305 "parser-smi.y"
                        {
			    (yyval.id) = smiStrdup((yyvsp[0].id));
			    /*
			     * well known types (keywords in this grammar)
			     * are known to be defined in these modules.
			     */
			    if ((strcmp(thisParserPtr->modulePtr->export.name,
					"COPS-PR-SPPI")) &&
				(thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI))
			        smiPrintError(thisParserPtr, ERR_TYPE_SPPI, (yyvsp[0].id));
                        }
#line 4122 "parser-smi.c"
    break;

  case 95: /* typeSMI: typeSMIonly  */
#line 2320 "parser-smi.y"
                        {
                            if ((thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI) &&
                                !findImportByName((yyvsp[0].id), thisParserPtr->modulePtr))
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, (yyvsp[0].id));
                            (yyval.id) = (yyvsp[0].id);
                        }
#line 4133 "parser-smi.c"
    break;

  case 106: /* typeDeclarationRHS: Syntax  */
#line 2345 "parser-smi.y"
                        {
			    if ((yyvsp[0].typePtr)->export.name) {
				/*
				 * If we found an already defined type,
				 * we have to inherit a new type structure.
				 * (Otherwise the `Syntax' rule created
				 * a new type for us.)
				 */
				(yyval.typePtr) = duplicateType((yyvsp[0].typePtr), 0, thisParserPtr);
				setTypeDecl((yyval.typePtr), SMI_DECL_TYPEASSIGNMENT);
			    } else {
				(yyval.typePtr) = (yyvsp[0].typePtr);
				setTypeDecl((yyval.typePtr), SMI_DECL_TYPEASSIGNMENT);
			    }
			}
#line 4153 "parser-smi.c"
    break;

  case 107: /* $@8: %empty  */
#line 2361 "parser-smi.y"
                        {
			    Import *importPtr;

			    thisParserPtr->currentDecl = SMI_DECL_TEXTUALCONVENTION;

			    if (thisModulePtr->export.language == SMI_LANGUAGE_UNKNOWN)
				thisModulePtr->export.language = SMI_LANGUAGE_SMIV2;

			    if (strcmp(thisModulePtr->export.name, "SNMPv2-TC")) {
				importPtr =
				    findImportByName("TEXTUAL-CONVENTION",
						     thisModulePtr);
				if (importPtr) {
				    importPtr->use++;
				} else {
                                    if (thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)
				        smiPrintError(thisParserPtr,
						      ERR_MACRO_NOT_IMPORTED,
						      "TEXTUAL-CONVENTION",
						      "SNMPv2-TC");
                                    else
				        smiPrintError(thisParserPtr,
						      ERR_MACRO_NOT_IMPORTED,
						      "TEXTUAL-CONVENTION",
						      "COPS-PR-SPPI");
				}
			    }
			}
#line 4186 "parser-smi.c"
    break;

  case 108: /* $@9: %empty  */
#line 2392 "parser-smi.y"
                        {
			    checkDescr(thisParserPtr, (yyvsp[0].text));
			}
#line 4194 "parser-smi.c"
    break;

  case 109: /* typeDeclarationRHS: TEXTUAL_CONVENTION $@8 DisplayPart STATUS Status DESCRIPTION Text $@9 ReferPart SYNTAX Syntax  */
#line 2397 "parser-smi.y"
                        {
			    if (((yyvsp[0].typePtr)) && !((yyvsp[0].typePtr)->export.name)) {
				/*
				 * If the Type we found has just been
				 * defined, we don't have to allocate
				 * a new one.
				 */
				(yyval.typePtr) = (yyvsp[0].typePtr);
			    } else {
				if (!((yyvsp[0].typePtr)))
				    smiPrintError(thisParserPtr, ERR_INTERNAL);
				/*
				 * Otherwise, we have to allocate a
				 * new Type struct, inherited from $10.
				 */
				(yyval.typePtr) = duplicateType((yyvsp[0].typePtr), 0, thisParserPtr);
			    }
			    setTypeDescription((yyval.typePtr), (yyvsp[-4].text), thisParserPtr);
			    if ((yyvsp[-2].text)) {
				setTypeReference((yyval.typePtr), (yyvsp[-2].text), thisParserPtr);
			    }
			    setTypeStatus((yyval.typePtr), (yyvsp[-6].status));
			    if ((yyvsp[-8].text)) {
				if (smiCheckFormat(thisParserPtr,
						   (yyval.typePtr)->export.basetype, (yyvsp[-8].text),
						   thisParserPtr->firstStatementLine)) {
				    setTypeFormat((yyval.typePtr), (yyvsp[-8].text));
				}
			    }
			    setTypeDecl((yyval.typePtr), SMI_DECL_TEXTUALCONVENTION);
			}
#line 4230 "parser-smi.c"
    break;

  case 110: /* typeDeclarationRHS: choiceClause  */
#line 2429 "parser-smi.y"
                        {
			    (yyval.typePtr) = (yyvsp[0].typePtr);
			    setTypeDecl((yyval.typePtr), SMI_DECL_TYPEASSIGNMENT);
			}
#line 4239 "parser-smi.c"
    break;

  case 111: /* conceptualTable: SEQUENCE OF row  */
#line 2437 "parser-smi.y"
                        {
			    if ((yyvsp[0].typePtr)) {
				(yyval.typePtr) = addType(NULL,
					     SMI_BASETYPE_UNKNOWN, 0,
					     thisParserPtr);
				setTypeDecl((yyval.typePtr), SMI_DECL_IMPL_SEQUENCEOF);
				setTypeParent((yyval.typePtr), (yyvsp[0].typePtr));
			    } else {
				(yyval.typePtr) = NULL;
			    }
			}
#line 4255 "parser-smi.c"
    break;

  case 112: /* row: UPPERCASE_IDENTIFIER  */
#line 2456 "parser-smi.y"
                        {
			    Type *typePtr;
			    Import *importPtr;

			    (yyval.typePtr) = findTypeByModulenameAndName(
				thisParserPtr->modulePtr->export.name, (yyvsp[0].id));
			    if (! (yyval.typePtr)) {
				importPtr = findImportByName((yyvsp[0].id),
							     thisModulePtr);
				if (!importPtr ||
				    (importPtr->kind == KIND_NOTFOUND)) {
				    /* 
				     * forward referenced type. create it,
				     * marked with FLAG_INCOMPLETE.
				     */
				    typePtr = addType((yyvsp[0].id),
						      SMI_BASETYPE_UNKNOWN,
						      FLAG_INCOMPLETE,
						      thisParserPtr);
				    (yyval.typePtr) = typePtr;
				} else {
				    /*
				     * imported type.
				     * TODO: is this allowed in a SEQUENCE? 
				     */
				    importPtr->use++;
				    (yyval.typePtr) = findTypeByModulenameAndName(
					importPtr->export.module,
					importPtr->export.name);
				    smiFree((yyvsp[0].id));
				}
			    } else {
				smiFree((yyvsp[0].id));
			    }
			}
#line 4295 "parser-smi.c"
    break;

  case 113: /* entryType: SEQUENCE '{' sequenceItems '}'  */
#line 2496 "parser-smi.y"
                        {
			    (yyval.typePtr) = addType(NULL, SMI_BASETYPE_UNKNOWN, 0,
					 thisParserPtr);
			    setTypeList((yyval.typePtr), (yyvsp[-1].listPtr));
			}
#line 4305 "parser-smi.c"
    break;

  case 114: /* sequenceItems: sequenceItem  */
#line 2504 "parser-smi.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].objectPtr);
			    (yyval.listPtr)->nextPtr = NULL;
			}
#line 4315 "parser-smi.c"
    break;

  case 115: /* sequenceItems: sequenceItems ',' sequenceItem  */
#line 2511 "parser-smi.y"
                        {
			    List *p, *pp;
			    
			    p = smiMalloc(sizeof(List));
			    p->ptr = (void *)(yyvsp[0].objectPtr);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-2].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    (yyval.listPtr) = (yyvsp[-2].listPtr);
			}
#line 4330 "parser-smi.c"
    break;

  case 116: /* sequenceItem: LOWERCASE_IDENTIFIER sequenceSyntax  */
#line 2530 "parser-smi.y"
                        {
			    Object *objectPtr;
			    Import *importPtr;
			    Type *typePtr;
			    
			    objectPtr =
			        findObjectByModuleAndName(thisParserPtr->modulePtr,
							  (yyvsp[-1].id));

			    if (!objectPtr) {
				importPtr = findImportByName((yyvsp[-1].id),
							     thisModulePtr);
				if (!importPtr ||
				    (importPtr->kind == KIND_NOTFOUND)) {
				    objectPtr = addObject((yyvsp[-1].id), thisParserPtr->pendingNodePtr,
					                  0,
					                  FLAG_INCOMPLETE |
							  FLAG_SEQTYPE,
						          thisParserPtr);
				    setObjectType(objectPtr, (yyvsp[0].typePtr));
				} else {
				    /*
				     * imported object.
				     */
				    importPtr->use++;
				    objectPtr = findObjectByModulenameAndName(
					importPtr->export.module, (yyvsp[-1].id));
				    smiFree((yyvsp[-1].id));

				    if (objectPtr->typePtr->export.name) {
					typePtr = objectPtr->typePtr;
				    } else {
					typePtr = objectPtr->typePtr->parentPtr;
				    }
				    if (((yyvsp[0].typePtr) != typePtr) &&
					(((yyvsp[0].typePtr)->export.basetype !=
					  SMI_BASETYPE_INTEGER32) ||
					 (typePtr->export.basetype !=
					  SMI_BASETYPE_ENUM)) &&
					(((yyvsp[0].typePtr)->export.basetype !=
					  SMI_BASETYPE_OCTETSTRING) ||
					 (typePtr->export.basetype !=
					  SMI_BASETYPE_BITS))) {
					smiPrintError(thisParserPtr,
						      ERR_SEQUENCE_TYPE_MISMATCH,
						      objectPtr->export.name);
				    }
				}
			    } else {
				smiFree((yyvsp[-1].id));
				if (objectPtr->typePtr) {

				    if (objectPtr->typePtr->export.name) {
					typePtr = objectPtr->typePtr;
				    } else {
					typePtr = objectPtr->typePtr->parentPtr;
				    }
				    if (((yyvsp[0].typePtr) != typePtr) &&
					(((yyvsp[0].typePtr)->export.basetype !=
					  SMI_BASETYPE_INTEGER32) ||
					 (typePtr->export.basetype !=
					  SMI_BASETYPE_ENUM)) &&
					(((yyvsp[0].typePtr)->export.basetype !=
					  SMI_BASETYPE_OCTETSTRING) ||
					 (typePtr->export.basetype !=
					  SMI_BASETYPE_BITS))) {
					smiPrintError(thisParserPtr,
						      ERR_SEQUENCE_TYPE_MISMATCH,
						      objectPtr->export.name);
				    }

				} else {
				    setObjectType(objectPtr, (yyvsp[0].typePtr));
				    addObjectFlags(objectPtr,
						   FLAG_SEQTYPE);
				}
			    }

			    (yyval.objectPtr) = objectPtr;
			}
#line 4415 "parser-smi.c"
    break;

  case 117: /* Syntax: ObjectSyntax  */
#line 2613 "parser-smi.y"
                        {
			    (yyval.typePtr) = (yyvsp[0].typePtr);
			    if ((yyval.typePtr))
				defaultBasetype = (yyval.typePtr)->export.basetype;
			}
#line 4425 "parser-smi.c"
    break;

  case 118: /* Syntax: BITS '{' NamedBits '}'  */
#line 2621 "parser-smi.y"
                        {
			    Type *typePtr;
			    List *p;
			    
			    defaultBasetype = SMI_BASETYPE_BITS;
			    typePtr = addType(NULL, SMI_BASETYPE_BITS,
					      FLAG_INCOMPLETE,
					      thisParserPtr);
			    setTypeDecl(typePtr, SMI_DECL_IMPLICIT_TYPE);
			    setTypeParent(typePtr, smiHandle->typeBitsPtr);
			    setTypeList(typePtr, (yyvsp[-1].listPtr));
			    for (p = (yyvsp[-1].listPtr); p; p = p->nextPtr)
				((NamedNumber *)p->ptr)->typePtr = typePtr;
			    smiCheckNamedNumbersOrder(parserPtr, typePtr);
			    (yyval.typePtr) = typePtr;
			}
#line 4446 "parser-smi.c"
    break;

  case 119: /* sequenceSyntax: sequenceObjectSyntax  */
#line 2641 "parser-smi.y"
                        {
			    (yyval.typePtr) = (yyvsp[0].typePtr);
			}
#line 4454 "parser-smi.c"
    break;

  case 120: /* sequenceSyntax: BITS  */
#line 2645 "parser-smi.y"
                        {
			    /* TODO: */
			    (yyval.typePtr) = smiHandle->typeOctetStringPtr;
			}
#line 4463 "parser-smi.c"
    break;

  case 121: /* sequenceSyntax: UPPERCASE_IDENTIFIER anySubType  */
#line 2650 "parser-smi.y"
                        {
			    Type *typePtr;
			    Import *importPtr;
			    
			    (yyval.typePtr) = findTypeByModulenameAndName(
				thisParserPtr->modulePtr->export.name, (yyvsp[-1].id));
			    if (! (yyval.typePtr)) {
				importPtr = findImportByName((yyvsp[-1].id),
							     thisModulePtr);
				if (!importPtr ||
				    (importPtr->kind == KIND_NOTFOUND)) {
				    /* 
				     * forward referenced type. create it,
				     * marked with FLAG_INCOMPLETE.
				     */
				    typePtr = addType((yyvsp[-1].id), SMI_BASETYPE_UNKNOWN,
						      FLAG_INCOMPLETE,
						      thisParserPtr);
				    (yyval.typePtr) = typePtr;
				} else {
				    importPtr->use++;
				    (yyval.typePtr) = findTypeByModulenameAndName(
					importPtr->export.module,
					importPtr->export.name);
				    smiFree((yyvsp[-1].id));
				}
			    } else {
				smiFree((yyvsp[-1].id));
			    }
			}
#line 4498 "parser-smi.c"
    break;

  case 122: /* NamedBits: NamedBit  */
#line 2683 "parser-smi.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].namedNumberPtr);
			    (yyval.listPtr)->nextPtr = NULL;
			}
#line 4508 "parser-smi.c"
    break;

  case 123: /* NamedBits: NamedBits ',' NamedBit  */
#line 2689 "parser-smi.y"
                        {
			    List *p, *pp;
			    
			    p = smiMalloc(sizeof(List));
			    p->ptr = (void *)(yyvsp[0].namedNumberPtr);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-2].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    (yyval.listPtr) = (yyvsp[-2].listPtr);
			}
#line 4523 "parser-smi.c"
    break;

  case 124: /* $@10: %empty  */
#line 2702 "parser-smi.y"
                        {
			    checkNameLen(thisParserPtr, (yyvsp[0].id),
					 ERR_BITNAME_32, ERR_BITNAME_64);
			    if (thisModulePtr->export.language == SMI_LANGUAGE_SMIV2)
			    {
				if (strchr((yyvsp[0].id), '-')) {
				    smiPrintError(thisParserPtr,
						  ERR_NAMEDBIT_INCLUDES_HYPHEN,
						  (yyvsp[0].id));
				}
			    }
			}
#line 4540 "parser-smi.c"
    break;

  case 125: /* NamedBit: LOWERCASE_IDENTIFIER $@10 '(' NUMBER ')'  */
#line 2715 "parser-smi.y"
                        {
			    (yyval.namedNumberPtr) = smiMalloc(sizeof(NamedNumber));
			    (yyval.namedNumberPtr)->export.name = (yyvsp[-4].id);
			    (yyval.namedNumberPtr)->export.value.basetype =
				                       SMI_BASETYPE_UNSIGNED32;
			    (yyval.namedNumberPtr)->export.value.value.unsigned32 = (yyvsp[-1].unsigned32);
			    /* RFC 2578 7.1.4 */
			    if ((yyvsp[-1].unsigned32) >= 65535*8) {
				smiPrintError(thisParserPtr,
					      ERR_BITS_NUMBER_TOO_LARGE,
					      (yyvsp[-4].id), (yyvsp[-1].unsigned32));
			    } else {
				if ((yyvsp[-1].unsigned32) >= 128) {
				    smiPrintError(thisParserPtr,
						  ERR_BITS_NUMBER_LARGE,
						  (yyvsp[-4].id), (yyvsp[-1].unsigned32));
				}
			    }
			}
#line 4564 "parser-smi.c"
    break;

  case 126: /* $@11: %empty  */
#line 2737 "parser-smi.y"
                        {
			    thisParserPtr->firstStatementLine = thisParserPtr->line;
			    thisParserPtr->currentDecl = SMI_DECL_OBJECTIDENTITY;

			    checkNameLen(thisParserPtr, (yyvsp[0].id),
					 ERR_OIDNAME_32, ERR_OIDNAME_64);
			    smiCheckObjectName(thisParserPtr,
					       thisModulePtr, (yyvsp[0].id));
			}
#line 4578 "parser-smi.c"
    break;

  case 127: /* $@12: %empty  */
#line 2747 "parser-smi.y"
                        {
			    Import *importPtr;

			    if (strcmp(thisModulePtr->export.name, "SNMPv2-SMI") &&
                                strcmp(thisModulePtr->export.name, "COPS-PR-SPPI")) {
				importPtr = findImportByName("OBJECT-IDENTITY",
							     thisModulePtr);
				if (importPtr) {
				    importPtr->use++;
				} else {
                                    if (thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)
				        smiPrintError(thisParserPtr,
						      ERR_MACRO_NOT_IMPORTED,
						      "OBJECT-IDENTITY",
						      "SNMPv2-SMI");
                                    else
				        smiPrintError(thisParserPtr,
						      ERR_MACRO_NOT_IMPORTED,
						      "OBJECT-IDENTITY",
						      "COPS-PR-SPPI");
				}
			    }
			}
#line 4606 "parser-smi.c"
    break;

  case 128: /* $@13: %empty  */
#line 2772 "parser-smi.y"
                        {
			    checkDescr(thisParserPtr, (yyvsp[0].text));
			}
#line 4614 "parser-smi.c"
    break;

  case 129: /* objectIdentityClause: LOWERCASE_IDENTIFIER $@11 OBJECT_IDENTITY $@12 STATUS Status DESCRIPTION Text $@13 ReferPart COLON_COLON_EQUAL '{' objectIdentifier '}'  */
#line 2778 "parser-smi.y"
                        {
			    Object *objectPtr;
			    
			    objectPtr = (yyvsp[-1].objectPtr);
			    smiCheckObjectReuse(thisParserPtr, (yyvsp[-13].id), &objectPtr);

			    objectPtr = setObjectName(objectPtr, (yyvsp[-13].id), thisParserPtr);
			    setObjectDecl(objectPtr, SMI_DECL_OBJECTIDENTITY);
			    setObjectLine(objectPtr, thisParserPtr->firstStatementLine,
					  thisParserPtr);
			    setObjectStatus(objectPtr, (yyvsp[-8].status));
			    setObjectDescription(objectPtr, (yyvsp[-6].text), thisParserPtr);
			    if ((yyvsp[-4].text)) {
				setObjectReference(objectPtr, (yyvsp[-4].text), thisParserPtr);
			    }
			    addObjectFlags(objectPtr, FLAG_REGISTERED);
			    deleteObjectFlags(objectPtr, FLAG_INCOMPLETE);
			    (yyval.err) = 0;
			}
#line 4638 "parser-smi.c"
    break;

  case 130: /* $@14: %empty  */
#line 2800 "parser-smi.y"
                        {
			    thisParserPtr->firstStatementLine = thisParserPtr->line;
			    thisParserPtr->currentDecl = SMI_DECL_OBJECTTYPE;
			    
			    checkNameLen(thisParserPtr, (yyvsp[0].id),
					 ERR_OIDNAME_32, ERR_OIDNAME_64);
			    smiCheckObjectName(thisParserPtr,
					       thisModulePtr, (yyvsp[0].id));
			}
#line 4652 "parser-smi.c"
    break;

  case 131: /* $@15: %empty  */
#line 2810 "parser-smi.y"
                        {
			    Import *importPtr;
			    
			    importPtr = findImportByName("OBJECT-TYPE",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_MACRO_NOT_IMPORTED,
						  "OBJECT-TYPE", "SNMPv2-SMI");
				} else if (thisModulePtr->export.language ==
                                    SMI_LANGUAGE_SPPI) {
                                    smiPrintError(thisParserPtr,
                                                  ERR_MACRO_NOT_IMPORTED,
                                                  "OBJECT-TYPE", "COPS-PR-SPPI");
                                } else {
				    smiPrintError(thisParserPtr,
						  ERR_MACRO_NOT_IMPORTED,
						  "OBJECT-TYPE", "RFC-1212");
				}
			    }
                            indexFlag = 0;
			}
#line 4683 "parser-smi.c"
    break;

  case 132: /* objectTypeClause: LOWERCASE_IDENTIFIER $@14 OBJECT_TYPE $@15 SYNTAX Syntax UnitsPart MaxOrPIBAccessPart SPPIPibReferencesPart SPPIPibTagPart STATUS Status descriptionClause SPPIErrorsPart ReferPart IndexPart MibIndex SPPIUniquePart DefValPart COLON_COLON_EQUAL '{' ObjectName '}'  */
#line 2850 "parser-smi.y"
                        {
			    Object *objectPtr, *parentPtr;
			    Type *typePtr = NULL;
			    
			    objectPtr = (yyvsp[-1].objectPtr);

			    smiCheckObjectReuse(thisParserPtr, (yyvsp[-22].id), &objectPtr);

			    objectPtr = setObjectName(objectPtr, (yyvsp[-22].id), thisParserPtr);
			    setObjectDecl(objectPtr, SMI_DECL_OBJECTTYPE);
			    setObjectLine(objectPtr, thisParserPtr->firstStatementLine,
					  thisParserPtr);
			    if (checkObjectFlags(objectPtr, FLAG_SEQTYPE)) {
				deleteObjectFlags(objectPtr, FLAG_SEQTYPE);
				if ((yyvsp[-17].typePtr)) {
				    if ((yyvsp[-17].typePtr)->export.name) {
					typePtr = (yyvsp[-17].typePtr);
                                        /*
                                         * According to RFC 3159 7.1.3. Opaque must not be used
                                         * in a SYNTAX clause.
                                         */
                                        if ((thisModulePtr->export.language == SMI_LANGUAGE_SPPI) &&
                                            !strcmp(typePtr->export.name, "Opaque"))
                                            smiPrintError(thisParserPtr, ERR_OPAQUE_IN_SYNTAX);
                                        /*
                                         * According to RFC 3159 7.1.4. IpAddress must not be used
                                         * in a SYNTAX clause.
                                         */
                                        if ((thisModulePtr->export.language == SMI_LANGUAGE_SPPI) &&
                                            !strcmp(typePtr->export.name, "IpAddress"))
                                            smiPrintError(thisParserPtr, ERR_IPADDRESS_IN_SYNTAX);
				    } else {
					typePtr = (yyvsp[-17].typePtr)->parentPtr;
				    }
				    if ((objectPtr->typePtr != typePtr) &&
					((objectPtr->typePtr->export.basetype !=
					  SMI_BASETYPE_INTEGER32) ||
					 (typePtr->export.basetype !=
					  SMI_BASETYPE_ENUM)) &&
					((objectPtr->typePtr->export.basetype !=
					  SMI_BASETYPE_OCTETSTRING) ||
					 (typePtr->export.basetype !=
					  SMI_BASETYPE_BITS))) {
					smiPrintError(thisParserPtr,
						      ERR_SEQUENCE_TYPE_MISMATCH,
						      objectPtr->export.name);
				    }
				}
			    }
			    setObjectType(objectPtr, (yyvsp[-17].typePtr));
			    if (!((yyvsp[-17].typePtr)->export.name)) {
				/*
				 * An inlined type.
				 */
#if 0 /* export implicitly defined types by the node's lowercase name */
				setTypeName((yyvsp[-17].typePtr), (yyvsp[-22].id));
#endif
			    }
			    setObjectUnits(objectPtr, (yyvsp[-16].text));
			    setObjectAccess(objectPtr, (yyvsp[-15].access));
			    if (thisParserPtr->flags & FLAG_CREATABLE) {
				thisParserPtr->flags &= ~FLAG_CREATABLE;
				parentPtr =
				  objectPtr->nodePtr->parentPtr->lastObjectPtr;
				if (parentPtr &&
				    parentPtr->export.indexkind !=
				       SMI_INDEX_UNKNOWN) {
				    /*
				     * add objectPtr to the parent object's
				     * listPtr, which is the list of columns
				     * needed for row creation.
				     *
				     * Note, that this would clash, if the
				     * parent row object-type is not yet
				     * defined.
				     */
				    /*
				    newlistPtr = smiMalloc(sizeof(List));
				    newlistPtr->nextPtr = NULL;
				    newlistPtr->ptr = objectPtr;
				    */
				    /*
				     * Look up the parent object-type.
				     */
				    /*
				    if (parentPtr->listPtr) {
					for(listPtr = parentPtr->listPtr;
					    listPtr->nextPtr;
					    listPtr = listPtr->nextPtr);
					listPtr->nextPtr = newlistPtr;
				    } else {
					parentPtr->listPtr = newlistPtr;
				    }
				    */
				    addObjectFlags(parentPtr, FLAG_CREATABLE);
				    setObjectCreate(parentPtr, 1);
				} else {
				    smiPrintError(thisParserPtr,
						  ERR_SCALAR_READCREATE);
				}
			    }
			    setObjectStatus(objectPtr, (yyvsp[-11].status));
			    addObjectFlags(objectPtr, FLAG_REGISTERED);
			    deleteObjectFlags(objectPtr, FLAG_INCOMPLETE);
			    if ((yyvsp[-10].text)) {
				setObjectDescription(objectPtr, (yyvsp[-10].text), thisParserPtr);
			    }
			    if ((yyvsp[-8].text)) {
				setObjectReference(objectPtr, (yyvsp[-8].text), thisParserPtr);
			    }
                            if (thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI) {
                                /*
                                 * For SMI documents either $16 (IndexPart) or $17 (MibIndex)
                                 * are used, but not both. This is signalled via the indexFlag
                                 * which is 1 if IndexPart has been used.
                                 */
                                if (indexFlag == INDEXFLAG_AUGMENTS) { /* IndexPart was used */
			            if ((yyvsp[-7].index).indexkind != SMI_INDEX_UNKNOWN) {
				        setObjectList(objectPtr, (yyvsp[-7].index).listPtr);
				        setObjectImplied(objectPtr, (yyvsp[-7].index).implied);
				        setObjectIndexkind(objectPtr, (yyvsp[-7].index).indexkind);
				        setObjectRelated(objectPtr, (yyvsp[-7].index).rowPtr);
			            }
                                } else {
			            if ((yyvsp[-6].index).indexkind != SMI_INDEX_UNKNOWN) {
				        setObjectList(objectPtr, (yyvsp[-6].index).listPtr);
				        setObjectImplied(objectPtr, (yyvsp[-6].index).implied);
				        setObjectIndexkind(objectPtr, (yyvsp[-6].index).indexkind);
				        setObjectRelated(objectPtr, (yyvsp[-6].index).rowPtr);
			            }
                                }
                            } else {
                                /*
                                 * PIBs contain either PIB-INDEX or AUGMENTS or EXTENDS - 
                                 * but only with one Index entry. A PIB-INDEX may be
                                 * followed by a full INDEX. We get the indexkind
                                 * from the first.
                                 * Note that PIB-INDEX/AUGMENTS/EXTENS is always
                                 * the first element in objectPtr->listPtr.
                                 * If an optional INDEX exists then it is
                                 * appended to this list.
                                 */
			        if ((yyvsp[-7].index).indexkind != SMI_INDEX_UNKNOWN) {
                                    setObjectList(objectPtr, (yyvsp[-7].index).listPtr);
				    setObjectIndexkind(objectPtr, (yyvsp[-7].index).indexkind);
				    setObjectRelated(objectPtr, (yyvsp[-7].index).rowPtr);
			        }
			        if ((yyvsp[-6].index).indexkind != SMI_INDEX_UNKNOWN) {
                                    if (objectPtr->listPtr) {
                                        List *p;
                                        for (p = objectPtr->listPtr; p->nextPtr;
                                             p = p->nextPtr);
                                        p->nextPtr = (yyvsp[-6].index).listPtr;
                                    }
				    setObjectImplied(objectPtr, (yyvsp[-6].index).implied);
			        }
                            }
                            if ((yyvsp[-5].listPtr)) {
                                setObjectUniqueness(objectPtr, (yyvsp[-5].listPtr));
                            }
			    if ((yyvsp[-4].valuePtr)) {
				if (objectPtr->typePtr
				    && (((objectPtr->typePtr->export.basetype == SMI_BASETYPE_OCTETSTRING) &&
					 ((yyvsp[-4].valuePtr)->basetype != SMI_BASETYPE_OCTETSTRING))
					|| ((objectPtr->typePtr->export.basetype == SMI_BASETYPE_OBJECTIDENTIFIER) &&
					    ((yyvsp[-4].valuePtr)->basetype != SMI_BASETYPE_OBJECTIDENTIFIER)))) {
				    smiPrintError(thisParserPtr,
						  ERR_DEFVAL_SYNTAX);
				    if ((yyvsp[-4].valuePtr)->basetype == SMI_BASETYPE_OBJECTIDENTIFIER) {
					smiFree((yyvsp[-4].valuePtr)->value.oid);
				    }
				    if (((yyvsp[-4].valuePtr)->basetype == SMI_BASETYPE_BITS) ||
					((yyvsp[-4].valuePtr)->basetype == SMI_BASETYPE_OCTETSTRING)) {
					smiFree((yyvsp[-4].valuePtr)->value.ptr);
				    }
				    smiFree((yyvsp[-4].valuePtr));
				} else {
				    setObjectValue(objectPtr, (yyvsp[-4].valuePtr));
				}
			    }
                            if ((yyvsp[-14].objectPtr)) {
                                if (objectPtr->relatedPtr)
                                    smiPrintError(thisParserPtr, ERR_OBJECTPTR_ELEMENT_IN_USE,
                                                  "relatedPtr", "PIB-REFERENCES");
                                /*
                                 * PIB-REFERENCES clauses are only allowed for
                                 * objects with a SYNTAX of 'ReferenceId'.
                                 * See RFC 3159 7.10
                                 */
                                if (objectPtr->typePtr && objectPtr->typePtr->export.name &&
                                    strcmp(objectPtr->typePtr->export.name, "ReferenceId"))
                                    smiPrintErrorAtLine(parserPtr, ERR_PIB_REFERENCES_WRONG_TYPE,
                                                        objectPtr->line);
                                else
                                    setObjectRelated(objectPtr, (yyvsp[-14].objectPtr));
                            } else {
                               /*
                                * Does this object have a SYNTAX of 'ReferenceId'
                                * and a PIB-REFERENCES clause?
                                * See RFC 3159 7.10
                                */
                               if ((thisModulePtr->export.language == SMI_LANGUAGE_SPPI) &&
                                   objectPtr->typePtr && objectPtr->typePtr->export.name &&
                                   !strcmp(objectPtr->typePtr->export.name, "ReferenceId"))
                                   smiPrintErrorAtLine(parserPtr, ERR_LACKING_PIB_REFERENCES,
                                                       objectPtr->line);
                            }
                            if ((yyvsp[-13].objectPtr)) {
                                if (objectPtr->relatedPtr)
                                    smiPrintError(thisParserPtr, ERR_OBJECTPTR_ELEMENT_IN_USE,
                                                  "relatedPtr", "PIB-TAG");
                                /*
                                 * PIB-TAG clauses are only allowed for
                                 * objects with a SYNTAX of 'TagReferenceId'.
                                 * See RFC 3159 7.11
                                 */
                                if (objectPtr->typePtr && objectPtr->typePtr->export.name &&
                                    strcmp(objectPtr->typePtr->export.name, "TagReferenceId"))
                                    smiPrintErrorAtLine(parserPtr, ERR_PIB_TAG_WRONG_TYPE,
                                                        objectPtr->line);
                                else
                                    setObjectRelated(objectPtr, (yyvsp[-13].objectPtr));
                            } else {
                                /*
                                 * Does this object have a SYNTAX of 'TagReferenceId'
                                 * and a PIB-TAG clause?
                                 * See RFC 3159 7.11
                                 */
                                if ((thisModulePtr->export.language == SMI_LANGUAGE_SPPI) &&
                                    objectPtr->typePtr && objectPtr->typePtr->export.name &&
                                    !strcmp(objectPtr->typePtr->export.name, "TagReferenceId"))
                                    smiPrintErrorAtLine(parserPtr, ERR_LACKING_PIB_TAG,
                                                        objectPtr->line);

                            }
                            if ((yyvsp[-9].listPtr)) {
                                if (objectPtr->listPtr)
                                    smiPrintError(thisParserPtr, ERR_OBJECTPTR_ELEMENT_IN_USE,
                                                  "listPtr", "INSTALL-ERRORS");
                                /*
                                 * Are INSTALL-ERRORS only used with tables?
                                 * See RFC 3159 7.4
                                 */
                                if (!((objectPtr->export.decl == SMI_DECL_OBJECTTYPE) &&
                                    (objectPtr->typePtr) &&
                                    (objectPtr->typePtr->export.decl == SMI_DECL_IMPL_SEQUENCEOF)))
                                    smiPrintErrorAtLine(parserPtr, ERR_INSTALL_ERRORS_FOR_NON_TABLE,
                                                        objectPtr->line);
                                else
                                    setObjectList(objectPtr, (yyvsp[-9].listPtr));
                            }
			    (yyval.err) = 0;
			}
#line 4941 "parser-smi.c"
    break;

  case 133: /* descriptionClause: %empty  */
#line 3106 "parser-smi.y"
                        {
			    if ((thisModulePtr->export.language == SMI_LANGUAGE_SMIV2) ||
                                (thisModulePtr->export.language == SMI_LANGUAGE_SPPI))
			    {
				smiPrintError(thisParserPtr,
					      ERR_MISSING_DESCRIPTION);
			    }
			    (yyval.text) = NULL;
			}
#line 4955 "parser-smi.c"
    break;

  case 134: /* descriptionClause: DESCRIPTION Text  */
#line 3116 "parser-smi.y"
                        {
			    (yyval.text) = (yyvsp[0].text);
			    checkDescr(thisParserPtr, (yyvsp[0].text));
			}
#line 4964 "parser-smi.c"
    break;

  case 135: /* $@16: %empty  */
#line 3123 "parser-smi.y"
                        {
			    thisParserPtr->firstStatementLine = thisParserPtr->line;
			    thisParserPtr->currentDecl = SMI_DECL_TRAPTYPE;
			    
			    checkNameLen(thisParserPtr, (yyvsp[0].id),
					 ERR_OIDNAME_32, ERR_OIDNAME_64);
			    smiCheckObjectName(thisParserPtr,
					       thisModulePtr, (yyvsp[0].id));
			}
#line 4978 "parser-smi.c"
    break;

  case 136: /* $@17: %empty  */
#line 3133 "parser-smi.y"
                        {
			    Import *importPtr;
                            if (thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "TRAP-TYPE");
			    
			    if (thisModulePtr->export.language == SMI_LANGUAGE_SMIV2)
			    {
			        smiPrintError(thisParserPtr, ERR_TRAP_TYPE);
			    }

			    importPtr = findImportByName("TRAP-TYPE",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				smiPrintError(thisParserPtr,
					      ERR_MACRO_NOT_IMPORTED,
					      "TRAP-TYPE", "RFC-1215");
			    }
			}
#line 5003 "parser-smi.c"
    break;

  case 137: /* trapTypeClause: fuzzy_lowercase_identifier $@16 TRAP_TYPE $@17 ENTERPRISE objectIdentifier VarPart DescrPart ReferPart COLON_COLON_EQUAL NUMBER  */
#line 3159 "parser-smi.y"
                        {
			    Object *objectPtr;
			    Node *nodePtr;
			    
			    objectPtr = (yyvsp[-5].objectPtr);
			    nodePtr = findNodeByParentAndSubid(
				objectPtr->nodePtr, 0);
			    if (nodePtr && nodePtr->lastObjectPtr &&
	       		        (nodePtr->lastObjectPtr->modulePtr == thisModulePtr)) {
				/*
				 * hopefully, the last defined Object for
				 * this Node is the one we expect.
				 */
				objectPtr = nodePtr->lastObjectPtr;
			    } else {
				objectPtr = addObject(NULL,
						      objectPtr->nodePtr,
						      0,
						      FLAG_INCOMPLETE,
						      thisParserPtr);
			    }
			    objectPtr = addObject(NULL,
						  objectPtr->nodePtr,
						  (yyvsp[0].unsigned32),
						  FLAG_INCOMPLETE,
						  thisParserPtr);
			    
			    smiCheckObjectReuse(thisParserPtr, (yyvsp[-10].id), &objectPtr);

			    objectPtr = setObjectName(objectPtr, (yyvsp[-10].id), thisParserPtr);
			    setObjectDecl(objectPtr,
					  SMI_DECL_TRAPTYPE);
			    setObjectLine(objectPtr, thisParserPtr->firstStatementLine,
					  thisParserPtr);
			    addObjectFlags(objectPtr, FLAG_REGISTERED);
			    deleteObjectFlags(objectPtr, FLAG_INCOMPLETE);
			    setObjectList(objectPtr, (yyvsp[-4].listPtr));
			    setObjectStatus(objectPtr, SMI_STATUS_CURRENT); 
			    setObjectDescription(objectPtr, (yyvsp[-3].text), thisParserPtr);
			    if ((yyvsp[-2].text)) {
				setObjectReference(objectPtr, (yyvsp[-2].text), thisParserPtr);
			    }
			    (yyval.err) = 0;
			}
#line 5052 "parser-smi.c"
    break;

  case 138: /* VarPart: VARIABLES '{' VarTypes '}'  */
#line 3206 "parser-smi.y"
                        {
			    (yyval.listPtr) = (yyvsp[-1].listPtr);
			}
#line 5060 "parser-smi.c"
    break;

  case 139: /* VarPart: %empty  */
#line 3210 "parser-smi.y"
                        {
			    (yyval.listPtr) = NULL;
			}
#line 5068 "parser-smi.c"
    break;

  case 140: /* VarTypes: VarType  */
#line 3216 "parser-smi.y"
                        {
			    if ((yyvsp[0].objectPtr)) {
				(yyval.listPtr) = smiMalloc(sizeof(List));
				(yyval.listPtr)->ptr = (yyvsp[0].objectPtr);
				(yyval.listPtr)->nextPtr = NULL;
			    } else {
				(yyval.listPtr) = NULL;
			    }
			}
#line 5082 "parser-smi.c"
    break;

  case 141: /* VarTypes: VarTypes ',' VarType  */
#line 3226 "parser-smi.y"
                        {
			    List *p, *pp;

			    if ((yyvsp[0].objectPtr)) {
				p = smiMalloc(sizeof(List));
				p->ptr = (yyvsp[0].objectPtr);
				p->nextPtr = NULL;
				if ((yyvsp[-2].listPtr)) {
				    for (pp = (yyvsp[-2].listPtr); pp->nextPtr;
					 pp = pp->nextPtr);
				    pp->nextPtr = p;
				    (yyval.listPtr) = (yyvsp[-2].listPtr);
				} else {
				    (yyval.listPtr) = p;
				}
			    } else {
				(yyval.listPtr) = (yyvsp[-2].listPtr);
			    }
			}
#line 5106 "parser-smi.c"
    break;

  case 142: /* VarType: ObjectName  */
#line 3248 "parser-smi.y"
                        {
			    (yyval.objectPtr) = (yyvsp[0].objectPtr);
			}
#line 5114 "parser-smi.c"
    break;

  case 143: /* DescrPart: DESCRIPTION Text  */
#line 3254 "parser-smi.y"
                        {
			    (yyval.text) = (yyvsp[0].text);
			    checkDescr(thisParserPtr, (yyvsp[0].text));
			}
#line 5123 "parser-smi.c"
    break;

  case 144: /* DescrPart: %empty  */
#line 3259 "parser-smi.y"
                        { (yyval.text) = NULL; }
#line 5129 "parser-smi.c"
    break;

  case 145: /* MaxOrPIBAccessPart: MaxAccessPart  */
#line 3263 "parser-smi.y"
                        {
                            (yyval.access) = (yyvsp[0].access);
                        }
#line 5137 "parser-smi.c"
    break;

  case 146: /* MaxOrPIBAccessPart: PibAccessPart  */
#line 3267 "parser-smi.y"
                        {
                            if (thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SPPI_CONSTRUCT_IN_MIB, "MAX-ACCESS");
                            if ((yyvsp[0].access) == SMI_ACCESS_NOT_ACCESSIBLE)
                                smiPrintError(thisParserPtr, ERR_NOT_ACCESSIBLE_IN_PIB_ACCESS);
                            (yyval.access) = (yyvsp[0].access);
                        }
#line 5149 "parser-smi.c"
    break;

  case 147: /* MaxOrPIBAccessPart: %empty  */
#line 3275 "parser-smi.y"
                        { (yyval.access) = 0;  }
#line 5155 "parser-smi.c"
    break;

  case 148: /* PibAccessPart: PibAccess Access  */
#line 3279 "parser-smi.y"
                        { (yyval.access) = (yyvsp[0].access); }
#line 5161 "parser-smi.c"
    break;

  case 149: /* PibAccess: POLICY_ACCESS  */
#line 3283 "parser-smi.y"
                        { 
                            smiPrintError(thisParserPtr, ERR_POLICY_ACCESS_IN_PIB);
                        }
#line 5169 "parser-smi.c"
    break;

  case 150: /* PibAccess: PIB_ACCESS  */
#line 3287 "parser-smi.y"
                        { }
#line 5175 "parser-smi.c"
    break;

  case 151: /* $@18: %empty  */
#line 3291 "parser-smi.y"
                        {
                            if (thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SPPI_CONSTRUCT_IN_MIB, "PIB-REFERENCES");
                        }
#line 5184 "parser-smi.c"
    break;

  case 152: /* SPPIPibReferencesPart: PIB_REFERENCES $@18 '{' Entry '}'  */
#line 3296 "parser-smi.y"
                        { (yyval.objectPtr) = (yyvsp[-1].objectPtr); }
#line 5190 "parser-smi.c"
    break;

  case 153: /* SPPIPibReferencesPart: %empty  */
#line 3298 "parser-smi.y"
                        { (yyval.objectPtr) = 0; }
#line 5196 "parser-smi.c"
    break;

  case 154: /* $@19: %empty  */
#line 3302 "parser-smi.y"
                        {
                            if (thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SPPI_CONSTRUCT_IN_MIB, "PIB-TAG");
                        }
#line 5205 "parser-smi.c"
    break;

  case 155: /* SPPIPibTagPart: PIB_TAG $@19 '{' ObjectName '}'  */
#line 3307 "parser-smi.y"
                        { (yyval.objectPtr) = (yyvsp[-1].objectPtr); }
#line 5211 "parser-smi.c"
    break;

  case 156: /* SPPIPibTagPart: %empty  */
#line 3309 "parser-smi.y"
                        { (yyval.objectPtr) = 0; }
#line 5217 "parser-smi.c"
    break;

  case 157: /* $@20: %empty  */
#line 3314 "parser-smi.y"
                        {
                            if (thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SPPI_CONSTRUCT_IN_MIB, "UNIQUENESS");
                        }
#line 5226 "parser-smi.c"
    break;

  case 158: /* SPPIUniquePart: UNIQUENESS $@20 '{' UniqueTypesPart '}'  */
#line 3319 "parser-smi.y"
                        { (yyval.listPtr) = (yyvsp[-1].listPtr); }
#line 5232 "parser-smi.c"
    break;

  case 159: /* SPPIUniquePart: %empty  */
#line 3321 "parser-smi.y"
                        { (yyval.listPtr) = NULL; }
#line 5238 "parser-smi.c"
    break;

  case 160: /* UniqueTypesPart: UniqueTypes  */
#line 3325 "parser-smi.y"
                        { (yyval.listPtr) = (yyvsp[0].listPtr); }
#line 5244 "parser-smi.c"
    break;

  case 161: /* UniqueTypesPart: %empty  */
#line 3327 "parser-smi.y"
                        { (yyval.listPtr) = NULL; }
#line 5250 "parser-smi.c"
    break;

  case 162: /* UniqueTypes: UniqueType  */
#line 3331 "parser-smi.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].objectPtr);
			    (yyval.listPtr)->nextPtr = NULL;
			}
#line 5260 "parser-smi.c"
    break;

  case 163: /* UniqueTypes: UniqueTypes ',' UniqueType  */
#line 3338 "parser-smi.y"
                        {
			    List *p, *pp;
			    
			    p = smiMalloc(sizeof(List));
			    p->ptr = (yyvsp[0].objectPtr);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-2].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    (yyval.listPtr) = (yyvsp[-2].listPtr);
                        }
#line 5275 "parser-smi.c"
    break;

  case 164: /* UniqueType: ObjectName  */
#line 3351 "parser-smi.y"
                        { (yyval.objectPtr) = (yyvsp[0].objectPtr); }
#line 5281 "parser-smi.c"
    break;

  case 165: /* $@21: %empty  */
#line 3355 "parser-smi.y"
                        {
                            if (thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SPPI_CONSTRUCT_IN_MIB, "INSTALL-ERRORS");
                        }
#line 5290 "parser-smi.c"
    break;

  case 166: /* SPPIErrorsPart: INSTALL_ERRORS $@21 '{' Errors '}'  */
#line 3360 "parser-smi.y"
                        { (yyval.listPtr) = (yyvsp[-1].listPtr); }
#line 5296 "parser-smi.c"
    break;

  case 167: /* SPPIErrorsPart: %empty  */
#line 3362 "parser-smi.y"
                        { (yyval.listPtr) = NULL; }
#line 5302 "parser-smi.c"
    break;

  case 168: /* Errors: Error  */
#line 3366 "parser-smi.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].objectPtr);
			    (yyval.listPtr)->nextPtr = NULL;
			}
#line 5312 "parser-smi.c"
    break;

  case 169: /* Errors: Errors ',' Error  */
#line 3373 "parser-smi.y"
                        {
			    List *p, *pp;
			    
			    p = smiMalloc(sizeof(List));
			    p->ptr = (yyvsp[0].objectPtr);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-2].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    (yyval.listPtr) = (yyvsp[-2].listPtr);
                        }
#line 5327 "parser-smi.c"
    break;

  case 170: /* Error: LOWERCASE_IDENTIFIER '(' NUMBER ')'  */
#line 3386 "parser-smi.y"
                        {
			    Object *objectPtr;
			    
                            if (((yyvsp[-1].unsigned32) < 1) || ((yyvsp[-1].unsigned32) > 65536))
                                smiPrintError(thisParserPtr, ERR_ERROR_NUMBER_RANGE, (yyvsp[-1].unsigned32));
                            /*
                             * This is not a regular object that will be added vid
                             * 'addObject' as error identifier have no other
                             * meaning in PIBs. They are just used for
                             * a direct mapping to the actual protocol fields.
                             */
                            objectPtr = smiMalloc(sizeof(Object));
                            objectPtr->export.name = (yyvsp[-3].id);
                            objectPtr->export.oidlen = 1;
                            objectPtr->export.oid = (void *)(yyvsp[-1].unsigned32);
			    (yyval.objectPtr) = objectPtr;
			}
#line 5349 "parser-smi.c"
    break;

  case 171: /* $@22: %empty  */
#line 3407 "parser-smi.y"
                        {
			    if (thisModulePtr->export.language == SMI_LANGUAGE_SMIV1)
			    {
			        smiPrintError(thisParserPtr,
					      ERR_MAX_ACCESS_IN_SMIV1);
			    } else if (thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "MAX-ACCESS");
			}
#line 5362 "parser-smi.c"
    break;

  case 172: /* MaxAccessPart: MAX_ACCESS $@22 Access  */
#line 3416 "parser-smi.y"
                        { (yyval.access) = (yyvsp[0].access); }
#line 5368 "parser-smi.c"
    break;

  case 173: /* $@23: %empty  */
#line 3418 "parser-smi.y"
                        {
			    if (thisModulePtr->export.language == SMI_LANGUAGE_SMIV2)
			    {
			        smiPrintError(thisParserPtr, ERR_ACCESS_IN_SMIV2);
			    } else if (thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "ACCESS");
			}
#line 5380 "parser-smi.c"
    break;

  case 174: /* MaxAccessPart: ACCESS $@23 Access  */
#line 3427 "parser-smi.y"
                        { (yyval.access) = (yyvsp[0].access); }
#line 5386 "parser-smi.c"
    break;

  case 175: /* $@24: %empty  */
#line 3431 "parser-smi.y"
                        {
			    thisParserPtr->firstStatementLine = thisParserPtr->line;
			    thisParserPtr->currentDecl = SMI_DECL_NOTIFICATIONTYPE;

			    checkNameLen(thisParserPtr, (yyvsp[0].id),
					 ERR_OIDNAME_32, ERR_OIDNAME_64);
			    smiCheckObjectName(thisParserPtr,
					       thisModulePtr, (yyvsp[0].id));
			}
#line 5400 "parser-smi.c"
    break;

  case 176: /* $@25: %empty  */
#line 3441 "parser-smi.y"
                        {
			    Import *importPtr;

                            if (thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "NOTIFICATION-TYPE");
                                
			    importPtr = findImportByName("NOTIFICATION-TYPE",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				smiPrintError(thisParserPtr,
					      ERR_MACRO_NOT_IMPORTED,
					      "NOTIFICATION-TYPE",
					      "SNMPv2-SMI");
			    }
			}
#line 5422 "parser-smi.c"
    break;

  case 177: /* $@26: %empty  */
#line 3461 "parser-smi.y"
                        {
			    checkDescr(thisParserPtr, (yyvsp[0].text));
			}
#line 5430 "parser-smi.c"
    break;

  case 178: /* notificationTypeClause: LOWERCASE_IDENTIFIER $@24 NOTIFICATION_TYPE $@25 NotificationObjectsPart STATUS Status DESCRIPTION Text $@26 ReferPart COLON_COLON_EQUAL '{' NotificationName '}'  */
#line 3467 "parser-smi.y"
                        {
			    Object *objectPtr;
			    
			    objectPtr = (yyvsp[-1].objectPtr);

			    smiCheckObjectReuse(thisParserPtr, (yyvsp[-14].id), &objectPtr);

			    objectPtr = setObjectName(objectPtr, (yyvsp[-14].id), thisParserPtr);
			    setObjectDecl(objectPtr,
					  SMI_DECL_NOTIFICATIONTYPE);
			    setObjectLine(objectPtr, thisParserPtr->firstStatementLine,
					  thisParserPtr);
			    addObjectFlags(objectPtr, FLAG_REGISTERED);
			    deleteObjectFlags(objectPtr, FLAG_INCOMPLETE);
			    setObjectList(objectPtr, (yyvsp[-10].listPtr));
			    setObjectStatus(objectPtr, (yyvsp[-8].status));
			    setObjectDescription(objectPtr, (yyvsp[-6].text), thisParserPtr);
			    if ((yyvsp[-4].text)) {
				setObjectReference(objectPtr, (yyvsp[-4].text), thisParserPtr);
			    }
			    (yyval.err) = 0;
			}
#line 5457 "parser-smi.c"
    break;

  case 179: /* $@27: %empty  */
#line 3492 "parser-smi.y"
                        {
			    thisParserPtr->firstStatementLine = thisParserPtr->line;
			    thisParserPtr->currentDecl = SMI_DECL_MODULEIDENTITY;
			    
			    checkNameLen(thisParserPtr, (yyvsp[0].id),
					 ERR_OIDNAME_32, ERR_OIDNAME_64);
			    smiCheckObjectName(thisParserPtr,
					       thisModulePtr, (yyvsp[0].id));
			}
#line 5471 "parser-smi.c"
    break;

  case 180: /* $@28: %empty  */
#line 3502 "parser-smi.y"
                        {
			    Import *importPtr;
			    
			    importPtr = findImportByName("MODULE-IDENTITY",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				smiPrintError(thisParserPtr,
					      ERR_MACRO_NOT_IMPORTED,
					      "MODULE-IDENTITY",
					      "SNMPv2-SMI");
			    }
			    
			    if (thisParserPtr->modulePtr->numModuleIdentities > 0)
			    {
			        smiPrintError(thisParserPtr,
					      ERR_TOO_MANY_MODULE_IDENTITIES);
			    }
			    if (thisParserPtr->modulePtr->numStatements > 0) {
			        smiPrintError(thisParserPtr,
					      ERR_MODULE_IDENTITY_NOT_FIRST);
			    }
			}
#line 5500 "parser-smi.c"
    break;

  case 181: /* $@29: %empty  */
#line 3527 "parser-smi.y"
                        {
                          /* do nothing at the moment */
                        }
#line 5508 "parser-smi.c"
    break;

  case 182: /* $@30: %empty  */
#line 3531 "parser-smi.y"
                        {
			    setModuleLastUpdated(thisParserPtr->modulePtr, (yyvsp[0].date));
			}
#line 5516 "parser-smi.c"
    break;

  case 183: /* $@31: %empty  */
#line 3535 "parser-smi.y"
                        {
			    if ((yyvsp[0].text) && !strlen((yyvsp[0].text))) {
				smiPrintError(thisParserPtr,
					      ERR_EMPTY_ORGANIZATION);
			    }
			}
#line 5527 "parser-smi.c"
    break;

  case 184: /* $@32: %empty  */
#line 3542 "parser-smi.y"
                        {
			    if ((yyvsp[0].text) && !strlen((yyvsp[0].text))) {
				smiPrintError(thisParserPtr,
					      ERR_EMPTY_CONTACT);
			    }
			}
#line 5538 "parser-smi.c"
    break;

  case 185: /* $@33: %empty  */
#line 3549 "parser-smi.y"
                        {
			    checkDescr(thisParserPtr, (yyvsp[0].text));
			}
#line 5546 "parser-smi.c"
    break;

  case 186: /* $@34: %empty  */
#line 3553 "parser-smi.y"
                        {
			    if ((!thisModulePtr->firstRevisionPtr) ||
				(thisModulePtr->firstRevisionPtr->export.date !=
				 thisModulePtr->lastUpdated)) {
				smiPrintError(thisParserPtr,
					      ERR_REVISION_MISSING);
				addRevision(thisModulePtr->lastUpdated,
					    smiStrdup(
						"[Revision added by libsmi due to a LAST-UPDATED clause.]"),
					    thisParserPtr);
			    }
			}
#line 5563 "parser-smi.c"
    break;

  case 187: /* moduleIdentityClause: LOWERCASE_IDENTIFIER $@27 MODULE_IDENTITY $@28 SubjectCategoriesPart $@29 LAST_UPDATED ExtUTCTime $@30 ORGANIZATION Text $@31 CONTACT_INFO Text $@32 DESCRIPTION Text $@33 RevisionPart $@34 COLON_COLON_EQUAL '{' objectIdentifier '}'  */
#line 3567 "parser-smi.y"
                        {
			    Object *objectPtr;
			    
			    objectPtr = (yyvsp[-1].objectPtr);
			    smiCheckObjectReuse(thisParserPtr, (yyvsp[-23].id), &objectPtr);

			    thisParserPtr->modulePtr->numModuleIdentities++;

			    objectPtr = setObjectName(objectPtr, (yyvsp[-23].id), thisParserPtr);
			    setObjectDecl(objectPtr, SMI_DECL_MODULEIDENTITY);
			    setObjectLine(objectPtr, thisParserPtr->firstStatementLine,
					  thisParserPtr);
			    setObjectStatus(objectPtr, SMI_STATUS_CURRENT);
			    addObjectFlags(objectPtr, FLAG_REGISTERED);
			    deleteObjectFlags(objectPtr, FLAG_INCOMPLETE);
			    setModuleIdentityObject(thisParserPtr->modulePtr,
						    objectPtr);
			    setModuleOrganization(thisParserPtr->modulePtr,
						  (yyvsp[-13].text));
			    setModuleContactInfo(thisParserPtr->modulePtr,
						 (yyvsp[-10].text));
			    setModuleDescription(thisParserPtr->modulePtr,
						 (yyvsp[-7].text), thisParserPtr);
                            if ((yyvsp[-19].subjectCategoriesPtr) != NULL) {
                                setObjectList(objectPtr, (yyvsp[-19].subjectCategoriesPtr)->categories);
                                smiFree((yyvsp[-19].subjectCategoriesPtr));
                            }
			    /* setObjectDescription(objectPtr, $15); */
			    (yyval.err) = 0;
			}
#line 5598 "parser-smi.c"
    break;

  case 188: /* SubjectCategoriesPart: SUBJECT_CATEGORIES '{' SubjectCategories '}'  */
#line 3600 "parser-smi.y"
                        {
                            if (thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SPPI_CONSTRUCT_IN_MIB, "SUBJECT-CATEGORIES");
                            (yyval.subjectCategoriesPtr) = (yyvsp[-1].subjectCategoriesPtr);
                        }
#line 5608 "parser-smi.c"
    break;

  case 189: /* SubjectCategoriesPart: %empty  */
#line 3606 "parser-smi.y"
                        {
                            if (thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SUBJECT_CATEGORIES_MISSING);
                            (yyval.subjectCategoriesPtr) = NULL;
                        }
#line 5618 "parser-smi.c"
    break;

  case 190: /* SubjectCategories: CategoryIDs  */
#line 3614 "parser-smi.y"
                        {
                            (yyval.subjectCategoriesPtr) = smiMalloc(sizeof(SubjectCategories));
                            (yyval.subjectCategoriesPtr)->categories    = (yyvsp[0].listPtr);
                        }
#line 5627 "parser-smi.c"
    break;

  case 191: /* CategoryIDs: CategoryID  */
#line 3621 "parser-smi.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].objectPtr);
			    (yyval.listPtr)->nextPtr = NULL;
			}
#line 5637 "parser-smi.c"
    break;

  case 192: /* CategoryIDs: CategoryIDs ',' CategoryID  */
#line 3627 "parser-smi.y"
                        {
			    List *p, *pp;
			    
                            if ((yyvsp[-2].listPtr)->ptr == NULL)
                                smiPrintError(thisParserPtr, ERR_SUBJECT_CATEGORIES_ALL);
			    p = smiMalloc(sizeof(List));
			    p->ptr = (void *)(yyvsp[0].objectPtr);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-2].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    (yyval.listPtr) = (yyvsp[-2].listPtr);
			}
#line 5654 "parser-smi.c"
    break;

  case 193: /* CategoryID: LOWERCASE_IDENTIFIER  */
#line 3642 "parser-smi.y"
                        {
                            Object *objectPtr;
                            
                            if (strcmp((yyvsp[0].id), "all"))
                                smiPrintError(thisParserPtr, ERR_SUBJECT_CATEGORIES_MISSING_SUBID);
                            else {
                                /*
                                 * This is not a regular object that will be added via
                                 * 'addObject' as subject category dentifier have no
                                 * other meaning in PIBs. They are just used for
                                 * a direct mapping to the actual protocol fields.
                                 */
                                objectPtr = smiMalloc(sizeof(Object));
                                objectPtr->export.name = "all";
                                objectPtr->export.oidlen = 0;
                                objectPtr->export.oid = 0;
                                (yyval.objectPtr) = objectPtr;
                            }
                            smiFree((yyvsp[0].id));
                        }
#line 5679 "parser-smi.c"
    break;

  case 194: /* CategoryID: LOWERCASE_IDENTIFIER '(' NUMBER ')'  */
#line 3663 "parser-smi.y"
                        {
			    Object *objectPtr;
			    
                            if (!strcmp((yyvsp[-3].id), "all")) {
                                smiPrintError(thisParserPtr, ERR_SUBJECT_CATEGORIES_ALL_WITH_SUBID);
                                (yyval.objectPtr) = NULL;
                            } else {
                                /*
                                 * This is not a regular object that will be added via
                                 * 'addObject' as subject category dentifier have no
                                 * other meaning in PIBs. They are just used for
                                 * a direct mapping to the actual protocol fields.
                                 */
                                objectPtr = smiMalloc(sizeof(Object));
                                objectPtr->export.name = (yyvsp[-3].id);
                                objectPtr->export.oidlen = 1;
                                objectPtr->export.oid = (void *)(yyvsp[-1].unsigned32);
                                (yyval.objectPtr) = objectPtr;
                            }
			}
#line 5704 "parser-smi.c"
    break;

  case 195: /* ObjectSyntax: SimpleSyntax  */
#line 3686 "parser-smi.y"
                        {
			    (yyval.typePtr) = (yyvsp[0].typePtr);
			}
#line 5712 "parser-smi.c"
    break;

  case 196: /* ObjectSyntax: typeTag SimpleSyntax  */
#line 3690 "parser-smi.y"
                        {
			    if (strcmp(thisParserPtr->modulePtr->export.name,
				       "SNMPv2-SMI") &&
			        strcmp(thisParserPtr->modulePtr->export.name,
				       "SNMPv2-TC") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "SNMPv2-CONF") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "RFC-1212") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "RFC1065-SMI") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "RFC1155-SMI") &&
                                strcmp(thisParserPtr->modulePtr->export.name,
                                       "COPS-PR-SPPI")) {
			        smiPrintError(thisParserPtr, ERR_TYPE_TAG, (yyvsp[-1].err));
			    }
			    (yyval.typePtr) = (yyvsp[0].typePtr);
			}
#line 5736 "parser-smi.c"
    break;

  case 197: /* ObjectSyntax: conceptualTable  */
#line 3710 "parser-smi.y"
                        {
			    /* TODO */
			    (yyval.typePtr) = (yyvsp[0].typePtr);
			}
#line 5745 "parser-smi.c"
    break;

  case 198: /* ObjectSyntax: row  */
#line 3715 "parser-smi.y"
                        {
			    /* TODO */
			    (yyval.typePtr) = (yyvsp[0].typePtr);
			}
#line 5754 "parser-smi.c"
    break;

  case 199: /* ObjectSyntax: entryType  */
#line 3720 "parser-smi.y"
                        {
			    /* TODO */
			    (yyval.typePtr) = (yyvsp[0].typePtr);
			}
#line 5763 "parser-smi.c"
    break;

  case 200: /* ObjectSyntax: ApplicationSyntax  */
#line 3725 "parser-smi.y"
                        {
			    Import *importPtr;

			    if ((yyvsp[0].typePtr) && (yyvsp[0].typePtr)->export.name) {
				importPtr = findImportByName((yyvsp[0].typePtr)->export.name,
							     thisModulePtr);
				if (importPtr) {
				    importPtr->use++;
				}
			    }

			    /* TODO */
			    (yyval.typePtr) = (yyvsp[0].typePtr);
			}
#line 5782 "parser-smi.c"
    break;

  case 201: /* typeTag: '[' APPLICATION NUMBER ']' IMPLICIT  */
#line 3742 "parser-smi.y"
                        { (yyval.err) = 0; /* TODO: check range */ }
#line 5788 "parser-smi.c"
    break;

  case 202: /* typeTag: '[' UNIVERSAL NUMBER ']' IMPLICIT  */
#line 3744 "parser-smi.y"
                        { (yyval.err) = 0; /* TODO: check range */ }
#line 5794 "parser-smi.c"
    break;

  case 203: /* sequenceObjectSyntax: sequenceSimpleSyntax  */
#line 3752 "parser-smi.y"
                        { (yyval.typePtr) = (yyvsp[0].typePtr); }
#line 5800 "parser-smi.c"
    break;

  case 204: /* sequenceObjectSyntax: sequenceApplicationSyntax  */
#line 3757 "parser-smi.y"
                        {
			    Import *importPtr;

			    if ((yyvsp[0].typePtr) && (yyvsp[0].typePtr)->export.name) {
				importPtr = findImportByName((yyvsp[0].typePtr)->export.name,
							     thisModulePtr);
				if (importPtr) {
				    importPtr->use++;
				}
			    }

			    /* TODO */
			    (yyval.typePtr) = (yyvsp[0].typePtr);
			}
#line 5819 "parser-smi.c"
    break;

  case 205: /* valueofObjectSyntax: valueofSimpleSyntax  */
#line 3774 "parser-smi.y"
                        { (yyval.valuePtr) = (yyvsp[0].valuePtr); }
#line 5825 "parser-smi.c"
    break;

  case 206: /* SimpleSyntax: INTEGER  */
#line 3783 "parser-smi.y"
                        {
			    if ((thisModulePtr->export.language == SMI_LANGUAGE_SMIV2)
				&&
				(strcmp(thisModulePtr->export.name, "SNMPv2-SMI") &&
				 strcmp(thisModulePtr->export.name, "SNMPv2-TC") &&
                                 strcmp(thisModulePtr->export.name, "COPS-PR-SPPI")))
				smiPrintError(thisParserPtr,
					      ERR_INTEGER_IN_SMIV2);

			    defaultBasetype = SMI_BASETYPE_INTEGER32;
			    (yyval.typePtr) = smiHandle->typeInteger32Ptr;
			}
#line 5842 "parser-smi.c"
    break;

  case 207: /* $@35: %empty  */
#line 3796 "parser-smi.y"
                        {
			    defaultBasetype = SMI_BASETYPE_INTEGER32;
			}
#line 5850 "parser-smi.c"
    break;

  case 208: /* SimpleSyntax: INTEGER $@35 integerSubType  */
#line 3800 "parser-smi.y"
                        {
			    if ((thisModulePtr->export.language == SMI_LANGUAGE_SMIV2)
				&&
				(strcmp(thisModulePtr->export.name, "SNMPv2-SMI") &&
				 strcmp(thisModulePtr->export.name, "SNMPv2-TC") &&
                                 strcmp(thisModulePtr->export.name, "COPS-PR-SPPI")))
				smiPrintError(thisParserPtr,
					      ERR_INTEGER_IN_SMIV2);

			    (yyval.typePtr) = duplicateType(smiHandle->typeInteger32Ptr, 0,
					       thisParserPtr);
			    setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
			    smiCheckTypeRanges(thisParserPtr, (yyval.typePtr));
			}
#line 5869 "parser-smi.c"
    break;

  case 209: /* $@36: %empty  */
#line 3815 "parser-smi.y"
                        {
			    defaultBasetype = SMI_BASETYPE_ENUM;
			}
#line 5877 "parser-smi.c"
    break;

  case 210: /* SimpleSyntax: INTEGER $@36 enumSpec  */
#line 3819 "parser-smi.y"
                        {
			    List *p;
			    
			    (yyval.typePtr) = duplicateType(smiHandle->typeEnumPtr, 0,
					       thisParserPtr);
			    setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
			    for (p = (yyvsp[0].listPtr); p; p = p->nextPtr)
				((NamedNumber *)p->ptr)->typePtr = (yyval.typePtr);
			    smiCheckNamedNumbersOrder(parserPtr, (yyval.typePtr));
			}
#line 5892 "parser-smi.c"
    break;

  case 211: /* SimpleSyntax: INTEGER32  */
#line 3830 "parser-smi.y"
                        {
			    Import *importPtr;

			    defaultBasetype = SMI_BASETYPE_INTEGER32;
			    importPtr = findImportByName("Integer32",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Integer32");
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_BASETYPE_NOT_IMPORTED,
						  "Integer32");
				}
			    }

			    /* TODO: any need to distinguish from INTEGER? */
			    (yyval.typePtr) = smiHandle->typeInteger32Ptr;
			}
#line 5922 "parser-smi.c"
    break;

  case 212: /* $@37: %empty  */
#line 3856 "parser-smi.y"
                        {
			    defaultBasetype = SMI_BASETYPE_INTEGER32;
			}
#line 5930 "parser-smi.c"
    break;

  case 213: /* SimpleSyntax: INTEGER32 $@37 integerSubType  */
#line 3860 "parser-smi.y"
                        {
			    Import *importPtr;
			    
			    importPtr = findImportByName("Integer32",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Integer32");
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_BASETYPE_NOT_IMPORTED,
						  "Integer32");
				}
			    }

			    (yyval.typePtr) = duplicateType(smiHandle->typeInteger32Ptr, 0,
					       thisParserPtr);
			    setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
			    smiCheckTypeRanges(thisParserPtr, (yyval.typePtr));
			}
#line 5961 "parser-smi.c"
    break;

  case 214: /* $@38: %empty  */
#line 3887 "parser-smi.y"
                        {
			    defaultBasetype = SMI_BASETYPE_ENUM;
			}
#line 5969 "parser-smi.c"
    break;

  case 215: /* SimpleSyntax: UPPERCASE_IDENTIFIER $@38 enumSpec  */
#line 3891 "parser-smi.y"
                        {
			    Type *parentPtr;
			    Import *importPtr;
			    List *p;
			    
			    parentPtr = findTypeByModuleAndName(
			        thisParserPtr->modulePtr, (yyvsp[-2].id));
			    if (!parentPtr) {
			        importPtr = findImportByName((yyvsp[-2].id),
							     thisModulePtr);
				if (importPtr &&
				    importPtr->kind == KIND_TYPE) {
				    importPtr->use++;
				    parentPtr = findTypeByModulenameAndName(
					importPtr->export.module, (yyvsp[-2].id));
				}
			    }
			    if (parentPtr) {
				if ((parentPtr->export.basetype !=
				     SMI_BASETYPE_ENUM) &&
				    (parentPtr->export.basetype !=
				     SMI_BASETYPE_BITS)) {
				    smiPrintError(thisParserPtr,
						  ERR_ILLEGAL_ENUM_FOR_PARENT_TYPE,
						  (yyvsp[-2].id));
				    (yyval.typePtr) = duplicateType(smiHandle->typeEnumPtr, 0,
						       thisParserPtr);
				} else {
				    (yyval.typePtr) = duplicateType(parentPtr, 0,
						       thisParserPtr);
				}
				smiFree((yyvsp[-2].id));
			    } else {
				/* 
				 * forward referenced type. create it,
				 * marked with FLAG_INCOMPLETE.
				 */
				parentPtr = addType((yyvsp[-2].id),
						    SMI_BASETYPE_UNKNOWN,
						    FLAG_INCOMPLETE,
						    thisParserPtr);
				(yyval.typePtr) = duplicateType(parentPtr, 0,
						   thisParserPtr);
			    }
			    setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
			    for (p = (yyvsp[0].listPtr); p; p = p->nextPtr)
				((NamedNumber *)p->ptr)->typePtr = (yyval.typePtr);
			    smiCheckNamedNumbersOrder(parserPtr, (yyval.typePtr));
			}
#line 6023 "parser-smi.c"
    break;

  case 216: /* SimpleSyntax: moduleName '.' UPPERCASE_IDENTIFIER enumSpec  */
#line 3942 "parser-smi.y"
                        {
			    Type *parentPtr;
			    Import *importPtr;
			    List *p;
			    
                            defaultBasetype = SMI_BASETYPE_ENUM;
                            parentPtr = findTypeByModulenameAndName((yyvsp[-3].id), (yyvsp[-1].id));
			    if (!parentPtr) {
				importPtr =
				    findImportByModulenameAndName((yyvsp[-3].id),
							  (yyvsp[-1].id), thisModulePtr);
				if (importPtr &&
				    importPtr->kind == KIND_TYPE) {
				    importPtr->use++;
				    parentPtr =
					findTypeByModulenameAndName((yyvsp[-3].id), (yyvsp[-1].id));
				}
			    }
			    if (parentPtr) {
				if ((parentPtr->export.basetype !=
				     SMI_BASETYPE_ENUM) &&
				    (parentPtr->export.basetype !=
				     SMI_BASETYPE_BITS)) {
				    smiPrintError(thisParserPtr,
						  ERR_ILLEGAL_ENUM_FOR_PARENT_TYPE,
						  (yyvsp[-1].id));
				    (yyval.typePtr) = duplicateType(smiHandle->typeEnumPtr, 0,
						       thisParserPtr);
				} else {
				    (yyval.typePtr) = duplicateType(parentPtr, 0,
						       thisParserPtr);
				}
			    } else {
				smiPrintError(thisParserPtr,
					      ERR_UNKNOWN_TYPE, (yyvsp[-1].id));
				(yyval.typePtr) = duplicateType(smiHandle->typeEnumPtr, 0,
						   thisParserPtr);
			    }
			    setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
			    for (p = (yyvsp[0].listPtr); p; p = p->nextPtr)
				((NamedNumber *)p->ptr)->typePtr = (yyval.typePtr);
			    smiCheckNamedNumbersOrder(parserPtr, (yyval.typePtr));
			    smiFree((yyvsp[-3].id));
			    smiFree((yyvsp[-1].id));
			}
#line 6073 "parser-smi.c"
    break;

  case 217: /* SimpleSyntax: UPPERCASE_IDENTIFIER integerSubType  */
#line 3988 "parser-smi.y"
                        {
			    Type *parentPtr;
			    Import *importPtr;
			    
			    parentPtr = findTypeByModuleAndName(
				thisParserPtr->modulePtr, (yyvsp[-1].id));
			    if (!parentPtr) {
				importPtr = findImportByName((yyvsp[-1].id),
							     thisModulePtr);
				if (importPtr &&
				    importPtr->kind == KIND_TYPE) {
				    importPtr->use++;
				    parentPtr = findTypeByModulenameAndName(
					importPtr->export.module, (yyvsp[-1].id));
				}
			    }
			    if (parentPtr) {
				if ((parentPtr->export.basetype !=
				    SMI_BASETYPE_INTEGER32) &&
				    (parentPtr->export.basetype !=
				     SMI_BASETYPE_INTEGER64) &&
				    (parentPtr->export.basetype !=
				     SMI_BASETYPE_UNSIGNED32) &&
				    (parentPtr->export.basetype !=
				     SMI_BASETYPE_UNSIGNED64)) {
				    smiPrintError(thisParserPtr,
					     ERR_ILLEGAL_RANGE_FOR_PARENT_TYPE,
						  (yyvsp[-1].id));
				    (yyval.typePtr) = duplicateType(smiHandle->typeInteger32Ptr, 0,
						       thisParserPtr);
				    defaultBasetype = SMI_BASETYPE_INTEGER32;
				} else {
				    defaultBasetype =
					parentPtr->export.basetype;
				    (yyval.typePtr) = duplicateType(parentPtr, 0,
						       thisParserPtr);
				}
				smiFree((yyvsp[-1].id));
			    } else {
				/* 
				 * forward referenced type. create it,
				 * marked with FLAG_INCOMPLETE.
				 */
				parentPtr = addType((yyvsp[-1].id),
						    SMI_BASETYPE_UNKNOWN,
						    FLAG_INCOMPLETE,
						    thisParserPtr);
				(yyval.typePtr) = duplicateType(parentPtr, 0,
						   thisParserPtr);
				defaultBasetype = SMI_BASETYPE_INTEGER32;
			    }
			    setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
			    smiCheckTypeRanges(thisParserPtr, (yyval.typePtr));
			}
#line 6132 "parser-smi.c"
    break;

  case 218: /* SimpleSyntax: moduleName '.' UPPERCASE_IDENTIFIER integerSubType  */
#line 4044 "parser-smi.y"
                        {
			    Type *parentPtr;
			    Import *importPtr;
			    
			    parentPtr = findTypeByModulenameAndName((yyvsp[-3].id), (yyvsp[-1].id));
			    if (!parentPtr) {
				importPtr = findImportByModulenameAndName((yyvsp[-3].id),
							  (yyvsp[-1].id), thisModulePtr);
				if (importPtr &&
				    importPtr->kind == KIND_TYPE) {
				    importPtr->use++;
				    parentPtr = findTypeByModulenameAndName(
					(yyvsp[-3].id), (yyvsp[-1].id));
				}
			    }
			    if (parentPtr) {
				if ((parentPtr->export.basetype !=
				    SMI_BASETYPE_INTEGER32) &&
				    (parentPtr->export.basetype !=
				     SMI_BASETYPE_INTEGER64) &&
				    (parentPtr->export.basetype !=
				     SMI_BASETYPE_UNSIGNED32) &&
				    (parentPtr->export.basetype !=
				     SMI_BASETYPE_UNSIGNED64)) {
				    smiPrintError(thisParserPtr,
					     ERR_ILLEGAL_RANGE_FOR_PARENT_TYPE,
						  (yyvsp[-1].id));
				    (yyval.typePtr) = duplicateType(smiHandle->typeInteger32Ptr, 0,
						       thisParserPtr);
				    defaultBasetype = SMI_BASETYPE_INTEGER32;
				} else {
				    defaultBasetype =
					parentPtr->export.basetype;
				    (yyval.typePtr) = duplicateType(parentPtr, 0,
						       thisParserPtr);
				}
			    } else {
				smiPrintError(thisParserPtr,
					      ERR_UNKNOWN_TYPE, (yyvsp[-1].id));
				(yyval.typePtr) = duplicateType(smiHandle->typeInteger32Ptr, 0,
						   thisParserPtr);
				defaultBasetype = SMI_BASETYPE_INTEGER32;
			    }
			    setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
			    smiCheckTypeRanges(thisParserPtr, (yyval.typePtr));
			    smiFree((yyvsp[-3].id));
			    smiFree((yyvsp[-1].id));
			}
#line 6185 "parser-smi.c"
    break;

  case 219: /* SimpleSyntax: OCTET STRING  */
#line 4093 "parser-smi.y"
                        {
			    defaultBasetype = SMI_BASETYPE_OCTETSTRING;
			    (yyval.typePtr) = smiHandle->typeOctetStringPtr;
			}
#line 6194 "parser-smi.c"
    break;

  case 220: /* $@39: %empty  */
#line 4098 "parser-smi.y"
                        {
			    defaultBasetype = SMI_BASETYPE_OCTETSTRING;
			}
#line 6202 "parser-smi.c"
    break;

  case 221: /* SimpleSyntax: OCTET STRING $@39 octetStringSubType  */
#line 4102 "parser-smi.y"
                        {
			    
			    (yyval.typePtr) = duplicateType(smiHandle->typeOctetStringPtr, 0,
					       thisParserPtr);
			    setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
			    smiCheckTypeRanges(thisParserPtr, (yyval.typePtr));
			}
#line 6214 "parser-smi.c"
    break;

  case 222: /* SimpleSyntax: UPPERCASE_IDENTIFIER octetStringSubType  */
#line 4110 "parser-smi.y"
                        {
			    Type *parentPtr;
			    Import *importPtr;
			    
			    defaultBasetype = SMI_BASETYPE_OCTETSTRING;
			    parentPtr = findTypeByModuleAndName(
				thisParserPtr->modulePtr, (yyvsp[-1].id));
			    if (!parentPtr) {
				importPtr = findImportByName((yyvsp[-1].id),
							     thisModulePtr);
				if (importPtr &&
				    importPtr->kind == KIND_TYPE) {
				    importPtr->use++;
				    parentPtr = findTypeByModulenameAndName(
					importPtr->export.module, (yyvsp[-1].id));
				}
			    }
			    if (parentPtr) {
				if (parentPtr->export.basetype !=
				    SMI_BASETYPE_OCTETSTRING) {
				    smiPrintError(thisParserPtr,
					      ERR_ILLEGAL_SIZE_FOR_PARENT_TYPE,
						  (yyvsp[-1].id));
				    (yyval.typePtr) = duplicateType(smiHandle->typeOctetStringPtr, 0,
						       thisParserPtr);
				} else {
				    (yyval.typePtr) = duplicateType(parentPtr, 0,
						       thisParserPtr);
				}
				smiFree((yyvsp[-1].id));
			    } else {
				/* 
				 * forward referenced type. create it,
				 * marked with FLAG_INCOMPLETE.
				 */
				parentPtr = addType((yyvsp[-1].id),
						    SMI_BASETYPE_UNKNOWN,
						    FLAG_INCOMPLETE,
						    thisParserPtr);
				(yyval.typePtr) = duplicateType(parentPtr, 0,
						   thisParserPtr);
			    }
			    setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
			    smiCheckTypeRanges(thisParserPtr, (yyval.typePtr));
			}
#line 6264 "parser-smi.c"
    break;

  case 223: /* SimpleSyntax: moduleName '.' UPPERCASE_IDENTIFIER octetStringSubType  */
#line 4157 "parser-smi.y"
                        {
			    Type *parentPtr;
			    Import *importPtr;
			    
			    defaultBasetype = SMI_BASETYPE_OCTETSTRING;
			    parentPtr = findTypeByModulenameAndName((yyvsp[-3].id), (yyvsp[-1].id));
			    if (!parentPtr) {
				importPtr = findImportByModulenameAndName((yyvsp[-3].id),
							  (yyvsp[-1].id), thisModulePtr);
				if (importPtr &&
				    importPtr->kind == KIND_TYPE) {
				    importPtr->use++;
				    parentPtr = findTypeByModulenameAndName(
					(yyvsp[-3].id), (yyvsp[-1].id));
				}
			    }
			    if (parentPtr) {
				if (parentPtr->export.basetype !=
				    SMI_BASETYPE_OCTETSTRING) {
				    smiPrintError(thisParserPtr,
					      ERR_ILLEGAL_SIZE_FOR_PARENT_TYPE,
						  (yyvsp[-1].id));
				    (yyval.typePtr) = duplicateType(smiHandle->typeOctetStringPtr, 0,
						       thisParserPtr);
				} else {
				    (yyval.typePtr) = duplicateType(parentPtr, 0,
						       thisParserPtr);
				}
			    } else {
				smiPrintError(thisParserPtr,
					      ERR_UNKNOWN_TYPE, (yyvsp[-1].id));
				(yyval.typePtr) = duplicateType(smiHandle->typeOctetStringPtr, 0,
						   thisParserPtr);
			    }
			    setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
			    smiCheckTypeRanges(thisParserPtr, (yyval.typePtr));
			    smiFree((yyvsp[-3].id));
			    smiFree((yyvsp[-1].id));
			}
#line 6308 "parser-smi.c"
    break;

  case 224: /* SimpleSyntax: OBJECT IDENTIFIER anySubType  */
#line 4197 "parser-smi.y"
                        {
			    defaultBasetype = SMI_BASETYPE_OBJECTIDENTIFIER;
			    (yyval.typePtr) = smiHandle->typeObjectIdentifierPtr;
			}
#line 6317 "parser-smi.c"
    break;

  case 225: /* valueofSimpleSyntax: NUMBER  */
#line 4205 "parser-smi.y"
                        {
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    (yyval.valuePtr)->basetype = SMI_BASETYPE_UNSIGNED32;
			    (yyval.valuePtr)->value.unsigned32 = (yyvsp[0].unsigned32);
			}
#line 6327 "parser-smi.c"
    break;

  case 226: /* valueofSimpleSyntax: NEGATIVENUMBER  */
#line 4211 "parser-smi.y"
                        {
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    (yyval.valuePtr)->basetype = SMI_BASETYPE_INTEGER32;
			    (yyval.valuePtr)->value.integer32 = (yyvsp[0].integer32);
			}
#line 6337 "parser-smi.c"
    break;

  case 227: /* valueofSimpleSyntax: NUMBER64  */
#line 4217 "parser-smi.y"
                        {   
                            /* The scanner already checks for the language */
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    (yyval.valuePtr)->basetype = SMI_BASETYPE_UNSIGNED64;
			    (yyval.valuePtr)->value.unsigned64 = (yyvsp[0].unsigned64);
			}
#line 6348 "parser-smi.c"
    break;

  case 228: /* valueofSimpleSyntax: NEGATIVENUMBER64  */
#line 4224 "parser-smi.y"
                        {
                            /* The scanner already checks for the language */
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    (yyval.valuePtr)->basetype = SMI_BASETYPE_INTEGER64;
			    (yyval.valuePtr)->value.integer64 = (yyvsp[0].integer64);
			}
#line 6359 "parser-smi.c"
    break;

  case 229: /* valueofSimpleSyntax: BIN_STRING  */
#line 4231 "parser-smi.y"
                        {
			    char s[9];
			    int i, len, j;
			    
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    if (defaultBasetype == SMI_BASETYPE_OCTETSTRING) {
				(yyval.valuePtr)->basetype = SMI_BASETYPE_OCTETSTRING;
				len = strlen((yyvsp[0].text));
				(yyval.valuePtr)->value.ptr =
				    smiMalloc((len+7)/8+1);
				for (i = 0; i < len; i += 8) {
				    strncpy(s, &(yyvsp[0].text)[i], 8);
				    for (j = 1; j < 8; j++) {
					if (!s[j]) s[j] = '0';
				    }
				    s[8] = 0;
				    (yyval.valuePtr)->value.ptr[i/8] =
					(unsigned char)strtol(s, 0, 2);
				}
				(yyval.valuePtr)->len = (len+7)/8;
			    } else {
				(yyval.valuePtr)->basetype = SMI_BASETYPE_UNSIGNED32;
				(yyval.valuePtr)->value.unsigned32 = strtoul((yyvsp[0].text), NULL, 2);
			    }
			}
#line 6389 "parser-smi.c"
    break;

  case 230: /* valueofSimpleSyntax: HEX_STRING  */
#line 4257 "parser-smi.y"
                        {
			    char s[3];
			    int i, len;
			    
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    if (defaultBasetype == SMI_BASETYPE_OCTETSTRING) {
				(yyval.valuePtr)->basetype = SMI_BASETYPE_OCTETSTRING;
				len = strlen((yyvsp[0].text));
				(yyval.valuePtr)->value.ptr = smiMalloc((len+1)/2+1);
				for (i = 0; i < len; i += 2) {
				    strncpy(s, &(yyvsp[0].text)[i], 2);
				    if (!s[1]) s[1] = '0';
				    s[2] = 0;
				    (yyval.valuePtr)->value.ptr[i/2] =
					(unsigned char)strtol(s, 0, 16);
				}
				(yyval.valuePtr)->len = (len+1)/2;
			    } else {
				(yyval.valuePtr)->basetype = SMI_BASETYPE_UNSIGNED32;
				(yyval.valuePtr)->value.unsigned32 = strtoul((yyvsp[0].text), NULL, 16);
			    }
			}
#line 6416 "parser-smi.c"
    break;

  case 231: /* valueofSimpleSyntax: LOWERCASE_IDENTIFIER  */
#line 4280 "parser-smi.y"
                        {
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    if ((defaultBasetype != SMI_BASETYPE_ENUM) &&
				(defaultBasetype != SMI_BASETYPE_OBJECTIDENTIFIER)) {
				smiPrintError(thisParserPtr, ERR_DEFVAL_SYNTAX);
				(yyval.valuePtr)->basetype = defaultBasetype;
				if (defaultBasetype == SMI_BASETYPE_ENUM) {
				    (yyval.valuePtr)->len = 1;
				    (yyval.valuePtr)->value.unsigned32 = 0;
				} else {
				    (yyval.valuePtr)->len = 0;
				    (yyval.valuePtr)->value.ptr = NULL;
				}
			    } else {
				(yyval.valuePtr)->basetype = defaultBasetype;
				(yyval.valuePtr)->len = -1;  /* indicates unresolved ptr */
				(yyval.valuePtr)->value.ptr = (yyvsp[0].id); /* JS: needs strdup? */
			    }
			}
#line 6440 "parser-smi.c"
    break;

  case 232: /* valueofSimpleSyntax: QUOTED_STRING  */
#line 4300 "parser-smi.y"
                        {
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    (yyval.valuePtr)->basetype = SMI_BASETYPE_OCTETSTRING;
			    (yyval.valuePtr)->value.ptr = smiStrdup((yyvsp[0].text));
			    (yyval.valuePtr)->len = strlen((yyvsp[0].text));
			}
#line 6451 "parser-smi.c"
    break;

  case 233: /* valueofSimpleSyntax: '{' objectIdentifier_defval '}'  */
#line 4323 "parser-smi.y"
                        {
			    /*
			     * SMIv1 allows something like { 0 0 } !
			     * SMIv2 does not!
			     */
			    /* TODO: make it work correctly for SMIv1 */
			    if (thisModulePtr->export.language == SMI_LANGUAGE_SMIV2) {
				smiPrintError(thisParserPtr,
					      ERR_OID_DEFVAL_TOO_LONG_SMIV2);
			    } else {
				smiPrintError(thisParserPtr,
					      ERR_OID_DEFVAL_TOO_LONG_SMIV1);
			    }
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    (yyval.valuePtr)->basetype = SMI_BASETYPE_OBJECTIDENTIFIER;
			    (yyval.valuePtr)->len = 2;
			    (yyval.valuePtr)->value.oid = smiMalloc(2 * sizeof(SmiSubid));
			    (yyval.valuePtr)->value.oid[0] = 0;
			    (yyval.valuePtr)->value.oid[1] = 0;
			}
#line 6476 "parser-smi.c"
    break;

  case 234: /* sequenceSimpleSyntax: INTEGER anySubType  */
#line 4350 "parser-smi.y"
                        {
			    (yyval.typePtr) = smiHandle->typeInteger32Ptr;
			}
#line 6484 "parser-smi.c"
    break;

  case 235: /* sequenceSimpleSyntax: INTEGER32 anySubType  */
#line 4354 "parser-smi.y"
                        {
			    Import *importPtr;
			    
			    /* TODO: any need to distinguish from INTEGER? */
			    (yyval.typePtr) = smiHandle->typeInteger32Ptr;

			    importPtr = findImportByName("Integer32",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Integer32");
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_BASETYPE_NOT_IMPORTED,
						  "Integer32");
				}
			    }
			}
#line 6513 "parser-smi.c"
    break;

  case 236: /* sequenceSimpleSyntax: OCTET STRING anySubType  */
#line 4379 "parser-smi.y"
                        {
			    (yyval.typePtr) = smiHandle->typeOctetStringPtr;
			}
#line 6521 "parser-smi.c"
    break;

  case 237: /* sequenceSimpleSyntax: OBJECT IDENTIFIER anySubType  */
#line 4383 "parser-smi.y"
                        {
			    (yyval.typePtr) = smiHandle->typeObjectIdentifierPtr;
			}
#line 6529 "parser-smi.c"
    break;

  case 238: /* ApplicationSyntax: IPADDRESS anySubType  */
#line 4389 "parser-smi.y"
                        {
			    Import *importPtr;
			    
			    (yyval.typePtr) = findTypeByName("IpAddress");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "IpAddress");
			    }
			    
			    importPtr = findImportByName("IpAddress",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "IpAddress");
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_BASETYPE_NOT_IMPORTED,
						  "IpAddress");
				}
			    }
			}
#line 6561 "parser-smi.c"
    break;

  case 239: /* ApplicationSyntax: COUNTER32 anySubType  */
#line 4417 "parser-smi.y"
                        {
			    Import *importPtr;

                            if ((thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI) &&
                                !findImportByName("Counter32", thisParserPtr->modulePtr))
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "COUNTER32");
			    (yyval.typePtr) = findTypeByName("Counter32");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Counter32");
			    }
			    
			    importPtr = findImportByName("Counter32",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Counter32");
				}
			    }
			}
#line 6591 "parser-smi.c"
    break;

  case 240: /* ApplicationSyntax: COUNTER32 integerSubType  */
#line 4443 "parser-smi.y"
                        {
			    Import *importPtr;
			    List *listPtr, *nextListPtr;
			    
			    smiPrintError(thisParserPtr,
					  ERR_ILLEGAL_RANGE_FOR_COUNTER,
					  "Counter32");
			    for (listPtr = (yyvsp[0].listPtr); listPtr;
				 listPtr = nextListPtr) {
				nextListPtr = listPtr->nextPtr;
				smiFree((Range *)listPtr->ptr);
				smiFree(listPtr);
			    }
			    
                            if ((thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI) &&
                                !findImportByName("Counter32", thisParserPtr->modulePtr))
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "Counter32");
			    (yyval.typePtr) = findTypeByName("Counter32");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Counter32");
			    }
			    
			    importPtr = findImportByName("Counter32",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Counter32");
				}
			    }
			}
#line 6632 "parser-smi.c"
    break;

  case 241: /* ApplicationSyntax: GAUGE32  */
#line 4480 "parser-smi.y"
                        {
			    Import *importPtr;

                            if ((thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI) &&
                                !findImportByName("Gauge32", thisParserPtr->modulePtr))
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "Gauge32");
			    (yyval.typePtr) = findTypeByName("Gauge32");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Gauge32");
			    }
			    
			    importPtr = findImportByName("Gauge32",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Gauge32");
				}
			    }
			}
#line 6662 "parser-smi.c"
    break;

  case 242: /* ApplicationSyntax: GAUGE32 integerSubType  */
#line 4506 "parser-smi.y"
                        {
			    Type *parentPtr;
			    Import *importPtr;
			    
                            if ((thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI) &&
                                !findImportByName("Gauge32", thisParserPtr->modulePtr))
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "Gauge32");
			    parentPtr = findTypeByName("Gauge32");
			    if (! parentPtr) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Gauge32");
				(yyval.typePtr) = NULL;
			    } else {
				(yyval.typePtr) = duplicateType(parentPtr, 0,
						   thisParserPtr);
				setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
				smiCheckTypeRanges(thisParserPtr, (yyval.typePtr));
			    }
			    
			    importPtr = findImportByName("Gauge32",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Gauge32");
				}
			    }
			}
#line 6699 "parser-smi.c"
    break;

  case 243: /* ApplicationSyntax: UNSIGNED32  */
#line 4539 "parser-smi.y"
                        {
			    Import *importPtr;

			    (yyval.typePtr) = smiHandle->typeUnsigned32Ptr;
			    
			    importPtr = findImportByName("Unsigned32",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Unsigned32");
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_BASETYPE_NOT_IMPORTED,
						  "Unsigned32");
				}
			    }
			}
#line 6727 "parser-smi.c"
    break;

  case 244: /* ApplicationSyntax: UNSIGNED32 integerSubType  */
#line 4563 "parser-smi.y"
                        {
			    Import *importPtr;
			    
			    (yyval.typePtr) = duplicateType(smiHandle->typeUnsigned32Ptr, 0,
					       thisParserPtr);
			    setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
			    smiCheckTypeRanges(thisParserPtr, (yyval.typePtr));

			    importPtr = findImportByName("Unsigned32",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Unsigned32");
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_BASETYPE_NOT_IMPORTED,
						  "Unsigned32");
				}
			    }
			}
#line 6758 "parser-smi.c"
    break;

  case 245: /* ApplicationSyntax: TIMETICKS anySubType  */
#line 4590 "parser-smi.y"
                        {
			    Import *importPtr;
			    
			    (yyval.typePtr) = findTypeByName("TimeTicks");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "TimeTicks");
			    }
			    
			    importPtr = findImportByName("TimeTicks",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "TimeTicks");
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_BASETYPE_NOT_IMPORTED,
						  "TimeTicks");
				}
			    }
			}
#line 6790 "parser-smi.c"
    break;

  case 246: /* ApplicationSyntax: OPAQUE  */
#line 4618 "parser-smi.y"
                        {
			    Import *importPtr;
			    
			    (yyval.typePtr) = findTypeByName("Opaque");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Opaque");
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_OPAQUE_OBSOLETE);
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_OPAQUE_OBSOLETE);
				}
			    }
			    
			    importPtr = findImportByName("Opaque",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Opaque");
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_BASETYPE_NOT_IMPORTED,
						  "Opaque");
				}
			    }
			}
#line 6832 "parser-smi.c"
    break;

  case 247: /* ApplicationSyntax: OPAQUE octetStringSubType  */
#line 4656 "parser-smi.y"
                        {
			    Type *parentPtr;
			    Import *importPtr;
			    
			    parentPtr = findTypeByName("Opaque");
			    if (! parentPtr) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Opaque");
				(yyval.typePtr) = NULL;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_OPAQUE_OBSOLETE,
						  "Opaque");
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_OPAQUE_OBSOLETE,
						  "Opaque");
				}
				(yyval.typePtr) = duplicateType(parentPtr, 0,
						   thisParserPtr);
				setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
				smiCheckTypeRanges(thisParserPtr, (yyval.typePtr));
			    }

			    importPtr = findImportByName("Opaque",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Opaque");
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_BASETYPE_NOT_IMPORTED,
						  "Opaque");
				}
			    }
			}
#line 6882 "parser-smi.c"
    break;

  case 248: /* ApplicationSyntax: COUNTER64 anySubType  */
#line 4702 "parser-smi.y"
                        {
			    Import *importPtr;

                            if ((thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI) &&
                                !findImportByName("Counter64", thisParserPtr->modulePtr))
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "Counter64");
			    (yyval.typePtr) = findTypeByName("Counter64");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Counter64");
			    }

			    importPtr = findImportByName("Counter64",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Counter64");
				}
			    }
			}
#line 6912 "parser-smi.c"
    break;

  case 249: /* ApplicationSyntax: COUNTER64 integerSubType  */
#line 4728 "parser-smi.y"
                        {
			    Import *importPtr;
			    List *listPtr, *nextListPtr;
			    
			    smiPrintError(thisParserPtr,
					  ERR_ILLEGAL_RANGE_FOR_COUNTER,
					  "Counter64");
			    for (listPtr = (yyvsp[0].listPtr); listPtr;
				 listPtr = nextListPtr) {
				nextListPtr = listPtr->nextPtr;
				smiFree((Range *)listPtr->ptr);
				smiFree(listPtr);
			    }
			    
                            if ((thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI) &&
                                !findImportByName("Counter64", thisParserPtr->modulePtr))
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "Counter64");
			    (yyval.typePtr) = findTypeByName("Counter64");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Counter64");
			    }

			    importPtr = findImportByName("Counter64",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Counter64");
				}
			    }
			}
#line 6953 "parser-smi.c"
    break;

  case 250: /* ApplicationSyntax: INTEGER64  */
#line 4765 "parser-smi.y"
                        {
			    Import *importPtr;

			    (yyval.typePtr) = findTypeByModulenameAndName(
				thisParserPtr->modulePtr->export.name, "Integer64");
			    if (! (yyval.typePtr)) {
				importPtr = findImportByName("Integer64",
							     thisModulePtr);
				if (!importPtr) {
				    (yyval.typePtr) = findTypeByName("Integer64");
				    if ((thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)) {
					smiPrintError(thisParserPtr, ERR_SPPI_CONSTRUCT_IN_MIB, "Integer64");
				    } else {
					smiPrintError(thisParserPtr,
						      ERR_SPPI_BASETYPE_NOT_IMPORTED,
						      "Integer64");
				    }
				} else {
				    importPtr->use++;
				    (yyval.typePtr) = findTypeByModulenameAndName(
					importPtr->export.module,
					importPtr->export.name);
				}
			    }
			}
#line 6983 "parser-smi.c"
    break;

  case 251: /* ApplicationSyntax: INTEGER64 integerSubType  */
#line 4791 "parser-smi.y"
                        {
			    Type *parentPtr;
			    Import *importPtr;
			    
			    parentPtr = findTypeByModulenameAndName(
				thisParserPtr->modulePtr->export.name, "Integer64");
			    if (! parentPtr) {
				importPtr = findImportByName("Integer64",
							     thisModulePtr);
				if (!importPtr) {
				    parentPtr = findTypeByName("Integer64");
				    if ((thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)) {
					smiPrintError(thisParserPtr, ERR_SPPI_CONSTRUCT_IN_MIB, "Integer64");
				    } else {
					smiPrintError(thisParserPtr,
						      ERR_SPPI_BASETYPE_NOT_IMPORTED,
						      "Integer64");
				    }
				} else {
				    importPtr->use++;
				    parentPtr = findTypeByModulenameAndName(
					importPtr->export.module,
					importPtr->export.name);
				}
			    }
			    if (! parentPtr) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Integer64");
				(yyval.typePtr) = NULL;
			    } else {
				(yyval.typePtr) = duplicateType(parentPtr, 0,
						   thisParserPtr);
				setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
				smiCheckTypeRanges(thisParserPtr, (yyval.typePtr));
			    }
			}
#line 7024 "parser-smi.c"
    break;

  case 252: /* ApplicationSyntax: UNSIGNED64  */
#line 4828 "parser-smi.y"
                        {
			    Import *importPtr;

			    (yyval.typePtr) = findTypeByModulenameAndName(
				thisParserPtr->modulePtr->export.name, "Unsigned64");
			    if (! (yyval.typePtr)) {
				importPtr = findImportByName("Unsigned64",
							     thisModulePtr);
				if (!importPtr) {
				    (yyval.typePtr) = findTypeByName("Unsigned64");
				    if ((thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)) {
					smiPrintError(thisParserPtr, ERR_SPPI_CONSTRUCT_IN_MIB, "Unsigned64");
				    } else {
					smiPrintError(thisParserPtr,
						      ERR_SPPI_BASETYPE_NOT_IMPORTED,
						      "Unsigned64");
				    }
				} else {
				    importPtr->use++;
				    (yyval.typePtr) = findTypeByModulenameAndName(
					importPtr->export.module,
					importPtr->export.name);
				}
			    }
			}
#line 7054 "parser-smi.c"
    break;

  case 253: /* ApplicationSyntax: UNSIGNED64 integerSubType  */
#line 4854 "parser-smi.y"
                        {
			    Type *parentPtr;
			    Import *importPtr;
			    
			    parentPtr = findTypeByModulenameAndName(
				thisParserPtr->modulePtr->export.name, "Unsigned64");
			    if (! parentPtr) {
				importPtr = findImportByName("Unsigned64",
							     thisModulePtr);
				if (!importPtr) {
				    parentPtr = findTypeByName("Unsigned64");
				    if ((thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)) {
					smiPrintError(thisParserPtr, ERR_SPPI_CONSTRUCT_IN_MIB, "Unsigned64");
				    } else {
					smiPrintError(thisParserPtr,
						      ERR_SPPI_BASETYPE_NOT_IMPORTED,
						      "Unsigned64");
				    }
				} else {
				    importPtr->use++;
				    parentPtr = findTypeByModulenameAndName(
					importPtr->export.module,
					importPtr->export.name);
				}
			    }
			    if (! parentPtr) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Unsigned64");
				(yyval.typePtr) = NULL;
			    } else {
				(yyval.typePtr) = duplicateType(parentPtr, 0,
						   thisParserPtr);
				setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
				smiCheckTypeRanges(thisParserPtr, (yyval.typePtr));
			    }
			}
#line 7095 "parser-smi.c"
    break;

  case 254: /* sequenceApplicationSyntax: IPADDRESS anySubType  */
#line 4897 "parser-smi.y"
                        {
			    Import *importPtr;
			    
			    (yyval.typePtr) = findTypeByName("IpAddress");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "IpAddress");
			    }

			    importPtr = findImportByName("IpAddress",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "IpAddress");
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_BASETYPE_NOT_IMPORTED,
						  "IpAddress");
				}
			    }
			}
#line 7127 "parser-smi.c"
    break;

  case 255: /* sequenceApplicationSyntax: COUNTER32 anySubType  */
#line 4925 "parser-smi.y"
                        {
			    Import *importPtr;
			    
                            if ((thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI) &&
                                !findImportByName("Counter32", thisParserPtr->modulePtr))
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "Counter32");
			    (yyval.typePtr) = findTypeByName("Counter32");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Counter32");
			    }

			    importPtr = findImportByName("Counter32",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Counter32");
				}
			    }
			}
#line 7157 "parser-smi.c"
    break;

  case 256: /* sequenceApplicationSyntax: GAUGE32 anySubType  */
#line 4951 "parser-smi.y"
                        {
			    Import *importPtr;
			    
                            if ((thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI) &&
                                !findImportByName("Gauge32", thisParserPtr->modulePtr))
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "Gauge32");
			    (yyval.typePtr) = findTypeByName("Gauge32");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Gauge32");
			    }

			    importPtr = findImportByName("Gauge32",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Gauge32");
				}
			    }
			}
#line 7187 "parser-smi.c"
    break;

  case 257: /* sequenceApplicationSyntax: UNSIGNED32 anySubType  */
#line 4977 "parser-smi.y"
                        {
			    Import *importPtr;
			    
			    (yyval.typePtr) = smiHandle->typeUnsigned32Ptr;

			    importPtr = findImportByName("Unsigned32",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Unsigned32");
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_BASETYPE_NOT_IMPORTED,
						  "Unsigned32");
				}
			    }
			}
#line 7215 "parser-smi.c"
    break;

  case 258: /* sequenceApplicationSyntax: TIMETICKS anySubType  */
#line 5001 "parser-smi.y"
                        {
			    Import *importPtr;
			    
			    (yyval.typePtr) = findTypeByName("TimeTicks");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "TimeTicks");
			    }

			    importPtr = findImportByName("TimeTicks",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "TimeTicks");
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_BASETYPE_NOT_IMPORTED,
						  "TimeTicks");
				}
			    }
			}
#line 7247 "parser-smi.c"
    break;

  case 259: /* sequenceApplicationSyntax: OPAQUE  */
#line 5029 "parser-smi.y"
                        {
			    Import *importPtr;
			    
			    (yyval.typePtr) = findTypeByName("Opaque");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Opaque");
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_OPAQUE_OBSOLETE,
						  "Opaque");
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_OPAQUE_OBSOLETE,
						  "Opaque");
				}
			    }

			    importPtr = findImportByName("Opaque",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Opaque");
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_BASETYPE_NOT_IMPORTED,
						  "Opaque");
				}
			    }
			}
#line 7291 "parser-smi.c"
    break;

  case 260: /* sequenceApplicationSyntax: COUNTER64 anySubType  */
#line 5069 "parser-smi.y"
                        {
			    Import *importPtr;

                            if ((thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI) &&
                                !findImportByName("Counter64", thisModulePtr))
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "Counter64");
			    (yyval.typePtr) = findTypeByName("Counter64");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Counter64");
			    }

			    importPtr = findImportByName("Counter64",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Counter64");
				}
			    }
			}
#line 7321 "parser-smi.c"
    break;

  case 261: /* sequenceApplicationSyntax: INTEGER64  */
#line 5095 "parser-smi.y"
                        {
			    Import *importPtr;

                            if (thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SPPI_CONSTRUCT_IN_MIB, "Integer64");
			    (yyval.typePtr) = findTypeByName("Integer64");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Integer64");
			    }

			    importPtr = findImportByName("Integer64",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_BASETYPE_NOT_IMPORTED,
						  "Integer64");
				}
			    }
			}
#line 7350 "parser-smi.c"
    break;

  case 262: /* sequenceApplicationSyntax: UNSIGNED64  */
#line 5120 "parser-smi.y"
                        {
			    Import *importPtr;

			    importPtr = findImportByName("Unsigned64",
							 thisModulePtr);
                            if ((thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI) && (!importPtr))
                                smiPrintError(thisParserPtr, ERR_SPPI_CONSTRUCT_IN_MIB, "Unsigned64");
			    (yyval.typePtr) = findTypeByName("Unsigned64");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Unsigned64");
			    }

			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_BASETYPE_NOT_IMPORTED,
						  "Unsigned64");
				}
			    }
			}
#line 7379 "parser-smi.c"
    break;

  case 263: /* anySubType: integerSubType  */
#line 5147 "parser-smi.y"
                        {
			    List *listPtr, *nextListPtr;

			    if (thisModulePtr->export.language == SMI_LANGUAGE_SMIV2)
				smiPrintError(thisParserPtr,
					      ERR_UNEXPECTED_TYPE_RESTRICTION);

			    for (listPtr = (yyvsp[0].listPtr); listPtr;
				 listPtr = nextListPtr) {
				nextListPtr = listPtr->nextPtr;
				smiFree((Range *)(listPtr->ptr));
				smiFree(listPtr);
			    }

			    (yyval.listPtr) = NULL;
			}
#line 7400 "parser-smi.c"
    break;

  case 264: /* anySubType: octetStringSubType  */
#line 5164 "parser-smi.y"
                        {
			    List *listPtr, *nextListPtr;

			    if (thisModulePtr->export.language == SMI_LANGUAGE_SMIV2)
				smiPrintError(thisParserPtr,
					      ERR_UNEXPECTED_TYPE_RESTRICTION);

			    for (listPtr = (yyvsp[0].listPtr); listPtr;
				 listPtr = nextListPtr) {
				nextListPtr = listPtr->nextPtr;
				smiFree((Range *)(listPtr->ptr));
				smiFree(listPtr);
			    }

			    (yyval.listPtr) = NULL;
			}
#line 7421 "parser-smi.c"
    break;

  case 265: /* anySubType: enumSpec  */
#line 5181 "parser-smi.y"
                        {
			    List *listPtr, *nextListPtr;

			    if (thisModulePtr->export.language == SMI_LANGUAGE_SMIV2)
				smiPrintError(thisParserPtr,
					      ERR_UNEXPECTED_TYPE_RESTRICTION);

			    for (listPtr = (yyvsp[0].listPtr); listPtr;
				 listPtr = nextListPtr) {
				nextListPtr = listPtr->nextPtr;
				smiFree(((NamedNumber *)(listPtr->ptr))->export.name);
				smiFree((NamedNumber *)(listPtr->ptr));
				smiFree(listPtr);
			    }

			    (yyval.listPtr) = NULL;
			}
#line 7443 "parser-smi.c"
    break;

  case 266: /* anySubType: %empty  */
#line 5199 "parser-smi.y"
                        {
			    (yyval.listPtr) = NULL;
			}
#line 7451 "parser-smi.c"
    break;

  case 267: /* integerSubType: '(' ranges ')'  */
#line 5213 "parser-smi.y"
                        { (yyval.listPtr) = (yyvsp[-1].listPtr); }
#line 7457 "parser-smi.c"
    break;

  case 268: /* octetStringSubType: '(' SIZE '(' ranges ')' ')'  */
#line 5223 "parser-smi.y"
                        {
			    (yyval.listPtr) = (yyvsp[-2].listPtr);
			}
#line 7465 "parser-smi.c"
    break;

  case 269: /* ranges: range  */
#line 5229 "parser-smi.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].rangePtr);
			    (yyval.listPtr)->nextPtr = NULL;
			}
#line 7475 "parser-smi.c"
    break;

  case 270: /* ranges: ranges '|' range  */
#line 5235 "parser-smi.y"
                        {
			    List *p, *pp;
			    
			    p = smiMalloc(sizeof(List));
			    p->ptr = (void *)(yyvsp[0].rangePtr);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-2].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    
			    (yyval.listPtr) = (yyvsp[-2].listPtr);
			}
#line 7491 "parser-smi.c"
    break;

  case 271: /* range: value  */
#line 5249 "parser-smi.y"
                        {
			    (yyval.rangePtr) = smiMalloc(sizeof(Range));
			    (yyval.rangePtr)->export.minValue = *(yyvsp[0].valuePtr);
			    (yyval.rangePtr)->export.maxValue = *(yyvsp[0].valuePtr);
			    smiFree((yyvsp[0].valuePtr));
			}
#line 7502 "parser-smi.c"
    break;

  case 272: /* range: value DOT_DOT value  */
#line 5256 "parser-smi.y"
                        {
			    (yyval.rangePtr) = smiMalloc(sizeof(Range));
			    (yyval.rangePtr)->export.minValue = *(yyvsp[-2].valuePtr);
			    (yyval.rangePtr)->export.maxValue = *(yyvsp[0].valuePtr);
			    smiFree((yyvsp[-2].valuePtr));
			    smiFree((yyvsp[0].valuePtr));
			}
#line 7514 "parser-smi.c"
    break;

  case 273: /* value: NEGATIVENUMBER  */
#line 5266 "parser-smi.y"
                        {
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    (yyval.valuePtr)->basetype = SMI_BASETYPE_INTEGER32;
			    (yyval.valuePtr)->value.integer32 = (yyvsp[0].integer32);
			}
#line 7524 "parser-smi.c"
    break;

  case 274: /* value: NUMBER  */
#line 5272 "parser-smi.y"
                        {
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    (yyval.valuePtr)->basetype = SMI_BASETYPE_UNSIGNED32;
			    (yyval.valuePtr)->value.unsigned32 = (yyvsp[0].unsigned32);
			}
#line 7534 "parser-smi.c"
    break;

  case 275: /* value: NEGATIVENUMBER64  */
#line 5278 "parser-smi.y"
                        {
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    (yyval.valuePtr)->basetype = SMI_BASETYPE_INTEGER64;
			    (yyval.valuePtr)->value.integer64 = (yyvsp[0].integer64);
			}
#line 7544 "parser-smi.c"
    break;

  case 276: /* value: NUMBER64  */
#line 5284 "parser-smi.y"
                        {
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    (yyval.valuePtr)->basetype = SMI_BASETYPE_UNSIGNED64;
			    (yyval.valuePtr)->value.unsigned64 = (yyvsp[0].unsigned64);
			}
#line 7554 "parser-smi.c"
    break;

  case 277: /* value: HEX_STRING  */
#line 5290 "parser-smi.y"
                        {
			    char s[3];
			    int i, len;
			    
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    if (defaultBasetype == SMI_BASETYPE_OCTETSTRING) {
				(yyval.valuePtr)->basetype = SMI_BASETYPE_OCTETSTRING;
				len = strlen((yyvsp[0].text));
				(yyval.valuePtr)->value.ptr = smiMalloc((len+1)/2+1);
				for (i = 0; i < len; i += 2) {
				    strncpy(s, &(yyvsp[0].text)[i], 2);
				    if (!s[1]) s[1] = '0';
				    s[2] = 0;
				    (yyval.valuePtr)->value.ptr[i/2] =
					(unsigned char)strtol(s, 0, 16);
				}
				(yyval.valuePtr)->len = (len+1)/2;
			    } else {
				(yyval.valuePtr)->basetype = SMI_BASETYPE_UNSIGNED32;
				(yyval.valuePtr)->value.unsigned32 = strtoul((yyvsp[0].text), NULL, 16);
			    }
			}
#line 7581 "parser-smi.c"
    break;

  case 278: /* value: BIN_STRING  */
#line 5313 "parser-smi.y"
                        {
			    char s[9];
			    int i, len, j;
			    
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    if (defaultBasetype == SMI_BASETYPE_OCTETSTRING) {
				(yyval.valuePtr)->basetype = SMI_BASETYPE_OCTETSTRING;
				len = strlen((yyvsp[0].text));
				(yyval.valuePtr)->value.ptr = smiMalloc((len+7)/8+1);
				for (i = 0; i < len; i += 8) {
				    strncpy(s, &(yyvsp[0].text)[i], 8);
				    for (j = 1; j < 8; j++) {
					if (!s[j]) s[j] = '0';
				    }
				    s[8] = 0;
				    (yyval.valuePtr)->value.ptr[i/8] =
					(unsigned char)strtol(s, 0, 2);
				}
				(yyval.valuePtr)->len = (len+7)/8;
			    } else {
				(yyval.valuePtr)->basetype = SMI_BASETYPE_UNSIGNED32;
				(yyval.valuePtr)->value.unsigned32 = strtoul((yyvsp[0].text), NULL, 2);
			    }
			}
#line 7610 "parser-smi.c"
    break;

  case 279: /* enumSpec: '{' enumItems '}'  */
#line 5340 "parser-smi.y"
                        {
			    (yyval.listPtr) = (yyvsp[-1].listPtr);
			}
#line 7618 "parser-smi.c"
    break;

  case 280: /* enumItems: enumItem  */
#line 5346 "parser-smi.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].namedNumberPtr);
			    (yyval.listPtr)->nextPtr = NULL;
			}
#line 7628 "parser-smi.c"
    break;

  case 281: /* enumItems: enumItems ',' enumItem  */
#line 5352 "parser-smi.y"
                        {
			    List *p, *pp;
			    
			    p = smiMalloc(sizeof(List));
			    p->ptr = (void *)(yyvsp[0].namedNumberPtr);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-2].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    (yyval.listPtr) = (yyvsp[-2].listPtr);
			}
#line 7643 "parser-smi.c"
    break;

  case 282: /* $@40: %empty  */
#line 5365 "parser-smi.y"
                        {
			    checkNameLen(thisParserPtr, (yyvsp[0].id),
					 ERR_ENUMNAME_32, ERR_ENUMNAME_64);
			    if (thisModulePtr->export.language == SMI_LANGUAGE_SMIV2)
			    {
				if (strchr((yyvsp[0].id), '-')) {
				    smiPrintError(thisParserPtr,
					  ERR_NAMEDNUMBER_INCLUDES_HYPHEN,
						  (yyvsp[0].id));
				}
			    }
			}
#line 7660 "parser-smi.c"
    break;

  case 283: /* enumItem: LOWERCASE_IDENTIFIER $@40 '(' enumNumber ')'  */
#line 5378 "parser-smi.y"
                        {
			    (yyval.namedNumberPtr) = smiMalloc(sizeof(NamedNumber));
			    (yyval.namedNumberPtr)->export.name = (yyvsp[-4].id);
			    (yyval.namedNumberPtr)->export.value = *(yyvsp[-1].valuePtr);
			    smiFree((yyvsp[-1].valuePtr));
			}
#line 7671 "parser-smi.c"
    break;

  case 284: /* enumNumber: NUMBER  */
#line 5387 "parser-smi.y"
                        {
			    if ((yyvsp[0].unsigned32) > SMI_BASETYPE_INTEGER32_MAX) {
				smiPrintError(thisParserPtr,
					      ERR_INTEGER32_TOO_LARGE, (yyvsp[0].unsigned32));
			    }
			    if ((thisModulePtr->export.language == SMI_LANGUAGE_SMIV1) &&
				((yyvsp[0].unsigned32) == 0)) {
				smiPrintError(thisParserPtr,
					      ERR_ENUM_ZERO);
			    }
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    (yyval.valuePtr)->basetype = SMI_BASETYPE_INTEGER32;
			    (yyval.valuePtr)->value.integer32 = (yyvsp[0].unsigned32);
			}
#line 7690 "parser-smi.c"
    break;

  case 285: /* enumNumber: NEGATIVENUMBER  */
#line 5402 "parser-smi.y"
                        {
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    (yyval.valuePtr)->basetype = SMI_BASETYPE_INTEGER32;
			    (yyval.valuePtr)->value.integer32 = (yyvsp[0].integer32);
			    /* TODO: non-negative is suggested */
			}
#line 7701 "parser-smi.c"
    break;

  case 286: /* Status: LOWERCASE_IDENTIFIER  */
#line 5411 "parser-smi.y"
                        {
			    if (thisModulePtr->export.language == SMI_LANGUAGE_SMIV2)
			    {
			        if (!strcmp((yyvsp[0].id), "current")) {
				    (yyval.status) = SMI_STATUS_CURRENT;
			        } else if (!strcmp((yyvsp[0].id), "deprecated")) {
				    (yyval.status) = SMI_STATUS_DEPRECATED;
			        } else if (!strcmp((yyvsp[0].id), "obsolete")) {
				    (yyval.status) = SMI_STATUS_OBSOLETE;
			        } else {
				    smiPrintError(thisParserPtr,
					          ERR_INVALID_SMIV2_STATUS,
					          (yyvsp[0].id));
				    if (!strcmp((yyvsp[0].id), "mandatory")
				        || !strcmp((yyvsp[0].id), "optional")) {
				        /* best guess */
				        (yyval.status) = SMI_STATUS_CURRENT;
				    } else {
				        (yyval.status) = SMI_STATUS_UNKNOWN;
				    }
			        }
			    } else if (thisModulePtr->export.language != SMI_LANGUAGE_SPPI) {
			        if (!strcmp((yyvsp[0].id), "mandatory")) {
				    (yyval.status) = SMI_STATUS_MANDATORY;
			        } else if (!strcmp((yyvsp[0].id), "optional")) {
				    (yyval.status) = SMI_STATUS_OPTIONAL;
			        } else if (!strcmp((yyvsp[0].id), "obsolete")) {
				    (yyval.status) = SMI_STATUS_OBSOLETE;
			        } else if (!strcmp((yyvsp[0].id), "deprecated")) {
				    (yyval.status) = SMI_STATUS_OBSOLETE;
			        } else {
				    smiPrintError(thisParserPtr,
					          ERR_INVALID_SMIV1_STATUS,
					          (yyvsp[0].id));
				    if (!strcmp((yyvsp[0].id), "current")) {
				        /* best guess */
				        (yyval.status) = SMI_STATUS_MANDATORY; 
				    } else {
				        (yyval.status) = SMI_STATUS_UNKNOWN;
				    }
			        }
			    } else { /* it is SPPI */
			        if (!strcmp((yyvsp[0].id), "current")) {
				    (yyval.status) = SMI_STATUS_CURRENT;
			        } else if (!strcmp((yyvsp[0].id), "obsolete")) {
				    (yyval.status) = SMI_STATUS_OBSOLETE;
			        } else if (!strcmp((yyvsp[0].id), "deprecated")) {
				    (yyval.status) = SMI_STATUS_OBSOLETE;
                                } else {
                                    smiPrintError(thisParserPtr,
                                                  ERR_INVALID_SPPI_STATUS, (yyvsp[0].id));
                                    (yyval.status) = SMI_STATUS_UNKNOWN;
                                }
                            }
			    smiFree((yyvsp[0].id));
			}
#line 7762 "parser-smi.c"
    break;

  case 287: /* Status_Capabilities: LOWERCASE_IDENTIFIER  */
#line 5470 "parser-smi.y"
                        {
			    if (!strcmp((yyvsp[0].id), "current")) {
				(yyval.status) = SMI_STATUS_CURRENT;
			    } else if (!strcmp((yyvsp[0].id), "obsolete")) {
				(yyval.status) = SMI_STATUS_OBSOLETE;
			    } else {
				smiPrintError(thisParserPtr,
					      ERR_INVALID_CAPABILITIES_STATUS,
					      (yyvsp[0].id));
				(yyval.status) = SMI_STATUS_UNKNOWN;
			    }
			    smiFree((yyvsp[0].id));
			}
#line 7780 "parser-smi.c"
    break;

  case 288: /* DisplayPart: DISPLAY_HINT Text  */
#line 5486 "parser-smi.y"
                        {
			    (yyval.text) = (yyvsp[0].text);
			    
			    if ((yyvsp[0].text) && !strlen((yyvsp[0].text))) {
				smiPrintError(thisParserPtr,
					      ERR_EMPTY_FORMAT);
			    }
			}
#line 7793 "parser-smi.c"
    break;

  case 289: /* DisplayPart: %empty  */
#line 5495 "parser-smi.y"
                        {
			    (yyval.text) = NULL;
			}
#line 7801 "parser-smi.c"
    break;

  case 290: /* UnitsPart: UNITS Text  */
#line 5501 "parser-smi.y"
                        {
			    (yyval.text) = (yyvsp[0].text);
			    
			    if ((yyvsp[0].text) && !strlen((yyvsp[0].text))) {
				smiPrintError(thisParserPtr,
					      ERR_EMPTY_UNITS);
			    }
			}
#line 7814 "parser-smi.c"
    break;

  case 291: /* UnitsPart: %empty  */
#line 5510 "parser-smi.y"
                        {
			    (yyval.text) = NULL;
			}
#line 7822 "parser-smi.c"
    break;

  case 292: /* Access: LOWERCASE_IDENTIFIER  */
#line 5516 "parser-smi.y"
                        {
			    if (thisModulePtr->export.language == SMI_LANGUAGE_SMIV2)
			    {
				if (!strcmp((yyvsp[0].id), "not-accessible")) {
				    (yyval.access) = SMI_ACCESS_NOT_ACCESSIBLE;
				} else if (!strcmp((yyvsp[0].id),
						   "accessible-for-notify")) {
				    (yyval.access) = SMI_ACCESS_NOTIFY;
				} else if (!strcmp((yyvsp[0].id), "read-only")) {
				    (yyval.access) = SMI_ACCESS_READ_ONLY;
				} else if (!strcmp((yyvsp[0].id), "read-write")) {
				    (yyval.access) = SMI_ACCESS_READ_WRITE;
				} else if (!strcmp((yyvsp[0].id), "read-create")) {
				    (yyval.access) = SMI_ACCESS_READ_WRITE;
				    thisParserPtr->flags |= FLAG_CREATABLE;
				    /* TODO:remember it's really read-create */
				} else if (!strcmp((yyvsp[0].id), "write-only")) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_WRITE_ONLY);
				    (yyval.access) = SMI_ACCESS_READ_WRITE;
				} else {
				    smiPrintError(thisParserPtr,
						  ERR_INVALID_SMIV2_ACCESS,
						  (yyvsp[0].id));
				    (yyval.access) = SMI_ACCESS_UNKNOWN;
				}
			    } else if (thisModulePtr->export.language != SMI_LANGUAGE_SPPI) {
				if (!strcmp((yyvsp[0].id), "not-accessible")) {
				    (yyval.access) = SMI_ACCESS_NOT_ACCESSIBLE;
				} else if (!strcmp((yyvsp[0].id), "read-only")) {
				    (yyval.access) = SMI_ACCESS_READ_ONLY;
				} else if (!strcmp((yyvsp[0].id), "read-write")) {
				    (yyval.access) = SMI_ACCESS_READ_WRITE;
				} else if (!strcmp((yyvsp[0].id), "write-only")) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV1_WRITE_ONLY);
				    (yyval.access) = SMI_ACCESS_READ_WRITE;
				} else {
				    smiPrintError(thisParserPtr,
						  ERR_INVALID_SMIV1_ACCESS,
						  (yyvsp[0].id));
				    (yyval.access) = SMI_ACCESS_UNKNOWN;
				}
			    } else {
			        if (!strcmp((yyvsp[0].id), "install")) {
				    (yyval.access) = SMI_ACCESS_INSTALL;
			        } else if (!strcmp((yyvsp[0].id), "install-notify")) {
				    (yyval.access) = SMI_ACCESS_INSTALL_NOTIFY;
			        } else if (!strcmp((yyvsp[0].id), "notify")) {
				    (yyval.access) = SMI_ACCESS_NOTIFY;
			        } else if (!strcmp((yyvsp[0].id), "report-only")) {
				    (yyval.access) = SMI_ACCESS_REPORT_ONLY;
			        } else if (!strcmp((yyvsp[0].id), "not-accessible")) {
				    (yyval.access) = SMI_ACCESS_NOT_ACCESSIBLE;
                                } else {
				    smiPrintError(thisParserPtr,
					          ERR_INVALID_SPPI_ACCESS,
					          (yyvsp[0].id));
				    (yyval.access) = SMI_ACCESS_UNKNOWN;
			        }
                            }
			    smiFree((yyvsp[0].id));
			}
#line 7890 "parser-smi.c"
    break;

  case 293: /* $@41: %empty  */
#line 5582 "parser-smi.y"
                        {
                            if (thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SPPI_CONSTRUCT_IN_MIB, "PIB-INDEX");
                        }
#line 7899 "parser-smi.c"
    break;

  case 294: /* IndexPart: PIB_INDEX $@41 '{' Entry '}'  */
#line 5587 "parser-smi.y"
                        {
                            List *p = smiMalloc(sizeof(List));
                            
                            p->ptr       = (yyvsp[-1].objectPtr);
                            p->nextPtr   = NULL;
                            
			    (yyval.index).indexkind = SMI_INDEX_INDEX;
			    (yyval.index).implied   = impliedFlag;
			    (yyval.index).listPtr   = p;
			    (yyval.index).rowPtr    = NULL;
                            indexFlag    = INDEXFLAG_PIBINDEX;
			}
#line 7916 "parser-smi.c"
    break;

  case 295: /* IndexPart: AUGMENTS '{' Entry '}'  */
#line 5602 "parser-smi.y"
                        {
			    (yyval.index).indexkind    = SMI_INDEX_AUGMENT;
			    (yyval.index).implied      = 0;
			    (yyval.index).listPtr      = NULL;
			    (yyval.index).rowPtr       = (yyvsp[-1].objectPtr);
                            indexFlag       = INDEXFLAG_AUGMENTS;
			}
#line 7928 "parser-smi.c"
    break;

  case 296: /* $@42: %empty  */
#line 5610 "parser-smi.y"
                        {
                            if (thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SPPI_CONSTRUCT_IN_MIB, "EXTENDS");
                        }
#line 7937 "parser-smi.c"
    break;

  case 297: /* IndexPart: EXTENDS $@42 '{' Entry '}'  */
#line 5615 "parser-smi.y"
                        {
			    (yyval.index).indexkind    = SMI_INDEX_SPARSE;
			    (yyval.index).implied      = 0;
			    (yyval.index).listPtr      = NULL;
			    (yyval.index).rowPtr       = (yyvsp[-1].objectPtr);
                            indexFlag       = INDEXFLAG_EXTENDS;
			}
#line 7949 "parser-smi.c"
    break;

  case 298: /* IndexPart: %empty  */
#line 5623 "parser-smi.y"
                        {
			    (yyval.index).indexkind = SMI_INDEX_UNKNOWN;
			}
#line 7957 "parser-smi.c"
    break;

  case 299: /* $@43: %empty  */
#line 5629 "parser-smi.y"
                        {
                            /* 
                             * To avoid ambiguity caused by merging
                             * the SMI and SPPI parser we use a flag.
                             */
                            if (thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI) {
                                /*
                                 * Only INDEX or AUGMENTS are allowed for SMI
                                 */
                                if (indexFlag != INDEXFLAG_NONE)
                                    smiPrintError(thisParserPtr, ERR_INDEX_AND_AUGMENTS_USED);
                            } else {
                                /*
                                 * INDEX may only be used if PIB_INDEX was used
                                 */
                                if (indexFlag != INDEXFLAG_PIBINDEX)
                                    smiPrintError(thisParserPtr, ERR_INDEX_WITHOUT_PIB_INDEX);
                            }
                            
			    /*
			     * Use a global variable to fetch and remember
			     * whether we have seen an IMPLIED keyword.
			     */
			    impliedFlag = 0;
			}
#line 7987 "parser-smi.c"
    break;

  case 300: /* MibIndex: INDEX $@43 '{' IndexTypes '}'  */
#line 5655 "parser-smi.y"
                        {
			    (yyval.index).indexkind = SMI_INDEX_INDEX;
			    (yyval.index).implied   = impliedFlag;
			    (yyval.index).listPtr   = (yyvsp[-1].listPtr);
			    (yyval.index).rowPtr    = NULL;
                        }
#line 7998 "parser-smi.c"
    break;

  case 301: /* MibIndex: %empty  */
#line 5662 "parser-smi.y"
                        {
			    (yyval.index).indexkind = SMI_INDEX_UNKNOWN;
			}
#line 8006 "parser-smi.c"
    break;

  case 302: /* IndexTypes: IndexType  */
#line 5668 "parser-smi.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].objectPtr);
			    (yyval.listPtr)->nextPtr = NULL;
			}
#line 8016 "parser-smi.c"
    break;

  case 303: /* IndexTypes: IndexTypes ',' IndexType  */
#line 5675 "parser-smi.y"
                        {
			    List *p, *pp;
			    
			    p = smiMalloc(sizeof(List));
			    p->ptr = (yyvsp[0].objectPtr);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-2].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    (yyval.listPtr) = (yyvsp[-2].listPtr);
			}
#line 8031 "parser-smi.c"
    break;

  case 304: /* IndexType: IMPLIED Index  */
#line 5688 "parser-smi.y"
                        {
			    impliedFlag = 1;
			    (yyval.objectPtr) = (yyvsp[0].objectPtr);
			}
#line 8040 "parser-smi.c"
    break;

  case 305: /* IndexType: Index  */
#line 5693 "parser-smi.y"
                        {
			    (yyval.objectPtr) = (yyvsp[0].objectPtr);
			}
#line 8048 "parser-smi.c"
    break;

  case 306: /* Index: ObjectName  */
#line 5703 "parser-smi.y"
                        {
			    (yyval.objectPtr) = (yyvsp[0].objectPtr);
			}
#line 8056 "parser-smi.c"
    break;

  case 307: /* Entry: ObjectName  */
#line 5709 "parser-smi.y"
                        {
			    (yyval.objectPtr) = (yyvsp[0].objectPtr);
			}
#line 8064 "parser-smi.c"
    break;

  case 308: /* DefValPart: DEFVAL '{' Value '}'  */
#line 5715 "parser-smi.y"
                        {
			    (yyval.valuePtr) = (yyvsp[-1].valuePtr);
			    if ((defaultBasetype == SMI_BASETYPE_BITS) &&
				((yyval.valuePtr)->basetype != SMI_BASETYPE_BITS)) {
				smiPrintError(thisParserPtr,
					      ERR_DEFVAL_SYNTAX);
				if ((yyval.valuePtr)->basetype == SMI_BASETYPE_OCTETSTRING) {
				    smiFree((yyval.valuePtr)->value.ptr);
				}
				smiFree((yyval.valuePtr));
				(yyval.valuePtr) = NULL;
			    }
			}
#line 8082 "parser-smi.c"
    break;

  case 309: /* DefValPart: %empty  */
#line 5729 "parser-smi.y"
                        { (yyval.valuePtr) = NULL; }
#line 8088 "parser-smi.c"
    break;

  case 310: /* Value: valueofObjectSyntax  */
#line 5734 "parser-smi.y"
                        { (yyval.valuePtr) = (yyvsp[0].valuePtr); }
#line 8094 "parser-smi.c"
    break;

  case 311: /* Value: '{' BitsValue '}'  */
#line 5736 "parser-smi.y"
                        {
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    (yyval.valuePtr)->basetype = SMI_BASETYPE_BITS;
			    (yyval.valuePtr)->value.ptr = (void *)(yyvsp[-1].listPtr);
			}
#line 8104 "parser-smi.c"
    break;

  case 312: /* BitsValue: BitNames  */
#line 5744 "parser-smi.y"
                        { (yyval.listPtr) = (yyvsp[0].listPtr); }
#line 8110 "parser-smi.c"
    break;

  case 313: /* BitsValue: %empty  */
#line 5746 "parser-smi.y"
                        { (yyval.listPtr) = NULL; }
#line 8116 "parser-smi.c"
    break;

  case 314: /* BitNames: LOWERCASE_IDENTIFIER  */
#line 5750 "parser-smi.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].id);
			    (yyval.listPtr)->nextPtr = NULL;
			}
#line 8126 "parser-smi.c"
    break;

  case 315: /* BitNames: BitNames ',' LOWERCASE_IDENTIFIER  */
#line 5756 "parser-smi.y"
                        {
			    List *p, *pp;
			    
			    p = smiMalloc(sizeof(List));
			    p->ptr = (yyvsp[0].id);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-2].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    (yyval.listPtr) = (yyvsp[-2].listPtr);
			}
#line 8141 "parser-smi.c"
    break;

  case 316: /* ObjectName: objectIdentifier  */
#line 5769 "parser-smi.y"
                        {
			    (yyval.objectPtr) = (yyvsp[0].objectPtr);
			}
#line 8149 "parser-smi.c"
    break;

  case 317: /* NotificationName: objectIdentifier  */
#line 5775 "parser-smi.y"
                        {
			    (yyval.objectPtr) = (yyvsp[0].objectPtr);
			}
#line 8157 "parser-smi.c"
    break;

  case 318: /* ReferPart: REFERENCE Text  */
#line 5781 "parser-smi.y"
                        {
			    (yyval.text) = (yyvsp[0].text);

			    if ((yyvsp[0].text) && !strlen((yyvsp[0].text))) {
				smiPrintError(thisParserPtr,
					      ERR_EMPTY_REFERENCE);
			    }
			}
#line 8170 "parser-smi.c"
    break;

  case 319: /* ReferPart: %empty  */
#line 5790 "parser-smi.y"
                        { (yyval.text) = NULL; }
#line 8176 "parser-smi.c"
    break;

  case 320: /* RevisionPart: Revisions  */
#line 5794 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 8182 "parser-smi.c"
    break;

  case 321: /* RevisionPart: %empty  */
#line 5796 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 8188 "parser-smi.c"
    break;

  case 322: /* Revisions: Revision  */
#line 5800 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 8194 "parser-smi.c"
    break;

  case 323: /* Revisions: Revisions Revision  */
#line 5802 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 8200 "parser-smi.c"
    break;

  case 324: /* $@44: %empty  */
#line 5806 "parser-smi.y"
                        {
			    thisParserPtr->firstRevisionLine = thisParserPtr->line;

			    if (thisParserPtr->modulePtr->lastRevisionPtr &&
				((yyvsp[0].date) >= thisParserPtr->modulePtr->lastRevisionPtr->export.date)) {
				smiPrintError(thisParserPtr,
					      ERR_REVISION_NOT_DESCENDING);
			    }

			    if ((yyvsp[0].date) > thisParserPtr->modulePtr->lastUpdated) {
				smiPrintError(thisParserPtr,
					      ERR_REVISION_AFTER_LAST_UPDATE);
			    }
			}
#line 8219 "parser-smi.c"
    break;

  case 325: /* Revision: REVISION ExtUTCTime $@44 DESCRIPTION Text  */
#line 5821 "parser-smi.y"
                        {
			    Revision *revisionPtr;

			    checkDescr(thisParserPtr, (yyvsp[0].text));

			    revisionPtr = addRevision((yyvsp[-3].date), (yyvsp[0].text), thisParserPtr);
			    if (revisionPtr) {
				setRevisionLine(revisionPtr,
						thisParserPtr->firstRevisionLine,
						thisParserPtr);
			    }
			    (yyval.err) = revisionPtr ? 0 : -1;
			}
#line 8237 "parser-smi.c"
    break;

  case 326: /* NotificationObjectsPart: OBJECTS '{' Objects '}'  */
#line 5837 "parser-smi.y"
                        {
			    (yyval.listPtr) = (yyvsp[-1].listPtr);
			}
#line 8245 "parser-smi.c"
    break;

  case 327: /* NotificationObjectsPart: %empty  */
#line 5841 "parser-smi.y"
                        {
			    (yyval.listPtr) = NULL;
			}
#line 8253 "parser-smi.c"
    break;

  case 328: /* ObjectGroupObjectsPart: OBJECTS '{' Objects '}'  */
#line 5847 "parser-smi.y"
                        {
			    (yyval.listPtr) = (yyvsp[-1].listPtr);
			}
#line 8261 "parser-smi.c"
    break;

  case 329: /* Objects: Object  */
#line 5853 "parser-smi.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].objectPtr);
			    (yyval.listPtr)->nextPtr = NULL;
			}
#line 8271 "parser-smi.c"
    break;

  case 330: /* Objects: Objects ',' Object  */
#line 5859 "parser-smi.y"
                        {
			    List *p, *pp;
			    
			    p = smiMalloc(sizeof(List));
			    p->ptr = (yyvsp[0].objectPtr);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-2].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    (yyval.listPtr) = (yyvsp[-2].listPtr);
			}
#line 8286 "parser-smi.c"
    break;

  case 331: /* Object: ObjectName  */
#line 5872 "parser-smi.y"
                        {
			    (yyval.objectPtr) = (yyvsp[0].objectPtr);
			    if ((thisParserPtr->currentDecl == SMI_DECL_OBJECTGROUP) &&
				(yyval.objectPtr)->modulePtr != thisParserPtr->modulePtr) {
                                smiPrintError(thisParserPtr,
					      ERR_COMPLIANCE_MEMBER_NOT_LOCAL,
					      (yyval.objectPtr)->export.name);
			    }
			}
#line 8300 "parser-smi.c"
    break;

  case 332: /* NotificationsPart: NOTIFICATIONS '{' Notifications '}'  */
#line 5884 "parser-smi.y"
                        {
			    (yyval.listPtr) = (yyvsp[-1].listPtr);
			}
#line 8308 "parser-smi.c"
    break;

  case 333: /* Notifications: Notification  */
#line 5890 "parser-smi.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].objectPtr);
			    (yyval.listPtr)->nextPtr = NULL;
			}
#line 8318 "parser-smi.c"
    break;

  case 334: /* Notifications: Notifications ',' Notification  */
#line 5896 "parser-smi.y"
                        {
			    List *p, *pp;
			    
			    p = smiMalloc(sizeof(List));
			    p->ptr = (yyvsp[0].objectPtr);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-2].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    (yyval.listPtr) = (yyvsp[-2].listPtr);
			}
#line 8333 "parser-smi.c"
    break;

  case 335: /* Notification: NotificationName  */
#line 5909 "parser-smi.y"
                        {
			    (yyval.objectPtr) = (yyvsp[0].objectPtr);
			    if ((yyval.objectPtr)->modulePtr != thisParserPtr->modulePtr) {
                                smiPrintError(thisParserPtr,
					      ERR_COMPLIANCE_MEMBER_NOT_LOCAL,
					      (yyval.objectPtr)->export.name);
			    }
			}
#line 8346 "parser-smi.c"
    break;

  case 336: /* Text: QUOTED_STRING  */
#line 5920 "parser-smi.y"
                        {
			    int len;
			    (yyval.text) = smiStrdup((yyvsp[0].text));
			    len = strlen((yyval.text));
			    while (len > 0 && (yyval.text)[len-1] == '\n') {
				(yyval.text)[--len] = 0;
			    }
			}
#line 8359 "parser-smi.c"
    break;

  case 337: /* ExtUTCTime: QUOTED_STRING  */
#line 5931 "parser-smi.y"
                        {
			    (yyval.date) = checkDate(thisParserPtr, (yyvsp[0].text));
			}
#line 8367 "parser-smi.c"
    break;

  case 338: /* $@45: %empty  */
#line 5936 "parser-smi.y"
                        {
			    thisParserPtr->parentNodePtr = smiHandle->rootNodePtr;
			}
#line 8375 "parser-smi.c"
    break;

  case 339: /* objectIdentifier: $@45 subidentifiers  */
#line 5940 "parser-smi.y"
                        {
			    (yyval.objectPtr) = (yyvsp[0].objectPtr);
			    if ((yyval.objectPtr)) {
				thisParserPtr->parentNodePtr = (yyvsp[0].objectPtr)->nodePtr;
			    } else {
				thisParserPtr->parentNodePtr = NULL;
			    }
			}
#line 8388 "parser-smi.c"
    break;

  case 340: /* subidentifiers: subidentifier  */
#line 5952 "parser-smi.y"
                        {
			    (yyval.objectPtr) = (yyvsp[0].objectPtr);
			}
#line 8396 "parser-smi.c"
    break;

  case 341: /* subidentifiers: subidentifiers subidentifier  */
#line 5957 "parser-smi.y"
                        {
			    (yyval.objectPtr) = (yyvsp[0].objectPtr);
			}
#line 8404 "parser-smi.c"
    break;

  case 342: /* subidentifier: fuzzy_lowercase_identifier  */
#line 5965 "parser-smi.y"
                        {
			    Object *objectPtr;
			    Import *importPtr;
			    
			    if (thisParserPtr->parentNodePtr != smiHandle->rootNodePtr) {
				smiPrintError(thisParserPtr,
					      ERR_OIDLABEL_NOT_FIRST, (yyvsp[0].id));
			    }
			    objectPtr = findObjectByModuleAndName(
				thisParserPtr->modulePtr, (yyvsp[0].id));
			    if (objectPtr) {
				(yyval.objectPtr) = objectPtr;
				smiFree((yyvsp[0].id));
			    } else {
				importPtr = findImportByName((yyvsp[0].id),
							     thisModulePtr);
				if (!importPtr ||
				    (importPtr->kind == KIND_NOTFOUND)) {
				    /*
				     * If we are in a MODULE-COMPLIANCE
				     * statement with a given MODULE...
				     */
				    if (thisParserPtr->complianceModulePtr) {
					objectPtr =
					    findObjectByModuleAndName(
						thisParserPtr->complianceModulePtr, (yyvsp[0].id));
					if (objectPtr) {
					    importPtr = addImport(
						(yyvsp[0].id),
						thisParserPtr);
					    setImportModulename(importPtr,
								thisParserPtr->complianceModulePtr->export.name);
					    addImportFlags(importPtr,
							   FLAG_INCOMPLIANCE);
					    importPtr->use++;
					} else {
					    objectPtr = addObject((yyvsp[0].id),
								  thisParserPtr->pendingNodePtr, 0,
								  FLAG_INCOMPLETE,
								  thisParserPtr);
					    smiPrintError(thisParserPtr,
							  ERR_IDENTIFIER_NOT_IN_MODULE, (yyvsp[0].id),
							  thisParserPtr->complianceModulePtr->export.name);
					}
				    } else if (thisParserPtr->capabilitiesModulePtr) {
					objectPtr =
					    findObjectByModuleAndName(
						thisParserPtr->capabilitiesModulePtr, (yyvsp[0].id));
					if (objectPtr) {
					    importPtr = addImport(
						(yyvsp[0].id),
						thisParserPtr);
					    setImportModulename(importPtr,
								thisParserPtr->capabilitiesModulePtr->
								export.name);
					    addImportFlags(importPtr,
							   FLAG_INCOMPLIANCE);
					    importPtr->use++;
					} else {
					    objectPtr = addObject((yyvsp[0].id),
								  thisParserPtr->pendingNodePtr, 0,
								  FLAG_INCOMPLETE,
								  thisParserPtr);
					    smiPrintError(thisParserPtr,
							  ERR_IDENTIFIER_NOT_IN_MODULE, (yyvsp[0].id),
							  thisParserPtr->capabilitiesModulePtr->export.name);
					}
				    } else {
					/* 
					 * forward referenced node.
					 * create it,
					 * marked with FLAG_INCOMPLETE.
					 */
					objectPtr = addObject((yyvsp[0].id),
							      thisParserPtr->pendingNodePtr,
							      0,
							      FLAG_INCOMPLETE,
							      thisParserPtr);
				    }
				    (yyval.objectPtr) = objectPtr;
				} else {
				    /*
				     * imported object.
				     */
				    importPtr->use++;
				    (yyval.objectPtr) = findObjectByModulenameAndName(
					importPtr->export.module, (yyvsp[0].id));
				    smiFree((yyvsp[0].id));
				}
			    }
			    if ((yyval.objectPtr))
				thisParserPtr->parentNodePtr = (yyval.objectPtr)->nodePtr;
			}
#line 8502 "parser-smi.c"
    break;

  case 343: /* subidentifier: moduleName '.' LOWERCASE_IDENTIFIER  */
#line 6059 "parser-smi.y"
                        {
			    Object *objectPtr;
			    Import *importPtr;
			    char *md;
			    
			    if (thisParserPtr->parentNodePtr != smiHandle->rootNodePtr) {
				md = smiMalloc(sizeof(char) *
					       (strlen((yyvsp[-2].id)) + strlen((yyvsp[0].id)) + 2));
				sprintf(md, "%s.%s", (yyvsp[-2].id), (yyvsp[0].id));
				smiPrintError(thisParserPtr,
					      ERR_OIDLABEL_NOT_FIRST, md);
				smiFree(md);
			    } else {
				objectPtr = findObjectByModulenameAndName(
				    (yyvsp[-2].id), (yyvsp[0].id));
				if (objectPtr) {
				    (yyval.objectPtr) = objectPtr;
				    smiFree((yyvsp[-2].id));
				    smiFree((yyvsp[0].id));
				} else {
				    importPtr = findImportByModulenameAndName(
					(yyvsp[-2].id), (yyvsp[0].id), thisModulePtr);
				    if (!importPtr ||
					(importPtr->kind == KIND_NOTFOUND)) {
					/* TODO: check: $1 == thisModule ? */
					/*
					 * If we are in a MODULE-COMPLIANCE
					 * statement with a given MODULE...
					 */
					if (thisParserPtr->complianceModulePtr) {
					    objectPtr =
						findObjectByModuleAndName(
						    thisParserPtr->complianceModulePtr, (yyvsp[-2].id));
					    if (objectPtr) {
						importPtr = addImport(
						    (yyvsp[-2].id),
						    thisParserPtr);
						setImportModulename(importPtr,
						    thisParserPtr->complianceModulePtr->export.name);
						addImportFlags(importPtr,
							       FLAG_INCOMPLIANCE);
						importPtr->use++;
					    } else {
						objectPtr = addObject((yyvsp[-2].id),
						    thisParserPtr->pendingNodePtr, 0,
						    FLAG_INCOMPLETE,
						    thisParserPtr);
						smiPrintError(thisParserPtr,
					      ERR_IDENTIFIER_NOT_IN_MODULE, (yyvsp[-2].id),
					     thisParserPtr->complianceModulePtr->export.name);
					    }
					} else if (thisParserPtr->capabilitiesModulePtr) {
					    objectPtr =
						findObjectByModuleAndName(
						    thisParserPtr->capabilitiesModulePtr, (yyvsp[-2].id));
					    if (objectPtr) {
						importPtr = addImport(
						    (yyvsp[-2].id),
						    thisParserPtr);
						setImportModulename(importPtr,
						        thisParserPtr->capabilitiesModulePtr->
								  export.name);
						addImportFlags(importPtr,
							       FLAG_INCOMPLIANCE);
						importPtr->use++;
					    } else {
						objectPtr = addObject((yyvsp[-2].id),
						    thisParserPtr->pendingNodePtr, 0,
						    FLAG_INCOMPLETE,
						    thisParserPtr);
						smiPrintError(thisParserPtr,
					      ERR_IDENTIFIER_NOT_IN_MODULE, (yyvsp[-2].id),
					   thisParserPtr->capabilitiesModulePtr->export.name);
					    }
					} else {
					    /* 
					     * forward referenced node.
					     * create it,
					     * marked with FLAG_INCOMPLETE.
					     */
					    objectPtr = addObject((yyvsp[0].id),
							    thisParserPtr->pendingNodePtr,
							      0,
							      FLAG_INCOMPLETE,
							      thisParserPtr);
					    smiFree((yyvsp[-2].id));
					}
					(yyval.objectPtr) = objectPtr;
				    } else {
					/*
					 * imported object.
					 */
					importPtr->use++;
					(yyval.objectPtr) = findObjectByModulenameAndName(
					    importPtr->export.module, (yyvsp[0].id));
					smiFree((yyvsp[-2].id));
					smiFree((yyvsp[0].id));
				    }
				}
				if ((yyval.objectPtr))
				    thisParserPtr->parentNodePtr = (yyval.objectPtr)->nodePtr;
			    }
			}
#line 8610 "parser-smi.c"
    break;

  case 344: /* subidentifier: NUMBER  */
#line 6163 "parser-smi.y"
                        {
			    Node *nodePtr;
			    Object *objectPtr;

			    nodePtr = findNodeByParentAndSubid(thisParserPtr->parentNodePtr,
							       (yyvsp[0].unsigned32));
			    if (nodePtr && nodePtr->lastObjectPtr &&
	       		(nodePtr->lastObjectPtr->modulePtr == thisModulePtr)) {
				/*
				 * hopefully, the last defined Object for
				 * this Node is the one we expect.
				 */
				(yyval.objectPtr) = nodePtr->lastObjectPtr;
			    } else {
				objectPtr = addObject(NULL,
						      thisParserPtr->parentNodePtr,
						      (yyvsp[0].unsigned32),
						      FLAG_INCOMPLETE,
						      thisParserPtr);
				(yyval.objectPtr) = objectPtr;
			    }
			    thisParserPtr->parentNodePtr = (yyval.objectPtr)->nodePtr;
			}
#line 8638 "parser-smi.c"
    break;

  case 345: /* subidentifier: LOWERCASE_IDENTIFIER '(' NUMBER ')'  */
#line 6187 "parser-smi.y"
                        {
			    Object *objectPtr = NULL;
			    Object *oldObjectPtr = NULL;
			    Node *oldNodePtr = NULL;
			    
			    /* TODO: search in local module and
			     *       in imported modules
			     */

			    oldNodePtr = findNodeByParentAndSubid(
				thisParserPtr->parentNodePtr, (yyvsp[-1].unsigned32));
			    oldObjectPtr = findObjectByModuleAndName(
                                thisParserPtr->modulePtr, (yyvsp[-3].id));

			    if (oldObjectPtr &&
				((oldObjectPtr->nodePtr->subid != (yyvsp[-1].unsigned32)) ||
				 (oldObjectPtr->nodePtr->parentPtr != thisParserPtr->parentNodePtr))) {
				smiPrintError(thisParserPtr,
					      ERR_IDENTIFIER_OID_CHANGED,
					      (yyvsp[-3].id));
				smiPrintErrorAtLine(thisParserPtr,
						    ERR_PREVIOUS_DEFINITION,
						    oldObjectPtr->line,
						    oldObjectPtr->export.name);
				objectPtr = addObject((yyvsp[-3].id),
						      thisParserPtr->parentNodePtr,
						      (yyvsp[-1].unsigned32), 0, thisParserPtr);
				setObjectDecl(objectPtr,
					      SMI_DECL_IMPL_OBJECT);
				(yyval.objectPtr) = objectPtr;
				thisParserPtr->parentNodePtr = (yyval.objectPtr)->nodePtr;
			    } else if (oldNodePtr &&
				       oldNodePtr->lastObjectPtr &&
				       oldNodePtr->lastObjectPtr->export.name &&
				       strcmp(oldNodePtr->lastObjectPtr->export.name, (yyvsp[-3].id))) {
				smiPrintError(thisParserPtr,
					      ERR_OIDLABEL_CHANGED,
					      (yyvsp[-3].id), oldNodePtr->lastObjectPtr->export.name);
				smiPrintErrorAtLine(thisParserPtr,
						    ERR_PREVIOUS_DEFINITION,
						    oldNodePtr->lastObjectPtr->line,
						    oldNodePtr->lastObjectPtr->export.name);
				objectPtr = addObject((yyvsp[-3].id),
						      thisParserPtr->parentNodePtr,
						      (yyvsp[-1].unsigned32), 0, thisParserPtr);
				setObjectDecl(objectPtr,
					      SMI_DECL_IMPL_OBJECT);
				(yyval.objectPtr) = objectPtr;
				thisParserPtr->parentNodePtr = (yyval.objectPtr)->nodePtr;
			    } else {
				objectPtr = addObject((yyvsp[-3].id), thisParserPtr->parentNodePtr,
						      (yyvsp[-1].unsigned32), 0,
						      thisParserPtr);
				setObjectDecl(objectPtr,
					      SMI_DECL_IMPL_OBJECT);
				(yyval.objectPtr) = objectPtr;
				thisParserPtr->parentNodePtr = (yyval.objectPtr)->nodePtr;
			    }
			}
#line 8702 "parser-smi.c"
    break;

  case 346: /* subidentifier: moduleName '.' LOWERCASE_IDENTIFIER '(' NUMBER ')'  */
#line 6247 "parser-smi.y"
                        {
			    Object *objectPtr = NULL;
			    Object *oldObjectPtr = NULL;
			    Node *oldNodePtr = NULL;
			    char *md;

			    md = smiMalloc(sizeof(char) *
					   (strlen((yyvsp[-5].id)) + strlen((yyvsp[-3].id)) + 2));
			    sprintf(md, "%s.%s", (yyvsp[-5].id), (yyvsp[-3].id));

			    oldNodePtr = findNodeByParentAndSubid(
				thisParserPtr->parentNodePtr, (yyvsp[-1].unsigned32));
			    oldObjectPtr = findObjectByModulenameAndName(
                                (yyvsp[-5].id), (yyvsp[-3].id));

			    if (oldObjectPtr &&
				((oldObjectPtr->nodePtr->subid != (yyvsp[-1].unsigned32)) ||
				 (oldObjectPtr->nodePtr->parentPtr != thisParserPtr->parentNodePtr))) {
				smiPrintError(thisParserPtr,
					      ERR_ILLEGALLY_QUALIFIED, md);
				smiPrintError(thisParserPtr,
					      ERR_IDENTIFIER_OID_CHANGED,
					      (yyvsp[-3].id));
				smiPrintErrorAtLine(thisParserPtr,
						    ERR_PREVIOUS_DEFINITION,
						    oldObjectPtr->line,
						    oldObjectPtr->export.name);
				objectPtr = addObject((yyvsp[-3].id),
						      thisParserPtr->parentNodePtr,
						      (yyvsp[-1].unsigned32), 0, thisParserPtr);
				setObjectDecl(objectPtr,
					      SMI_DECL_IMPL_OBJECT);
				(yyval.objectPtr) = objectPtr;
				thisParserPtr->parentNodePtr = (yyval.objectPtr)->nodePtr;
			    } else if (oldNodePtr &&
				       oldNodePtr->lastObjectPtr &&
				       strcmp(oldNodePtr->lastObjectPtr->export.name, (yyvsp[-3].id))) {
				smiPrintError(thisParserPtr,
					      ERR_ILLEGALLY_QUALIFIED, md);
				smiPrintError(thisParserPtr,
					      ERR_OIDLABEL_CHANGED,
					      (yyvsp[-3].id), oldNodePtr->lastObjectPtr->export.name);
				smiPrintErrorAtLine(thisParserPtr,
						    ERR_PREVIOUS_DEFINITION,
						    oldNodePtr->lastObjectPtr->line,
						    oldNodePtr->lastObjectPtr->export.name);
				objectPtr = addObject((yyvsp[-3].id),
						      thisParserPtr->parentNodePtr,
						      (yyvsp[-1].unsigned32), 0, thisParserPtr);
				setObjectDecl(objectPtr,
					      SMI_DECL_IMPL_OBJECT);
				(yyval.objectPtr) = objectPtr;
				thisParserPtr->parentNodePtr = (yyval.objectPtr)->nodePtr;
			    } else {
				smiPrintError(thisParserPtr,
					      ERR_ILLEGALLY_QUALIFIED, md);
				objectPtr = addObject((yyvsp[-3].id), thisParserPtr->parentNodePtr,
						      (yyvsp[-1].unsigned32), 0,
						      thisParserPtr);
				setObjectDecl(objectPtr,
					      SMI_DECL_IMPL_OBJECT);
				(yyval.objectPtr) = objectPtr;
				thisParserPtr->parentNodePtr = (yyval.objectPtr)->nodePtr;
			    }
			    smiFree(md);
			}
#line 8773 "parser-smi.c"
    break;

  case 347: /* objectIdentifier_defval: subidentifiers_defval  */
#line 6316 "parser-smi.y"
                        { (yyval.text) = NULL; }
#line 8779 "parser-smi.c"
    break;

  case 348: /* subidentifiers_defval: subidentifier_defval  */
#line 6320 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 8785 "parser-smi.c"
    break;

  case 349: /* subidentifiers_defval: subidentifiers_defval subidentifier_defval  */
#line 6322 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 8791 "parser-smi.c"
    break;

  case 350: /* subidentifier_defval: LOWERCASE_IDENTIFIER '(' NUMBER ')'  */
#line 6326 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 8797 "parser-smi.c"
    break;

  case 351: /* subidentifier_defval: NUMBER  */
#line 6328 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 8803 "parser-smi.c"
    break;

  case 352: /* $@46: %empty  */
#line 6332 "parser-smi.y"
                        {
			    thisParserPtr->firstStatementLine = thisParserPtr->line;
			    thisParserPtr->currentDecl = SMI_DECL_OBJECTGROUP;
			    
			    checkNameLen(thisParserPtr, (yyvsp[0].id),
					 ERR_OIDNAME_32, ERR_OIDNAME_64);
			    smiCheckObjectName(thisParserPtr,
					       thisModulePtr, (yyvsp[0].id));
			}
#line 8817 "parser-smi.c"
    break;

  case 353: /* $@47: %empty  */
#line 6342 "parser-smi.y"
                        {
			    Import *importPtr;
			    
			    if (thisModulePtr->export.language == SMI_LANGUAGE_UNKNOWN)
				thisModulePtr->export.language = SMI_LANGUAGE_SMIV2;

			    importPtr = findImportByName("OBJECT-GROUP",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				smiPrintError(thisParserPtr,
					      ERR_MACRO_NOT_IMPORTED,
					      "OBJECT-GROUP", "SNMPv2-CONF");
			    }
			}
#line 8838 "parser-smi.c"
    break;

  case 354: /* $@48: %empty  */
#line 6361 "parser-smi.y"
                        {
			    checkDescr(thisParserPtr, (yyvsp[0].text));
			}
#line 8846 "parser-smi.c"
    break;

  case 355: /* objectGroupClause: LOWERCASE_IDENTIFIER $@46 OBJECT_GROUP $@47 ObjectGroupObjectsPart STATUS Status DESCRIPTION Text $@48 ReferPart COLON_COLON_EQUAL '{' objectIdentifier '}'  */
#line 6366 "parser-smi.y"
                        {
			    Object *objectPtr;
			    
			    objectPtr = (yyvsp[-1].objectPtr);

			    smiCheckObjectReuse(thisParserPtr, (yyvsp[-14].id), &objectPtr);

			    objectPtr = setObjectName(objectPtr, (yyvsp[-14].id), thisParserPtr);
			    setObjectDecl(objectPtr, SMI_DECL_OBJECTGROUP);
			    setObjectLine(objectPtr, thisParserPtr->firstStatementLine,
					  thisParserPtr);
			    addObjectFlags(objectPtr, FLAG_REGISTERED);
			    deleteObjectFlags(objectPtr, FLAG_INCOMPLETE);
			    setObjectStatus(objectPtr, (yyvsp[-8].status));
			    setObjectDescription(objectPtr, (yyvsp[-6].text), thisParserPtr);
			    if ((yyvsp[-4].text)) {
				setObjectReference(objectPtr, (yyvsp[-4].text), thisParserPtr);
			    }
			    setObjectAccess(objectPtr,
					    SMI_ACCESS_NOT_ACCESSIBLE);
			    setObjectList(objectPtr, (yyvsp[-10].listPtr));
			    (yyval.err) = 0;
			}
#line 8874 "parser-smi.c"
    break;

  case 356: /* $@49: %empty  */
#line 6392 "parser-smi.y"
                        {
			    thisParserPtr->firstStatementLine = thisParserPtr->line;
			    thisParserPtr->currentDecl = SMI_DECL_NOTIFICATIONGROUP;
			    
			    checkNameLen(thisParserPtr, (yyvsp[0].id),
					 ERR_OIDNAME_32, ERR_OIDNAME_64);
			    smiCheckObjectName(thisParserPtr,
					       thisModulePtr, (yyvsp[0].id));
			}
#line 8888 "parser-smi.c"
    break;

  case 357: /* $@50: %empty  */
#line 6402 "parser-smi.y"
                        {
			    Import *importPtr;
                            if (thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "NOTIFICATION-GROUP");
			    
			    if (thisModulePtr->export.language == SMI_LANGUAGE_UNKNOWN)
				thisModulePtr->export.language = SMI_LANGUAGE_SMIV2;

			    importPtr = findImportByName("NOTIFICATION-GROUP",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				smiPrintError(thisParserPtr,
					      ERR_MACRO_NOT_IMPORTED,
					      "NOTIFICATION-GROUP",
					      "SNMPv2-CONF");
			    }
			}
#line 8912 "parser-smi.c"
    break;

  case 358: /* $@51: %empty  */
#line 6424 "parser-smi.y"
                        {
			    checkDescr(thisParserPtr, (yyvsp[0].text));
			}
#line 8920 "parser-smi.c"
    break;

  case 359: /* notificationGroupClause: LOWERCASE_IDENTIFIER $@49 NOTIFICATION_GROUP $@50 NotificationsPart STATUS Status DESCRIPTION Text $@51 ReferPart COLON_COLON_EQUAL '{' objectIdentifier '}'  */
#line 6429 "parser-smi.y"
                        {
			    Object *objectPtr;
			    
			    objectPtr = (yyvsp[-1].objectPtr);

			    smiCheckObjectReuse(thisParserPtr, (yyvsp[-14].id), &objectPtr);

			    objectPtr = setObjectName(objectPtr, (yyvsp[-14].id), thisParserPtr);
			    setObjectDecl(objectPtr,
					  SMI_DECL_NOTIFICATIONGROUP);
			    setObjectLine(objectPtr, thisParserPtr->firstStatementLine,
					  thisParserPtr);
			    addObjectFlags(objectPtr, FLAG_REGISTERED);
			    deleteObjectFlags(objectPtr, FLAG_INCOMPLETE);
			    setObjectStatus(objectPtr, (yyvsp[-8].status));
			    setObjectDescription(objectPtr, (yyvsp[-6].text), thisParserPtr);
			    if ((yyvsp[-4].text)) {
				setObjectReference(objectPtr, (yyvsp[-4].text), thisParserPtr);
			    }
			    setObjectAccess(objectPtr,
					    SMI_ACCESS_NOT_ACCESSIBLE);
			    setObjectList(objectPtr, (yyvsp[-10].listPtr));
			    (yyval.err) = 0;
			}
#line 8949 "parser-smi.c"
    break;

  case 360: /* $@52: %empty  */
#line 6456 "parser-smi.y"
                        {
			    thisParserPtr->firstStatementLine = thisParserPtr->line;
			    thisParserPtr->currentDecl = SMI_DECL_MODULECOMPLIANCE;
			    
			    checkNameLen(thisParserPtr, (yyvsp[0].id),
					 ERR_OIDNAME_32, ERR_OIDNAME_64);
			    smiCheckObjectName(thisParserPtr,
					       thisModulePtr, (yyvsp[0].id));
			}
#line 8963 "parser-smi.c"
    break;

  case 361: /* $@53: %empty  */
#line 6466 "parser-smi.y"
                        {
			    Import *importPtr;
			    
			    if (thisModulePtr->export.language == SMI_LANGUAGE_UNKNOWN)
				thisModulePtr->export.language = SMI_LANGUAGE_SMIV2;
			    importPtr = findImportByName("MODULE-COMPLIANCE",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				smiPrintError(thisParserPtr,
					      ERR_MACRO_NOT_IMPORTED,
					      "MODULE-COMPLIANCE",
					      "SNMPv2-CONF");
			    }
			}
#line 8984 "parser-smi.c"
    break;

  case 362: /* $@54: %empty  */
#line 6484 "parser-smi.y"
                        {
			    checkDescr(thisParserPtr, (yyvsp[0].text));
			}
#line 8992 "parser-smi.c"
    break;

  case 363: /* moduleComplianceClause: LOWERCASE_IDENTIFIER $@52 MODULE_COMPLIANCE $@53 STATUS Status DESCRIPTION Text $@54 ReferPart ComplianceModulePart COLON_COLON_EQUAL '{' objectIdentifier '}'  */
#line 6490 "parser-smi.y"
                        {
			    Object *objectPtr;
			    Option *optionPtr;
			    Refinement *refinementPtr;
			    List *listPtr;
			    
			    objectPtr = (yyvsp[-1].objectPtr);

			    smiCheckObjectReuse(thisParserPtr, (yyvsp[-14].id), &objectPtr);

			    setObjectName(objectPtr, (yyvsp[-14].id), thisParserPtr);
			    setObjectDecl(objectPtr,
					  SMI_DECL_MODULECOMPLIANCE);
			    setObjectLine(objectPtr, thisParserPtr->firstStatementLine,
					  thisParserPtr);
			    addObjectFlags(objectPtr, FLAG_REGISTERED);
			    deleteObjectFlags(objectPtr, FLAG_INCOMPLETE);
			    setObjectStatus(objectPtr, (yyvsp[-9].status));
			    setObjectDescription(objectPtr, (yyvsp[-7].text), thisParserPtr);
			    if ((yyvsp[-5].text)) {
				setObjectReference(objectPtr, (yyvsp[-5].text), thisParserPtr);
			    }
			    setObjectAccess(objectPtr,
					    SMI_ACCESS_NOT_ACCESSIBLE);
			    setObjectList(objectPtr, (yyvsp[-4].compl).mandatorylistPtr);
			    objectPtr->optionlistPtr = (yyvsp[-4].compl).optionlistPtr;
			    objectPtr->refinementlistPtr =
				                          (yyvsp[-4].compl).refinementlistPtr;

			    if ((yyvsp[-4].compl).optionlistPtr) {
				for (listPtr = (yyvsp[-4].compl).optionlistPtr;
				     listPtr;
				     listPtr = listPtr->nextPtr) {
				    optionPtr = ((Option *)(listPtr->ptr));
				    optionPtr->compliancePtr = objectPtr;
				}
			    }

			    /*
			     * Dirty: Fake the types' names in the
			     * refinement list:
			     * ``<compliancename>+<objecttypename>+type''
			     * ``<compliancename>+<objecttypename>+writetype''
			     */
			    if ((yyvsp[-4].compl).refinementlistPtr) {
				for (listPtr = (yyvsp[-4].compl).refinementlistPtr;
				     listPtr;
				     listPtr = listPtr->nextPtr) {
				    refinementPtr =
					((Refinement *)(listPtr->ptr));
				    refinementPtr->compliancePtr = objectPtr;
				}
			    }

			    (yyval.err) = 0;
			}
#line 9053 "parser-smi.c"
    break;

  case 364: /* ComplianceModulePart: ComplianceModules  */
#line 6549 "parser-smi.y"
                        {
			    (yyval.compl) = (yyvsp[0].compl);
			}
#line 9061 "parser-smi.c"
    break;

  case 365: /* ComplianceModules: ComplianceModule  */
#line 6555 "parser-smi.y"
                        {
			    (yyval.compl) = (yyvsp[0].compl);
			}
#line 9069 "parser-smi.c"
    break;

  case 366: /* ComplianceModules: ComplianceModules ComplianceModule  */
#line 6559 "parser-smi.y"
                        {
			    List *listPtr;
			    
			    /* concatenate lists in $1 and $2 */
			    if ((yyvsp[-1].compl).mandatorylistPtr) {
				for (listPtr = (yyvsp[-1].compl).mandatorylistPtr;
				     listPtr->nextPtr;
				     listPtr = listPtr->nextPtr);
				listPtr->nextPtr = (yyvsp[0].compl).mandatorylistPtr;
				(yyval.compl).mandatorylistPtr = (yyvsp[-1].compl).mandatorylistPtr;
			    } else {
				(yyval.compl).mandatorylistPtr = (yyvsp[0].compl).mandatorylistPtr;
			    }
			    if ((yyvsp[-1].compl).optionlistPtr) {
				for (listPtr = (yyvsp[-1].compl).optionlistPtr;
				     listPtr->nextPtr;
				     listPtr = listPtr->nextPtr);
				listPtr->nextPtr = (yyvsp[0].compl).optionlistPtr;
				(yyval.compl).optionlistPtr = (yyvsp[-1].compl).optionlistPtr;
			    } else {
				(yyval.compl).optionlistPtr = (yyvsp[0].compl).optionlistPtr;
			    }
			    if ((yyvsp[-1].compl).refinementlistPtr) {
				for (listPtr = (yyvsp[-1].compl).refinementlistPtr;
				     listPtr->nextPtr;
				     listPtr = listPtr->nextPtr);
				listPtr->nextPtr = (yyvsp[0].compl).refinementlistPtr;
				(yyval.compl).refinementlistPtr = (yyvsp[-1].compl).refinementlistPtr;
			    } else {
				(yyval.compl).refinementlistPtr = (yyvsp[0].compl).refinementlistPtr;
			    }
			}
#line 9106 "parser-smi.c"
    break;

  case 367: /* $@55: %empty  */
#line 6594 "parser-smi.y"
                        {
			    /*
			     * Remember the module. SMIv2 is broken by
			     * design to allow subsequent clauses to
			     * refer identifiers that are not
			     * imported.  Although, SMIv2 does not
			     * require, we will fake it by inserting
			     * appropriate imports.
			     */
			    if ((yyvsp[0].modulePtr) == thisModulePtr)
				thisParserPtr->complianceModulePtr = NULL;
			    else
				thisParserPtr->complianceModulePtr = (yyvsp[0].modulePtr);
			}
#line 9125 "parser-smi.c"
    break;

  case 368: /* ComplianceModule: MODULE ComplianceModuleName $@55 MandatoryPart CompliancePart  */
#line 6610 "parser-smi.y"
                        {
			    (yyval.compl).mandatorylistPtr = (yyvsp[-1].listPtr);
			    (yyval.compl).optionlistPtr = (yyvsp[0].compl).optionlistPtr;
			    (yyval.compl).refinementlistPtr = (yyvsp[0].compl).refinementlistPtr;
			    if (thisParserPtr->complianceModulePtr) {
				checkImports(thisParserPtr->complianceModulePtr,
					     thisParserPtr);
				thisParserPtr->complianceModulePtr = NULL;
			    }
			}
#line 9140 "parser-smi.c"
    break;

  case 369: /* ComplianceModuleName: UPPERCASE_IDENTIFIER objectIdentifier  */
#line 6623 "parser-smi.y"
                        {
			    (yyval.modulePtr) = findModuleByName((yyvsp[-1].id));
			    /* TODO: handle objectIdentifier */
			    if (!(yyval.modulePtr)) {
				(yyval.modulePtr) = loadModule((yyvsp[-1].id), thisParserPtr);
			    }
			    smiFree((yyvsp[-1].id));
			}
#line 9153 "parser-smi.c"
    break;

  case 370: /* ComplianceModuleName: UPPERCASE_IDENTIFIER  */
#line 6632 "parser-smi.y"
                        {
			    (yyval.modulePtr) = findModuleByName((yyvsp[0].id));
			    if (!(yyval.modulePtr)) {
				(yyval.modulePtr) = loadModule((yyvsp[0].id), thisParserPtr);
			    }
			    smiFree((yyvsp[0].id));
			}
#line 9165 "parser-smi.c"
    break;

  case 371: /* ComplianceModuleName: %empty  */
#line 6641 "parser-smi.y"
                        {
			    (yyval.modulePtr) = thisModulePtr;
			}
#line 9173 "parser-smi.c"
    break;

  case 372: /* MandatoryPart: MANDATORY_GROUPS '{' MandatoryGroups '}'  */
#line 6647 "parser-smi.y"
                        {
			    (yyval.listPtr) = (yyvsp[-1].listPtr);
			}
#line 9181 "parser-smi.c"
    break;

  case 373: /* MandatoryPart: %empty  */
#line 6651 "parser-smi.y"
                        {
			    (yyval.listPtr) = NULL;
			}
#line 9189 "parser-smi.c"
    break;

  case 374: /* MandatoryGroups: MandatoryGroup  */
#line 6657 "parser-smi.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].objectPtr);
			    (yyval.listPtr)->nextPtr = NULL;
			}
#line 9199 "parser-smi.c"
    break;

  case 375: /* MandatoryGroups: MandatoryGroups ',' MandatoryGroup  */
#line 6663 "parser-smi.y"
                        {
			    List *p, *pp;
			    
			    p = smiMalloc(sizeof(List));
			    p->ptr = (yyvsp[0].objectPtr);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-2].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    (yyval.listPtr) = (yyvsp[-2].listPtr);
			}
#line 9214 "parser-smi.c"
    break;

  case 376: /* MandatoryGroup: objectIdentifier  */
#line 6676 "parser-smi.y"
                        {
			    /* TODO: check that objectIdentifier is
			       found, is defined in thisParserPtr->complianceModulePtr,
			       and is a group node. */
			    Import *importPtr;

			    (yyval.objectPtr) = (yyvsp[0].objectPtr);
			    if (thisParserPtr->complianceModulePtr) {
				(yyval.objectPtr) = findObjectByModuleAndName(
				                           thisParserPtr->complianceModulePtr,
							   (yyvsp[0].objectPtr)->export.name);
			    }
			    if (thisParserPtr->complianceModulePtr && (yyvsp[0].objectPtr)->export.name) {
				importPtr = findImportByModulenameAndName(
				    thisParserPtr->complianceModulePtr->export.name,
				    (yyvsp[0].objectPtr)->export.name, thisModulePtr);
				if (importPtr)
				    importPtr->use++;
			    }
			}
#line 9239 "parser-smi.c"
    break;

  case 377: /* CompliancePart: Compliances  */
#line 6699 "parser-smi.y"
                        {
			    (yyval.compl).mandatorylistPtr = NULL;
			    (yyval.compl).optionlistPtr = (yyvsp[0].compl).optionlistPtr;
			    (yyval.compl).refinementlistPtr = (yyvsp[0].compl).refinementlistPtr;
			}
#line 9249 "parser-smi.c"
    break;

  case 378: /* CompliancePart: %empty  */
#line 6705 "parser-smi.y"
                        {
			    (yyval.compl).mandatorylistPtr = NULL;
			    (yyval.compl).optionlistPtr = NULL;
			    (yyval.compl).refinementlistPtr = NULL;
			}
#line 9259 "parser-smi.c"
    break;

  case 379: /* Compliances: Compliance  */
#line 6713 "parser-smi.y"
                        {
			    (yyval.compl) = (yyvsp[0].compl);
			}
#line 9267 "parser-smi.c"
    break;

  case 380: /* Compliances: Compliances Compliance  */
#line 6717 "parser-smi.y"
                        {
			    List *listPtr;
			    int stop;
			    
			    (yyval.compl).mandatorylistPtr = NULL;

			    /* check for duplicates in optionlist */
			    stop = 0;
			    if ((yyvsp[0].compl).optionlistPtr) {
				for (listPtr = (yyvsp[-1].compl).optionlistPtr; listPtr;
				     listPtr = listPtr->nextPtr) {
				    if (((Option *)listPtr->ptr)->objectPtr ==
					((Option *)(yyvsp[0].compl).optionlistPtr->ptr)->objectPtr) {
					smiPrintError(thisParserPtr,
						      ERR_OPTIONALGROUP_ALREADY_EXISTS,
						      ((Option *)(yyvsp[0].compl).optionlistPtr->ptr)->objectPtr->export.name);
					stop = 1;
					(yyval.compl).optionlistPtr = (yyvsp[-1].compl).optionlistPtr;
				    }
				}
			    }
	
                            /* concatenate optionlists */
			    if ((yyvsp[-1].compl).optionlistPtr) {
				for (listPtr = (yyvsp[-1].compl).optionlistPtr;
				     listPtr->nextPtr;
				     listPtr = listPtr->nextPtr);
				if (!stop) {
				    listPtr->nextPtr = (yyvsp[0].compl).optionlistPtr;
				}
				(yyval.compl).optionlistPtr = (yyvsp[-1].compl).optionlistPtr;
			    } else {
				(yyval.compl).optionlistPtr = (yyvsp[0].compl).optionlistPtr;
			    }

			    /* check for duplicates in refinementlist */
			    stop = 0;
			    if ((yyvsp[0].compl).refinementlistPtr) {
				for (listPtr = (yyvsp[-1].compl).refinementlistPtr; listPtr;
				     listPtr = listPtr->nextPtr) {
				    if (((Refinement *)listPtr->ptr)->objectPtr ==
					((Refinement *)(yyvsp[0].compl).refinementlistPtr->ptr)->objectPtr) {
					smiPrintError(thisParserPtr,
						      ERR_REFINEMENT_ALREADY_EXISTS,
						      ((Refinement *)(yyvsp[0].compl).refinementlistPtr->ptr)->objectPtr->export.name);
					stop = 1;
					(yyval.compl).refinementlistPtr = (yyvsp[-1].compl).refinementlistPtr;
				    }
				}
			    }
			    
                            /* concatenate refinementlists */
			    if ((yyvsp[-1].compl).refinementlistPtr) {
				for (listPtr = (yyvsp[-1].compl).refinementlistPtr;
				     listPtr->nextPtr;
				     listPtr = listPtr->nextPtr);
				if (!stop) {
				    listPtr->nextPtr = (yyvsp[0].compl).refinementlistPtr;
				}
				(yyval.compl).refinementlistPtr = (yyvsp[-1].compl).refinementlistPtr;
			    } else {
				(yyval.compl).refinementlistPtr = (yyvsp[0].compl).refinementlistPtr;
			    }
			}
#line 9336 "parser-smi.c"
    break;

  case 381: /* Compliance: ComplianceGroup  */
#line 6784 "parser-smi.y"
                        {
			    (yyval.compl).mandatorylistPtr = NULL;
			    (yyval.compl).optionlistPtr = (yyvsp[0].listPtr);
			    (yyval.compl).refinementlistPtr = NULL;
			}
#line 9346 "parser-smi.c"
    break;

  case 382: /* Compliance: ComplianceObject  */
#line 6790 "parser-smi.y"
                        {
			    (yyval.compl).mandatorylistPtr = NULL;
			    (yyval.compl).optionlistPtr = NULL;
			    (yyval.compl).refinementlistPtr = (yyvsp[0].listPtr);
			}
#line 9356 "parser-smi.c"
    break;

  case 383: /* $@56: %empty  */
#line 6798 "parser-smi.y"
                        {
			    thisParserPtr->firstNestedStatementLine = thisParserPtr->line;
			}
#line 9364 "parser-smi.c"
    break;

  case 384: /* ComplianceGroup: GROUP $@56 objectIdentifier DESCRIPTION Text  */
#line 6803 "parser-smi.y"
                        {
			    Import *importPtr;
			    
			    if (thisParserPtr->complianceModulePtr && (yyvsp[-2].objectPtr)->export.name) {
				importPtr = findImportByModulenameAndName(
						    thisParserPtr->complianceModulePtr->export.name,
						    (yyvsp[-2].objectPtr)->export.name,
						    thisModulePtr);
				if (importPtr)
				    importPtr->use++;
			    }

			    checkDescr(thisParserPtr, (yyvsp[0].text));
			    
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->nextPtr = NULL;
			    (yyval.listPtr)->ptr = smiMalloc(sizeof(Option));
			    ((Option *)((yyval.listPtr)->ptr))->line = thisParserPtr->firstNestedStatementLine;
			    ((Option *)((yyval.listPtr)->ptr))->objectPtr = (yyvsp[-2].objectPtr);
			    if (! (thisModulePtr->flags & SMI_FLAG_NODESCR)) {
				((Option *)((yyval.listPtr)->ptr))->export.description = (yyvsp[0].text);
			    } else {
				smiFree((yyvsp[0].text));
			    }
			}
#line 9394 "parser-smi.c"
    break;

  case 385: /* $@57: %empty  */
#line 6831 "parser-smi.y"
                        {
			    thisParserPtr->firstNestedStatementLine = thisParserPtr->line;
			}
#line 9402 "parser-smi.c"
    break;

  case 386: /* ComplianceObject: OBJECT $@57 ObjectName SyntaxPart WriteSyntaxPart AccessPart DESCRIPTION Text  */
#line 6839 "parser-smi.y"
                        {
			    Import *importPtr;

			    if (thisParserPtr->complianceModulePtr && (yyvsp[-5].objectPtr)->export.name) {
				importPtr = findImportByModulenameAndName(
						    thisParserPtr->complianceModulePtr->export.name,
						    (yyvsp[-5].objectPtr)->export.name,
						    thisModulePtr);
				if (importPtr) 
				    importPtr->use++;
			    }

			    checkDescr(thisParserPtr, (yyvsp[0].text));
			    
			    thisParserPtr->flags &= ~FLAG_CREATABLE;
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->nextPtr = NULL;
			    (yyval.listPtr)->ptr = smiMalloc(sizeof(Refinement));
			    ((Refinement *)((yyval.listPtr)->ptr))->line =
				thisParserPtr->firstNestedStatementLine;
			    ((Refinement *)((yyval.listPtr)->ptr))->objectPtr = (yyvsp[-5].objectPtr);
			    ((Refinement *)((yyval.listPtr)->ptr))->typePtr = (yyvsp[-4].typePtr);
			    if ((yyvsp[-4].typePtr)) {
				(yyvsp[-4].typePtr)->parentPtr = (yyvsp[-5].objectPtr)->typePtr;
			    }
			    ((Refinement *)((yyval.listPtr)->ptr))->writetypePtr = (yyvsp[-3].typePtr);
			    if ((yyvsp[-3].typePtr)) {
				(yyvsp[-3].typePtr)->parentPtr = (yyvsp[-5].objectPtr)->typePtr;
			    }
			    ((Refinement *)((yyval.listPtr)->ptr))->export.access = (yyvsp[-2].access);
			    if (! (thisParserPtr->flags & SMI_FLAG_NODESCR)) {
				((Refinement *)((yyval.listPtr)->ptr))->export.description = (yyvsp[0].text);
			    } else {
				smiFree((yyvsp[0].text));
			    }
			}
#line 9443 "parser-smi.c"
    break;

  case 387: /* SyntaxPart: SYNTAX Syntax  */
#line 6878 "parser-smi.y"
                        {
			    if ((yyvsp[0].typePtr)->export.name) {
				(yyval.typePtr) = duplicateType((yyvsp[0].typePtr), 0, thisParserPtr);
			    } else {
				(yyval.typePtr) = (yyvsp[0].typePtr);
			    }
			}
#line 9455 "parser-smi.c"
    break;

  case 388: /* SyntaxPart: %empty  */
#line 6886 "parser-smi.y"
                        {
			    (yyval.typePtr) = NULL;
			}
#line 9463 "parser-smi.c"
    break;

  case 389: /* WriteSyntaxPart: WRITE_SYNTAX WriteSyntax  */
#line 6892 "parser-smi.y"
                        {
                            /* must not be present in PIBs */
                            if (thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "WRITE-SYNTAX");
			    if ((yyvsp[0].typePtr)->export.name) {
				(yyval.typePtr) = duplicateType((yyvsp[0].typePtr), 0, thisParserPtr);
			    } else {
				(yyval.typePtr) = (yyvsp[0].typePtr);
			    }
			}
#line 9478 "parser-smi.c"
    break;

  case 390: /* WriteSyntaxPart: %empty  */
#line 6903 "parser-smi.y"
                        {
			    (yyval.typePtr) = NULL;
			}
#line 9486 "parser-smi.c"
    break;

  case 391: /* WriteSyntax: Syntax  */
#line 6909 "parser-smi.y"
                        {
			    (yyval.typePtr) = (yyvsp[0].typePtr);
			}
#line 9494 "parser-smi.c"
    break;

  case 392: /* AccessPart: MIN_ACCESS Access  */
#line 6915 "parser-smi.y"
                        {
                            if (thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "MIN-ACCESS");
			    (yyval.access) = (yyvsp[0].access);
			}
#line 9504 "parser-smi.c"
    break;

  case 393: /* AccessPart: PIB_MIN_ACCESS Access  */
#line 6921 "parser-smi.y"
                        {
                            if (thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SPPI_CONSTRUCT_IN_MIB, "PIB-MIN-ACCESS");
                            if ((yyvsp[0].access) == SMI_ACCESS_REPORT_ONLY)
                                smiPrintError(thisParserPtr, ERR_REPORT_ONLY_IN_PIB_MIN_ACCESS);
                            (yyval.access) = (yyvsp[0].access);
                        }
#line 9516 "parser-smi.c"
    break;

  case 394: /* AccessPart: %empty  */
#line 6929 "parser-smi.y"
                        {
			    (yyval.access) = SMI_ACCESS_UNKNOWN;
			}
#line 9524 "parser-smi.c"
    break;

  case 395: /* $@58: %empty  */
#line 6935 "parser-smi.y"
                        {
			    thisParserPtr->firstStatementLine = thisParserPtr->line;
			    thisParserPtr->currentDecl = SMI_DECL_AGENTCAPABILITIES;
			    
			    checkNameLen(thisParserPtr, (yyvsp[0].id),
					 ERR_OIDNAME_32, ERR_OIDNAME_64);
			    smiCheckObjectName(thisParserPtr,
					       thisModulePtr, (yyvsp[0].id));
			}
#line 9538 "parser-smi.c"
    break;

  case 396: /* $@59: %empty  */
#line 6945 "parser-smi.y"
                        {
			    Import *importPtr;
                            if (thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "AGENT-CAAPABILITIES");
			    
			    if (thisModulePtr->export.language == SMI_LANGUAGE_UNKNOWN)
				thisModulePtr->export.language = SMI_LANGUAGE_SMIV2;

			    importPtr = findImportByName("AGENT-CAPABILITIES",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				smiPrintError(thisParserPtr,
					      ERR_MACRO_NOT_IMPORTED,
					      "AGENT-CAPABILITIES",
					      "SNMPv2-CONF");
			    }
			}
#line 9562 "parser-smi.c"
    break;

  case 397: /* $@60: %empty  */
#line 6967 "parser-smi.y"
                        {
			    checkDescr(thisParserPtr, (yyvsp[0].text));
			}
#line 9570 "parser-smi.c"
    break;

  case 398: /* agentCapabilitiesClause: LOWERCASE_IDENTIFIER $@58 AGENT_CAPABILITIES $@59 PRODUCT_RELEASE Text STATUS Status_Capabilities DESCRIPTION Text $@60 ReferPart ModulePart_Capabilities COLON_COLON_EQUAL '{' objectIdentifier '}'  */
#line 6973 "parser-smi.y"
                        {
			    Object *objectPtr;
			    
			    objectPtr = (yyvsp[-1].objectPtr);
			    
			    smiCheckObjectReuse(thisParserPtr, (yyvsp[-16].id), &objectPtr);

			    setObjectName(objectPtr, (yyvsp[-16].id), thisParserPtr);
			    setObjectDecl(objectPtr,
					  SMI_DECL_AGENTCAPABILITIES);
			    setObjectLine(objectPtr, thisParserPtr->firstStatementLine,
					  thisParserPtr);
			    addObjectFlags(objectPtr, FLAG_REGISTERED);
			    deleteObjectFlags(objectPtr, FLAG_INCOMPLETE);
			    setObjectStatus(objectPtr, (yyvsp[-9].status));
			    setObjectDescription(objectPtr, (yyvsp[-7].text), thisParserPtr);
			    if ((yyvsp[-5].text)) {
				setObjectReference(objectPtr, (yyvsp[-5].text), thisParserPtr);
			    }
			    setObjectAccess(objectPtr,
					    SMI_ACCESS_NOT_ACCESSIBLE);
				/*
				 * TODO: PRODUCT_RELEASE Text
				 * TODO: ModulePart_Capabilities
				 */
			    (yyval.err) = 0;
			}
#line 9602 "parser-smi.c"
    break;

  case 399: /* ModulePart_Capabilities: Modules_Capabilities  */
#line 7003 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 9608 "parser-smi.c"
    break;

  case 400: /* ModulePart_Capabilities: %empty  */
#line 7005 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 9614 "parser-smi.c"
    break;

  case 401: /* Modules_Capabilities: Module_Capabilities  */
#line 7009 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 9620 "parser-smi.c"
    break;

  case 402: /* Modules_Capabilities: Modules_Capabilities Module_Capabilities  */
#line 7011 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 9626 "parser-smi.c"
    break;

  case 403: /* $@61: %empty  */
#line 7015 "parser-smi.y"
                        {
			    /*
			     * Remember the module. SMIv2 is broken by
			     * design to allow subsequent clauses to
			     * refer identifiers that are not
			     * imported.  Although, SMIv2 does not
			     * require, we will fake it by inserting
			     * appropriate imports.
			     */
			    if ((yyvsp[0].modulePtr) == thisModulePtr)
				thisParserPtr->capabilitiesModulePtr = NULL;
			    else
				thisParserPtr->capabilitiesModulePtr = (yyvsp[0].modulePtr);
			}
#line 9645 "parser-smi.c"
    break;

  case 404: /* Module_Capabilities: SUPPORTS ModuleName_Capabilities $@61 INCLUDES '{' CapabilitiesGroups '}' VariationPart  */
#line 7031 "parser-smi.y"
                        {
			    if (thisParserPtr->capabilitiesModulePtr) {
				checkImports(thisParserPtr->capabilitiesModulePtr,
					     thisParserPtr);
				thisParserPtr->capabilitiesModulePtr = NULL;
			    }
			    (yyval.err) = 0;
			}
#line 9658 "parser-smi.c"
    break;

  case 405: /* CapabilitiesGroups: CapabilitiesGroup  */
#line 7042 "parser-smi.y"
                        {
#if 0
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].listPtr);
			    (yyval.listPtr)->nextPtr = NULL;
#else
			    (yyval.listPtr) = NULL;
#endif
			}
#line 9672 "parser-smi.c"
    break;

  case 406: /* CapabilitiesGroups: CapabilitiesGroups ',' CapabilitiesGroup  */
#line 7052 "parser-smi.y"
                        {
#if 0
			    List *p, *pp;
			    
			    p = smiMalloc(sizeof(List));
			    p->ptr = (yyvsp[0].listPtr);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-2].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    (yyval.listPtr) = (yyvsp[-2].listPtr);
#else
			    (yyval.listPtr) = NULL;
#endif
			}
#line 9691 "parser-smi.c"
    break;

  case 407: /* CapabilitiesGroup: objectIdentifier  */
#line 7069 "parser-smi.y"
                        {
			    (yyval.listPtr) = NULL;
			}
#line 9699 "parser-smi.c"
    break;

  case 408: /* ModuleName_Capabilities: UPPERCASE_IDENTIFIER objectIdentifier  */
#line 7075 "parser-smi.y"
                        {
			    (yyval.modulePtr) = findModuleByName((yyvsp[-1].id));
			    /* TODO: handle objectIdentifier */
			    if (!(yyval.modulePtr)) {
				(yyval.modulePtr) = loadModule((yyvsp[-1].id), thisParserPtr);
			    }
			    smiFree((yyvsp[-1].id));
			}
#line 9712 "parser-smi.c"
    break;

  case 409: /* ModuleName_Capabilities: UPPERCASE_IDENTIFIER  */
#line 7084 "parser-smi.y"
                        {
			    (yyval.modulePtr) = findModuleByName((yyvsp[0].id));
			    if (!(yyval.modulePtr)) {
				(yyval.modulePtr) = loadModule((yyvsp[0].id), thisParserPtr);
			    }
			    smiFree((yyvsp[0].id));
			}
#line 9724 "parser-smi.c"
    break;

  case 410: /* VariationPart: Variations  */
#line 7094 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 9730 "parser-smi.c"
    break;

  case 411: /* VariationPart: %empty  */
#line 7096 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 9736 "parser-smi.c"
    break;

  case 412: /* Variations: Variation  */
#line 7100 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 9742 "parser-smi.c"
    break;

  case 413: /* Variations: Variations Variation  */
#line 7102 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 9748 "parser-smi.c"
    break;

  case 414: /* $@62: %empty  */
#line 7106 "parser-smi.y"
                        {
			    if ((yyvsp[0].objectPtr)) {
				variationkind = (yyvsp[0].objectPtr)->export.nodekind;
			    } else {
				variationkind = SMI_NODEKIND_UNKNOWN;
			    }
			}
#line 9760 "parser-smi.c"
    break;

  case 415: /* $@63: %empty  */
#line 7114 "parser-smi.y"
                        {
			    if (variationkind == SMI_NODEKIND_NOTIFICATION) {
				smiPrintError(thisParserPtr,
				      ERR_NOTIFICATION_VARIATION_SYNTAX);
			    }
			}
#line 9771 "parser-smi.c"
    break;

  case 416: /* $@64: %empty  */
#line 7121 "parser-smi.y"
                        {
			    if (variationkind == SMI_NODEKIND_NOTIFICATION) {
				smiPrintError(thisParserPtr,
				      ERR_NOTIFICATION_VARIATION_WRITESYNTAX);
			    }
			}
#line 9782 "parser-smi.c"
    break;

  case 417: /* $@65: %empty  */
#line 7129 "parser-smi.y"
                        {
			    if (variationkind == SMI_NODEKIND_NOTIFICATION) {
				smiPrintError(thisParserPtr,
				      ERR_NOTIFICATION_VARIATION_CREATION);
			    }
			}
#line 9793 "parser-smi.c"
    break;

  case 418: /* $@66: %empty  */
#line 7136 "parser-smi.y"
                        {
			    if (variationkind == SMI_NODEKIND_NOTIFICATION) {
				smiPrintError(thisParserPtr,
				      ERR_NOTIFICATION_VARIATION_DEFVAL);
			    } else if ((yyvsp[0].valuePtr)) {
				adjustDefval(thisParserPtr,
					     (yyvsp[0].valuePtr), (yyvsp[-9].objectPtr)->typePtr,
					     thisParserPtr->line);
				smiCheckValueType(thisParserPtr,
						  (yyvsp[0].valuePtr), (yyvsp[-9].objectPtr)->typePtr,
						  thisParserPtr->line);
			    }
			}
#line 9811 "parser-smi.c"
    break;

  case 419: /* Variation: VARIATION ObjectName $@62 SyntaxPart $@63 WriteSyntaxPart $@64 VariationAccessPart CreationPart $@65 DefValPart $@66 DESCRIPTION Text  */
#line 7150 "parser-smi.y"
                        {
			    thisParserPtr->flags &= ~FLAG_CREATABLE;
			    (yyval.err) = 0;
			    variationkind = SMI_NODEKIND_UNKNOWN;

			    checkDescr(thisParserPtr, (yyvsp[0].text));
			}
#line 9823 "parser-smi.c"
    break;

  case 420: /* VariationAccessPart: ACCESS VariationAccess  */
#line 7160 "parser-smi.y"
                        { (yyval.access) = (yyvsp[0].access); }
#line 9829 "parser-smi.c"
    break;

  case 421: /* VariationAccessPart: %empty  */
#line 7162 "parser-smi.y"
                        { (yyval.access) = 0; }
#line 9835 "parser-smi.c"
    break;

  case 422: /* VariationAccess: LOWERCASE_IDENTIFIER  */
#line 7166 "parser-smi.y"
                        {
			    if (!strcmp((yyvsp[0].id), "not-implemented")) {
				(yyval.access) = SMI_ACCESS_NOT_IMPLEMENTED;
			    } else if (!strcmp((yyvsp[0].id), "accessible-for-notify")) {
				if (variationkind ==
				    SMI_NODEKIND_NOTIFICATION) {
				    smiPrintError(thisParserPtr,
				     ERR_INVALID_NOTIFICATION_VARIATION_ACCESS,
					       (yyvsp[0].id));
				    (yyval.access) = SMI_ACCESS_UNKNOWN;
				} else {
				    (yyval.access) = SMI_ACCESS_NOTIFY;
				}
			    } else if (!strcmp((yyvsp[0].id), "read-only")) {
				if (variationkind ==
				    SMI_NODEKIND_NOTIFICATION) {
				    smiPrintError(thisParserPtr,
				     ERR_INVALID_NOTIFICATION_VARIATION_ACCESS,
					       (yyvsp[0].id));
				    (yyval.access) = SMI_ACCESS_UNKNOWN;
				} else {
				    (yyval.access) = SMI_ACCESS_READ_ONLY;
				}
			    } else if (!strcmp((yyvsp[0].id), "read-write")) {
				if (variationkind ==
				    SMI_NODEKIND_NOTIFICATION) {
				    smiPrintError(thisParserPtr,
				     ERR_INVALID_NOTIFICATION_VARIATION_ACCESS,
					       (yyvsp[0].id));
				    (yyval.access) = SMI_ACCESS_UNKNOWN;
				} else {
				    (yyval.access) = SMI_ACCESS_READ_WRITE;
				}
			    } else if (!strcmp((yyvsp[0].id), "read-create")) {
				if (variationkind ==
				    SMI_NODEKIND_NOTIFICATION) {
				    smiPrintError(thisParserPtr,
				     ERR_INVALID_NOTIFICATION_VARIATION_ACCESS,
					       (yyvsp[0].id));
				    (yyval.access) = SMI_ACCESS_UNKNOWN;
				} else {
				    (yyval.access) = SMI_ACCESS_READ_WRITE;
				}
			    } else if (!strcmp((yyvsp[0].id), "write-only")) {
				if (variationkind ==
				    SMI_NODEKIND_NOTIFICATION) {
				    smiPrintError(thisParserPtr,
				     ERR_INVALID_NOTIFICATION_VARIATION_ACCESS,
					       (yyvsp[0].id));
				    (yyval.access) = SMI_ACCESS_UNKNOWN;
				} else {
				    (yyval.access) = SMI_ACCESS_READ_WRITE; /* TODO */
				    smiPrintError(thisParserPtr,
					       ERR_SMIV2_WRITE_ONLY);
				}
			    } else {
				smiPrintError(thisParserPtr,
					      ERR_INVALID_VARIATION_ACCESS,
					      (yyvsp[0].id));
				(yyval.access) = SMI_ACCESS_UNKNOWN;
			    }
			}
#line 9902 "parser-smi.c"
    break;

  case 423: /* CreationPart: CREATION_REQUIRES '{' Cells '}'  */
#line 7231 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 9908 "parser-smi.c"
    break;

  case 424: /* CreationPart: %empty  */
#line 7233 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 9914 "parser-smi.c"
    break;

  case 425: /* Cells: Cell  */
#line 7237 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 9920 "parser-smi.c"
    break;

  case 426: /* Cells: Cells ',' Cell  */
#line 7239 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 9926 "parser-smi.c"
    break;

  case 427: /* Cell: ObjectName  */
#line 7243 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 9932 "parser-smi.c"
    break;


#line 9936 "parser-smi.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (parserPtr, YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, parserPtr);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, parserPtr);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (parserPtr, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, parserPtr);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, parserPtr);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 7246 "parser-smi.y"


#endif
